import { ITEM_STATUS, RULE_TYPE } from "@const/aclResponse.constants";
import { BasicResponseDTO } from "./basicResponse.dto";
import { IMenuItem } from "./menuResponse.dto";
export type RuleType = (typeof RULE_TYPE)[keyof typeof RULE_TYPE];
export type ItemStatus = (typeof ITEM_STATUS)[keyof typeof ITEM_STATUS];
export declare class AclRule {
    rule_id: string;
    type: RuleType;
    value0?: string;
    value1?: string;
    value2?: string;
    constructor(rule_id: string, type: RuleType, value0?: string, value1?: string, value2?: string);
}
export declare class CreateAclRuleDTO {
    type: RuleType;
    value0?: string;
    value1?: string;
    value2?: string;
}
export interface IAclMenuItem extends IMenuItem {
    status: ItemStatus;
    disabled?: boolean;
    nodeId?: string;
}
export declare abstract class AclMenuItem implements IAclMenuItem {
    title: string;
    url: string;
    status: ItemStatus;
    disabled?: boolean;
    checkable?: boolean;
    key?: string;
    _class?: string;
    hwType?: string;
    subsystem?: string;
    children?: Array<AclMenuItem>;
    itemId?: string;
    isLeaf?: boolean;
    isDefault?: boolean;
    pageType?: string;
    constructor(title: string, path: string, status: ItemStatus, disabled?: boolean);
    getKey(): string;
}
export declare class AclMenuFolder extends AclMenuItem {
    constructor(title: string, path: string, status: ItemStatus, _class?: string, hwType?: string, subsystem?: string, itemId?: string);
}
export declare class AclMenuLink extends AclMenuItem {
    isLeaf: boolean;
    constructor(title: string, path: string, status: ItemStatus, itemId?: string);
}
export interface AclMenuChanges {
    [key: string]: boolean;
}
export declare class AclResponseDTO extends BasicResponseDTO {
    data: Array<AclRule>;
}
export declare class AclMenuChangesResponseDTO extends BasicResponseDTO {
    data: AclMenuChanges;
}
export declare class AclMenuResponseDTO extends BasicResponseDTO {
    data: Array<AclMenuItem>;
}
