"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlertHistoryDTO = exports.AlertHistory = exports.AlertResponseDTO = exports.AlertsResponseDTO = exports.GetAlert = exports.SaveAlert = exports.Alert = exports.AlertBase = exports.AlertGroup = exports.CreateAlertGroupDTO = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
const customGroup_dto_1 = require("./customGroup.dto");
class CreateAlertGroupDTO extends customGroup_dto_1.ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_group_id: { required: false, type: () => String }, class: { required: true, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, custom_group_id: { required: false, type: () => String }, label: { required: true, type: () => String }, alerts: { required: true, type: () => [require("./alerting.dto").SaveAlert] }, disabled: { required: true, type: () => Boolean }, group_id: { required: false, type: () => Number } };
    }
}
exports.CreateAlertGroupDTO = CreateAlertGroupDTO;
class AlertGroup extends customGroup_dto_1.ItemGroupWithLabels {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_group_id: { required: true, type: () => String }, class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, custom_group_id: { required: false, type: () => String }, label: { required: true, type: () => String }, alerts: { required: true, type: () => [require("./alerting.dto").GetAlert] }, disabled: { required: true, type: () => Boolean }, created_by: { required: false, type: () => require("./usersResponse.dto").UserDTO }, group: { required: false, type: () => ({ group_id: { required: true, type: () => Number }, name: { required: true, type: () => String } }) } };
    }
}
exports.AlertGroup = AlertGroup;
class AlertBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { limit: { required: true, type: () => Number }, peak: { required: true, type: () => Number }, repeat: { required: true, type: () => Number }, exclude_start: { required: true, type: () => Number }, exclude_end: { required: true, type: () => Number }, mail_groups: { required: true, type: () => [require("./mailGroup.dto").MailGroup] }, level: { required: false, type: () => String }, integrations: { required: true, type: () => require("./elements/alert.elements").AlertIntegrations } };
    }
}
exports.AlertBase = AlertBase;
class Alert extends AlertBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_group_id: { required: true, type: () => String }, alerting_id: { required: true, type: () => String }, triggered: { required: true, type: () => Number } };
    }
}
exports.Alert = Alert;
class SaveAlert extends Alert {
    static _OPENAPI_METADATA_FACTORY() {
        return { metric: { required: true, type: () => String } };
    }
}
exports.SaveAlert = SaveAlert;
class GetAlert extends Alert {
    static _OPENAPI_METADATA_FACTORY() {
        return { metric: { required: true, type: () => Object } };
    }
}
exports.GetAlert = GetAlert;
class AlertsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./alerting.dto").AlertGroup] } };
    }
}
exports.AlertsResponseDTO = AlertsResponseDTO;
class AlertResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./alerting.dto").Alert } };
    }
}
exports.AlertResponseDTO = AlertResponseDTO;
class AlertHistory {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_history_id: { required: true, type: () => String }, alerting_group_id: { required: true, type: () => String }, alerting_group_label: { required: true, type: () => String }, group_label: { required: false, type: () => String }, group_id: { required: false, type: () => Number }, metric: { required: true, type: () => Object }, limit: { required: true, type: () => Number }, level: { required: true, type: () => String }, targets: { required: true, type: () => [String] }, items: { required: true, type: () => [require("./architecture.dto").Item] }, triggered: { required: true, type: () => String } };
    }
}
exports.AlertHistory = AlertHistory;
class AlertHistoryDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./alerting.dto").AlertHistory] } };
    }
}
exports.AlertHistoryDTO = AlertHistoryDTO;
//# sourceMappingURL=alerting.dto.js.map