"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HSMSateSeverity = exports.MIRROR_COLORS = exports.Severity = void 0;
var Severity;
(function (Severity) {
    Severity["OK"] = "ok";
    Severity["WARNING"] = "warning";
    Severity["ERROR"] = "error";
    Severity["UNKNOWN"] = "unknown";
})(Severity || (exports.Severity = Severity = {}));
exports.MIRROR_COLORS = {
    [Severity.OK]: '#8FD400',
    [Severity.ERROR]: '#e32636',
    [Severity.WARNING]: '#ffa500',
    [Severity.UNKNOWN]: '#94c5f9',
};
exports.HSMSateSeverity = {
    consistent_copying: Severity.OK,
    consistent_synchronized: Severity.OK,
    inconsistent_copying: Severity.WARNING,
    consistent_disconnected: Severity.ERROR,
    inconsistent_disconnected: Severity.ERROR,
    consistent_stopped: Severity.ERROR,
    inconsistent_stopped: Severity.ERROR,
    idling_disconnected: Severity.ERROR,
    idling: Severity.ERROR,
    "Copy Pending": Severity.OK,
    "Target Copy Pending": Severity.OK,
    "Full Duplex": Severity.OK,
    "Target Full Duplex": Severity.OK,
    "Suspended": Severity.WARNING,
    "Target Suspended": Severity.WARNING,
    "Validation Required": Severity.WARNING,
    "Invalid State": Severity.ERROR,
    "Volume Inaccessible": Severity.ERROR,
    "PAIR": Severity.OK,
    "PSUS": Severity.ERROR,
    "PSUE": Severity.ERROR,
    "PausedDisconnected": Severity.ERROR,
    "ResumingConnected": Severity.OK,
    "ResumingRRSync": Severity.OK,
    "ResumingLocalSync": Severity.OK,
    "ResumingDataTransfer": Severity.OK,
    "Active": Severity.OK,
    "Idle": Severity.OK,
    "Paused Cluster Full": Severity.ERROR,
    "PausedExceededMaxSnapshotCount": Severity.ERROR,
    "PausedManual": Severity.WARNING,
    "PausedManualRemote": Severity.WARNING,
    "PausedQoS": Severity.WARNING,
    "PausedSlowLink": Severity.WARNING,
    "PausedVolumeSizeMismatch": Severity.WARNING,
    "PausedXCopy": Severity.WARNING,
    "StoppedMisconfigured": Severity.ERROR,
    "PausedMisconfigured": Severity.WARNING,
    "New": Severity.OK,
    "New-SyncFromSnap": Severity.OK,
    "New-PreSynced": Severity.OK,
    "Syncing": Severity.OK,
    "Synced": Severity.OK,
    "NotSynced": Severity.ERROR,
    "Failsafe": Severity.ERROR,
    "Stale": Severity.WARNING,
    "Logging": Severity.ERROR,
    "Starting": Severity.OK,
    "Started": Severity.OK,
    "Stopped": Severity.ERROR,
    "Stopped(Grow_Failed)": Severity.ERROR,
    "Backup": Severity.OK,
    "Restart": Severity.OK
};
//# sourceMappingURL=healthStatusMirror.constants.js.map