import { BasicResponseDTO } from "./basicResponse.dto";
import { ItemGroup } from "./customGroup.dto";
import { AlertIntegrations } from "./elements/alert.elements";
export declare class DeviceGroupHwAlertingDTO {
    device_group_id: string;
    label: string;
    class: string;
    hw_type: string;
    enabled: boolean;
    user_id: number;
    mail_groups: number[];
    integrations: AlertIntegrations;
}
export declare class UpdateDeviceGroupHwAlertingBody extends DeviceGroupHwAlertingDTO {
    regex?: string[];
    items?: string[];
}
interface MailGroups {
    mail_group_id: number;
    label: string;
    mails: string[];
}
export interface CreateDeviceGroupHwAlertingBody {
    class: string;
    hw_type: string;
    label: string;
    enabled: boolean;
    regex?: string[];
    items?: string[] | null;
    mail_groups: number[];
    integrations: AlertIntegrations;
}
export interface DeviceGroupHwAlerting {
    device_group_id: string;
    label: string;
    class: string;
    hw_type: string;
    enabled: boolean;
    user_id: number;
    mail_groups: number[];
}
export declare class DeviceGroup {
    device_group_id: string;
    label: string;
    class: string;
    hw_type: string;
    subsystem?: string;
    regex?: string[];
    items?: DeviceGroupObjectItems[];
    enabled: boolean;
    mailGroups: MailGroups[];
    integrations: AlertIntegrations;
}
interface MailGroups {
    mail_group_id: number;
    label: string;
    mails: string[];
}
export declare class DeviceGroupsResponseDTO extends BasicResponseDTO {
    data?: DeviceGroup[];
}
export declare class DeviceGroupResponseDTO extends BasicResponseDTO {
    data?: DeviceGroup;
}
export declare class DeviceGroupSave extends ItemGroup {
    enabled: boolean;
    mailGroupIds: number[];
}
export interface DeviceGroupObjectItems {
    item_id: string;
    label: string;
}
export interface DeviceGroupObjectItemsDTO extends BasicResponseDTO {
    data?: DeviceGroupObjectItems[];
}
export {};
