"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExportMetricsRequestDTO = exports.ExportTopRequestDTO = exports.ExportValuesRequestDTO = exports.ExportConfigurationRequestDTO = exports.ExportCapacityRequestDTO = exports.ExportMappingRequestDTO = exports.ExportTimeseriesRequestDTO = exports.PublicExportCapacityRequestDTO = exports.PublicExportConfigurationRequestDTO = exports.PublicExportMappingRequestDTO = exports.PublicExportTimeseriesRequestDTO = exports.ExportBase = exports.ExporterDetailResponseDTO = exports.ExporterHistoryResponseDTO = exports.Recurrence = exports.Export = exports.SaveExport = exports.JsonResponse = exports.ConfigurationFilter = exports.TypeFilter = exports.MetricFilter = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
const customGroup_dto_1 = require("./customGroup.dto");
class MetricFilter {
    static _OPENAPI_METADATA_FACTORY() {
        return { operator: { required: true, type: () => Object }, value: { required: true, type: () => Number }, metric: { required: false, type: () => String } };
    }
}
exports.MetricFilter = MetricFilter;
class TypeFilter {
    static _OPENAPI_METADATA_FACTORY() {
        return { hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String } };
    }
}
exports.TypeFilter = TypeFilter;
class ConfigurationFilter {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.ConfigurationFilter = ConfigurationFilter;
class JsonResponse {
    static _OPENAPI_METADATA_FACTORY() {
        return { metadata: { required: true, type: () => ({ total: { required: true, type: () => Number }, interval: { required: true, type: () => Number } }) }, items: { required: true, type: () => [Object] } };
    }
}
exports.JsonResponse = JsonResponse;
class SaveExport extends customGroup_dto_1.ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, custom_group_id: { required: false, type: () => String }, label: { required: true, type: () => String }, format: { required: true, type: () => Object }, type: { required: true, type: () => Object }, data: { required: false, type: () => Object }, recurrence: { required: false, type: () => require("./exporter.dto").Recurrence } };
    }
}
exports.SaveExport = SaveExport;
class Export extends customGroup_dto_1.ItemGroupWithLabels {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, custom_group_id: { required: false, type: () => String }, export_id: { required: true, type: () => String }, last_run: { required: true, type: () => String }, created: { required: true, type: () => String }, label: { required: true, type: () => String }, format: { required: true, type: () => Object }, type: { required: true, type: () => Object }, data: { required: false, type: () => Object }, recurrence: { required: false, type: () => require("./exporter.dto").Recurrence } };
    }
}
exports.Export = Export;
class Recurrence {
    static _OPENAPI_METADATA_FACTORY() {
        return { rrule: { required: false, type: () => String }, freq: { required: true, type: () => Object }, weekday: { required: false, type: () => [String] }, month: { required: false, type: () => [Number] }, setpos: { required: false, type: () => Number }, month_day: { required: false, type: () => Number }, year_day: { required: false, type: () => Number }, week_number: { required: false, type: () => Number }, mail: { required: false, type: () => String }, file: { required: false, type: () => Boolean } };
    }
}
exports.Recurrence = Recurrence;
class ExporterHistoryResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./exporter.dto").Export] } };
    }
}
exports.ExporterHistoryResponseDTO = ExporterHistoryResponseDTO;
class ExporterDetailResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => Object } };
    }
}
exports.ExporterDetailResponseDTO = ExporterDetailResponseDTO;
class ExportBase extends customGroup_dto_1.ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { class: { required: false, type: () => String }, hw_type: { required: false, type: () => String }, subsystem: { required: false, type: () => String }, custom_group_id: { required: false, type: () => String }, uuids: { required: false, type: () => [String] } };
    }
}
exports.ExportBase = ExportBase;
class PublicExportTimeseriesRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { start: { required: true, type: () => Number }, end: { required: true, type: () => Number }, metric: { required: true, type: () => [String] }, format: { required: false, type: () => Object } };
    }
}
exports.PublicExportTimeseriesRequestDTO = PublicExportTimeseriesRequestDTO;
class PublicExportMappingRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { format: { required: false, type: () => Object } };
    }
}
exports.PublicExportMappingRequestDTO = PublicExportMappingRequestDTO;
class PublicExportConfigurationRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { properties: { required: true, type: () => [String] }, format: { required: false, type: () => Object } };
    }
}
exports.PublicExportConfigurationRequestDTO = PublicExportConfigurationRequestDTO;
class PublicExportCapacityRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { format: { required: false, type: () => Object } };
    }
}
exports.PublicExportCapacityRequestDTO = PublicExportCapacityRequestDTO;
class ExportTimeseriesRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { interval: { required: false, type: () => Boolean }, start: { required: false, type: () => Number }, end: { required: false, type: () => Number }, metric: { required: false, type: () => [String] }, metricFilter: { required: false, type: () => require("./exporter.dto").MetricFilter }, configuration: { required: false, type: () => require("./exporter.dto").ConfigurationFilter } };
    }
}
exports.ExportTimeseriesRequestDTO = ExportTimeseriesRequestDTO;
class ExportMappingRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.ExportMappingRequestDTO = ExportMappingRequestDTO;
class ExportCapacityRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return {};
    }
}
exports.ExportCapacityRequestDTO = ExportCapacityRequestDTO;
class ExportConfigurationRequestDTO extends ExportBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { properties: { required: false, type: () => [String] } };
    }
}
exports.ExportConfigurationRequestDTO = ExportConfigurationRequestDTO;
class ExportValuesRequestDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { headers: { required: true, type: () => [String] }, values: { required: true, type: () => [[Object]] } };
    }
}
exports.ExportValuesRequestDTO = ExportValuesRequestDTO;
class ExportTopRequestDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { uuids: { required: true, type: () => [String] }, metric: { required: true, type: () => String }, interval: { required: true, type: () => Object } };
    }
}
exports.ExportTopRequestDTO = ExportTopRequestDTO;
class ExportMetricsRequestDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String } };
    }
}
exports.ExportMetricsRequestDTO = ExportMetricsRequestDTO;
//# sourceMappingURL=exporter.dto.js.map