import { BasicResponseDTO } from './basicResponse.dto';
export declare class AdminRoles {
    class?: string[];
    hwType?: string[];
}
export declare class AdminFeatures {
    deviceConfig?: boolean;
    heatmapTiers?: boolean;
}
export declare class GroupDTO {
    name: string;
    description: string;
    user_ids?: number[];
    manages?: AdminRoles;
    ldapGroups?: LdapGroupBase[];
}
export declare class PartialUser {
    user_id: number;
    username: string;
    email: string;
    active: boolean;
}
export declare class Group {
    group_id: number;
    name: string;
    description: string;
    title?: string;
    users?: PartialUser[];
    ldapGroups?: LdapGroupBase[];
}
export declare class LdapGroupBase {
    ldap_id: string;
    ldap_group: string;
}
export declare class UpdateLdapGroupDTO {
    ldap_groups: LdapGroupBase[];
}
export declare class LdapGroup extends LdapGroupBase {
    ldap_label: string;
}
export interface UpdateGroupDTO extends Partial<GroupDTO> {
    group_id: number;
}
export declare class GroupsResponseDTO extends BasicResponseDTO {
    data: Group[];
}
export declare class LdapGroupsResponseDTO extends BasicResponseDTO {
    data: LdapGroup[];
}
export declare class GroupResponseDTO extends BasicResponseDTO {
    data: Group;
}
export interface GroupEditResponseDTO<T> extends BasicResponseDTO {
    data: T;
    message: string;
    statusCode: number;
}
export interface GroupsEditResponseDTO<T> {
    data: GroupEditResponseDTO<T>;
    status: number;
    statusText: string;
    headers: Record<string, string>;
    request?: any;
}
