import { STATUS } from '@const/healthStatus.constants';
import { BasicResponseDTO } from './basicResponse.dto';
export type Status = typeof STATUS[keyof typeof STATUS];
export declare class HealthStatusItem {
    label: string;
    item_id: string;
    status: string;
    updated?: string;
    data: Object;
}
export declare class HealthStatusSubsystem {
    subsystem: string;
    status: string;
    items: HealthStatusItem[];
}
export declare class StatusHostCfgBase {
    class: string;
    hw_type: string;
    label: string;
    status: string;
    item_id: string;
    updatedAt: number;
    note: string;
    hw_type_label: string;
    ignored: boolean;
    ignore_reason: string;
    url: string;
}
export declare class StatusHostCfgExtended {
    class: string;
    hw_type: string;
    label: string;
    status: string;
    data: number;
    connection: number;
    item_id: string;
    updatedAt: number;
    note: string;
    hw_type_label: string;
    ignored: boolean;
    ignore_reason: string;
    url: string;
}
export declare class HealthStatusHostCfg extends StatusHostCfgBase {
    subsystems: HealthStatusSubsystem[];
}
export declare class HealthStatusSeverity {
    status: string;
    count: number;
    devices: StatusHostCfgBase[];
}
export declare class HostcfgStatus {
    name: string;
    count: number;
    devices: StatusHostCfgBase[];
}
export declare class Count {
    bell: number;
    error: number;
    warning: number;
    unknown: number;
    ok: number;
    ignored: number;
    data: number;
    connection: number;
}
export declare class CountDTO extends BasicResponseDTO {
    data: Count;
}
export declare class HealthStatusSeverityDTO extends BasicResponseDTO {
    data: HealthStatusSeverity[];
}
export declare class HealthStatusHwType {
    label: string;
    status: string;
    subsystems: HealthStatusSubsystem[];
}
export declare class HostcfgStatusDTO extends BasicResponseDTO {
    data: HostcfgStatus;
}
export declare class HealthStatusHostsCfgDTO extends BasicResponseDTO {
    data: HealthStatusHostCfg[];
}
export declare class HealthStatusHostCfgDTO extends BasicResponseDTO {
    data: HealthStatusHostCfg;
}
export declare class HealthStatusHwTypesDTO extends BasicResponseDTO {
    data: HealthStatusHwType[];
}
export declare class HealthStatusHwTypeDTO extends BasicResponseDTO {
    data: HealthStatusHwType;
}
export declare class HealthStatusItemDTO extends BasicResponseDTO {
    data: HealthStatusItem;
}
