"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TierResponseDTO = exports.TiersResponseDTO = exports.DevicesResponseDTO = exports.HeatmapTierItem = exports.Tier = exports.TierBase = exports.ReadWriteIntervals = exports.Interval = exports.Pool = exports.Device = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
class Device {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, pools: { required: true, type: () => [require("./heatmap.dto").Pool] } };
    }
}
exports.Device = Device;
class Pool {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, item_id: { required: true, type: () => String }, heatmap_tier_id: { required: false, type: () => String } };
    }
}
exports.Pool = Pool;
class Interval {
    static _OPENAPI_METADATA_FACTORY() {
        return { color: { required: true, type: () => String }, limit: { required: true, type: () => Number } };
    }
}
exports.Interval = Interval;
class ReadWriteIntervals {
    static _OPENAPI_METADATA_FACTORY() {
        return { read_intervals: { required: true, type: () => [require("./heatmap.dto").Interval] }, write_intervals: { required: true, type: () => [require("./heatmap.dto").Interval] } };
    }
}
exports.ReadWriteIntervals = ReadWriteIntervals;
class TierBase extends ReadWriteIntervals {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, limit_pool: { required: true, type: () => Number }, limit_volume: { required: true, type: () => Number } };
    }
}
exports.TierBase = TierBase;
class Tier extends TierBase {
    static _OPENAPI_METADATA_FACTORY() {
        return { heatmap_tier_id: { required: true, type: () => String } };
    }
}
exports.Tier = Tier;
class HeatmapTierItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, heatmap_tier_id: { required: true, type: () => String } };
    }
}
exports.HeatmapTierItem = HeatmapTierItem;
class DevicesResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./heatmap.dto").Device] } };
    }
}
exports.DevicesResponseDTO = DevicesResponseDTO;
class TiersResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./heatmap.dto").Tier] } };
    }
}
exports.TiersResponseDTO = TiersResponseDTO;
class TierResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./heatmap.dto").Tier } };
    }
}
exports.TierResponseDTO = TierResponseDTO;
//# sourceMappingURL=heatmap.dto.js.map