"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractDBDescription = exports.AbstractOldDBProps = exports.AbstractDBProps = exports.TwoNodeRestDevicePropsOld = exports.TwoNodeRestDeviceDescription = exports.TwoNodeRestDeviceProps = exports.TokenRestDeviceDescription = exports.TokenRestDevicePropsOld = exports.TokenRestDeviceProps = exports.OldUniCliDeviceProps = exports.UniCliDeviceDescription = exports.UniCliDeviceProps = exports.OldSnmpDeviceProps = exports.OldSshDeviceProps = exports.OldApiAuthDeviceProps = exports.OldRestDeviceProps = exports.OldVmProps = exports.OldDeviceProps = exports.SnmpStorageDeviceDescription = exports.SnmpStorageDeviceProps = exports.SnmpNetworkDeviceDescription = exports.SnmpNetworkDeviceProps = exports.SnmpDeviceDescription = exports.SnmpDeviceProps = exports.ExtensiveSshDeviceDescription = exports.ExtensiveSshDeviceProps = exports.SshDeviceDescription = exports.SshDeviceProps = exports.ProtoRestDeviceDescription = exports.ProtoRestDeviceProps = exports.RestDeviceDescription = exports.RestDeviceProps = exports.VMDescription = exports.VMProps = exports.AuthBaseDescription = exports.AuthBaseProps = exports.ProtoPortBaseDeviceDescription = exports.ProtoPortBaseDevice = exports.PortBaseDeviceDescription = exports.PortBaseDeviceProps = exports.BaseDeviceDescription = exports.BaseDeviceProps = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const hostcfgData_types_1 = require("./hostcfgData.types");
class BaseDeviceProps {
    constructor() {
        this.vendor = undefined;
        this.device = undefined;
        this.created = Date.now();
        this.updated = null;
        this.description = undefined;
        this.managementUrl = undefined;
        this.disabled = false;
        this.radio = undefined;
        this.sourceAddress = undefined;
        this.licType = undefined;
        this.type = undefined;
    }
}
exports.BaseDeviceProps = BaseDeviceProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "vendor", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "device", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], BaseDeviceProps.prototype, "created", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], BaseDeviceProps.prototype, "updated", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "description", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "managementUrl", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], BaseDeviceProps.prototype, "disabled", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "radio", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "sourceAddress", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "licType", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], BaseDeviceProps.prototype, "type", void 0);
exports.BaseDeviceDescription = {
    device: {
        required: true,
        type: "string",
        description: undefined
    },
    description: {
        required: false,
        type: "string",
        description: "Description of your device configuration"
    },
    managmentUrl: {
        required: false,
        type: "string",
        description: "Your device configuration managment URL"
    }
};
class PortBaseDeviceProps extends BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.host = undefined;
        this.port = null;
    }
}
exports.PortBaseDeviceProps = PortBaseDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], PortBaseDeviceProps.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", Number)
], PortBaseDeviceProps.prototype, "port", void 0);
exports.PortBaseDeviceDescription = {
    host: {
        required: true,
        type: "string",
        description: undefined
    },
    port: {
        required: true,
        type: "number",
        description: undefined
    },
    ...exports.BaseDeviceDescription
};
class ProtoPortBaseDevice extends PortBaseDeviceProps {
    constructor() {
        super(...arguments);
        this.protocol = hostcfgData_types_1.PROTO.HTTPS;
    }
}
exports.ProtoPortBaseDevice = ProtoPortBaseDevice;
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.PROTO),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.PROTO.HTTPS),
    __metadata("design:type", String)
], ProtoPortBaseDevice.prototype, "protocol", void 0);
exports.ProtoPortBaseDeviceDescription = {
    protocol: {
        required: true,
        type: "string",
        description: undefined
    },
    ...exports.PortBaseDeviceDescription
};
class AuthBaseProps extends ProtoPortBaseDevice {
    constructor() {
        super(...arguments);
        this.username = undefined;
        this.password = undefined;
    }
}
exports.AuthBaseProps = AuthBaseProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AuthBaseProps.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AuthBaseProps.prototype, "password", void 0);
exports.AuthBaseDescription = {
    ...exports.ProtoPortBaseDeviceDescription,
    username: {
        required: true,
        type: "string",
    },
    password: {
        required: true,
        type: "string",
    }
};
class VMProps extends AuthBaseProps {
    constructor() {
        super(...arguments);
        this.backup_host = undefined;
        this.domain = undefined;
    }
}
exports.VMProps = VMProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VMProps.prototype, "backup_host", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VMProps.prototype, "domain", void 0);
exports.VMDescription = {
    ...exports.AuthBaseDescription,
    backup_host: {
        required: false,
        type: "string",
    },
    domain: {
        required: false,
        type: "string",
    }
};
class RestDeviceProps extends BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.apiHost = undefined;
        this.apiPort = null;
        this.apiUsername = undefined;
        this.apiPassword = undefined;
    }
}
exports.RestDeviceProps = RestDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], RestDeviceProps.prototype, "apiHost", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", Number)
], RestDeviceProps.prototype, "apiPort", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], RestDeviceProps.prototype, "apiUsername", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], RestDeviceProps.prototype, "apiPassword", void 0);
exports.RestDeviceDescription = {
    apiHost: {
        required: true,
        type: "string",
    },
    apiPort: {
        required: true,
        type: "number",
    },
    apiUsername: {
        required: true,
        type: "string",
    },
    apiPassword: {
        required: true,
        type: "string",
    },
    ...exports.BaseDeviceDescription
};
class ProtoRestDeviceProps extends RestDeviceProps {
    constructor() {
        super(...arguments);
        this.proto = hostcfgData_types_1.PROTO.HTTPS;
    }
}
exports.ProtoRestDeviceProps = ProtoRestDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.PROTO.HTTPS),
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.PROTO),
    __metadata("design:type", String)
], ProtoRestDeviceProps.prototype, "proto", void 0);
exports.ProtoRestDeviceDescription = {
    proto: {
        required: false,
        default: "https",
        type: "string",
        possibleValues: Object.keys(hostcfgData_types_1.PROTO).map(k => hostcfgData_types_1.PROTO[k])
    },
    ...exports.RestDeviceDescription
};
class SshDeviceProps extends BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.sshHost = undefined;
        this.sshPort = 22;
        this.sshUsername = undefined;
    }
}
exports.SshDeviceProps = SshDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], SshDeviceProps.prototype, "sshHost", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)(22),
    __metadata("design:type", Number)
], SshDeviceProps.prototype, "sshPort", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], SshDeviceProps.prototype, "sshUsername", void 0);
exports.SshDeviceDescription = {
    sshHost: {
        required: true,
        type: "string",
        description: undefined
    },
    sshPort: {
        required: true,
        description: undefined,
        type: "number",
        default: 22
    },
    sshUsername: {
        required: true,
        type: "string",
        description: undefined
    },
    ...exports.BaseDeviceDescription
};
class ExtensiveSshDeviceProps extends SshDeviceProps {
    constructor() {
        super(...arguments);
        this.isKeyFile = false;
        this.sshPassword = undefined;
        this.sshKeyFile = undefined;
    }
}
exports.ExtensiveSshDeviceProps = ExtensiveSshDeviceProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], ExtensiveSshDeviceProps.prototype, "isKeyFile", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], ExtensiveSshDeviceProps.prototype, "sshPassword", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], ExtensiveSshDeviceProps.prototype, "sshKeyFile", void 0);
exports.ExtensiveSshDeviceDescription = {
    sshPassword: {
        required: true,
        type: "string",
        description: undefined
    },
    ...exports.SshDeviceDescription
};
class SnmpDeviceProps extends BaseDeviceProps {
    constructor() {
        super(...arguments);
        this.snmpHost = undefined;
        this.snmpPort = 161;
        this.snmpVersion = hostcfgData_types_1.SnmpVersion.SNMPv2c;
        this.snmpCommunity = 'public';
        this.snmpSecLevel = hostcfgData_types_1.SnmpLevel.NOAUTH_NOPRIV;
        this.snmpPrivProtocol = hostcfgData_types_1.SnmpPrivProto.AES;
        this.snmpAuthProtocol = hostcfgData_types_1.SnmpAuthProto.SHA;
    }
}
exports.SnmpDeviceProps = SnmpDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpHost", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", Object)
], SnmpDeviceProps.prototype, "snmpPort", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpVersion),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpVersion.SNMPv2c),
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpVersion", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)("public"),
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpCommunity", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpSecUser", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpLevel),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpLevel.NOAUTH_NOPRIV),
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpSecLevel", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpPrivProto),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpPrivProto.AES),
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpPrivProtocol", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpAuthProto),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpAuthProto.SHA),
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpAuthProtocol", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpPrivPassword", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], SnmpDeviceProps.prototype, "snmpAuthPassword", void 0);
exports.SnmpDeviceDescription = {
    snmpHost: {
        required: true,
        type: "string",
    },
    snmpPort: {
        default: 161,
        type: "number",
        required: true
    },
    snmpVersion: {
        required: true,
        type: "string",
        possibleValues: Object.keys(hostcfgData_types_1.SnmpVersion).map(key => hostcfgData_types_1.SnmpVersion[key])
    },
    snmpCommunity: {
        default: "public",
        type: "string",
        required: true
    },
    snmpSecUser: {
        required: true,
        type: "string",
    },
    snmpSecLevel: {
        required: false,
        type: "string",
        possibleValues: Object.keys(hostcfgData_types_1.SnmpLevel).map(key => hostcfgData_types_1.SnmpLevel[key]),
        description: "Required if if selected version of snmp is v3"
    },
    snmpPrivProtocol: {
        required: false,
        type: "string",
        possibleValues: Object.keys(hostcfgData_types_1.SnmpPrivProto).map(key => hostcfgData_types_1.SnmpPrivProto[key]),
        description: "Required based on your selected security level."
    },
    snmpAuthProtocol: {
        required: false,
        type: "string",
        possibleValues: Object.keys(hostcfgData_types_1.SnmpAuthProto).map(key => hostcfgData_types_1.SnmpAuthProto[key]),
        description: "Required based on your selected security level."
    },
    snmpPrivPassword: {
        required: false,
        type: "string",
    },
    snmpAuthPassword: {
        required: false,
        type: "string",
    },
    ...exports.BaseDeviceDescription
};
class SnmpNetworkDeviceProps extends SnmpDeviceProps {
}
exports.SnmpNetworkDeviceProps = SnmpNetworkDeviceProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Number)
], SnmpNetworkDeviceProps.prototype, "vfId", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], SnmpNetworkDeviceProps.prototype, "fabric_id", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], SnmpNetworkDeviceProps.prototype, "fabric_label", void 0);
exports.SnmpNetworkDeviceDescription = {
    vfId: {
        required: false,
        type: "string",
        description: "Virtual fabric id"
    },
    ...exports.SnmpDeviceDescription
};
class SnmpStorageDeviceProps extends SnmpDeviceProps {
}
exports.SnmpStorageDeviceProps = SnmpStorageDeviceProps;
exports.SnmpStorageDeviceDescription = {
    ...exports.SnmpDeviceDescription,
    snmpContextName: {
        required: false,
        type: "string",
    }
};
class OldDeviceProps {
}
exports.OldDeviceProps = OldDeviceProps;
class OldVmProps extends OldDeviceProps {
}
exports.OldVmProps = OldVmProps;
class OldRestDeviceProps extends OldDeviceProps {
}
exports.OldRestDeviceProps = OldRestDeviceProps;
class OldApiAuthDeviceProps extends OldDeviceProps {
}
exports.OldApiAuthDeviceProps = OldApiAuthDeviceProps;
class OldSshDeviceProps extends OldRestDeviceProps {
}
exports.OldSshDeviceProps = OldSshDeviceProps;
class OldSnmpDeviceProps extends OldDeviceProps {
}
exports.OldSnmpDeviceProps = OldSnmpDeviceProps;
class UniCliDeviceProps extends BaseDeviceProps {
}
exports.UniCliDeviceProps = UniCliDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], UniCliDeviceProps.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], UniCliDeviceProps.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], UniCliDeviceProps.prototype, "password", void 0);
exports.UniCliDeviceDescription = {
    host: {
        required: true,
        type: "string",
    },
    username: {
        required: true,
        type: "string",
    },
    password: {
        required: true,
        type: "string",
    },
    ...exports.BaseDeviceDescription
};
class OldUniCliDeviceProps extends OldDeviceProps {
}
exports.OldUniCliDeviceProps = OldUniCliDeviceProps;
class TokenRestDeviceProps extends RestDeviceProps {
    constructor() {
        super(...arguments);
        this.isToken = false;
    }
}
exports.TokenRestDeviceProps = TokenRestDeviceProps;
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], TokenRestDeviceProps.prototype, "apiToken", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", Boolean)
], TokenRestDeviceProps.prototype, "isToken", void 0);
class TokenRestDevicePropsOld extends OldRestDeviceProps {
}
exports.TokenRestDevicePropsOld = TokenRestDevicePropsOld;
exports.TokenRestDeviceDescription = {
    apiToken: {
        required: false,
        type: "string",
    },
    isToken: {
        required: true,
        type: "boolean",
    },
    password: {
        required: true,
        type: "string",
    },
    ...exports.RestDeviceDescription
};
class TwoNodeRestDeviceProps extends RestDeviceProps {
}
exports.TwoNodeRestDeviceProps = TwoNodeRestDeviceProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], TwoNodeRestDeviceProps.prototype, "node1Host", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], TwoNodeRestDeviceProps.prototype, "node2Host", void 0);
exports.TwoNodeRestDeviceDescription = {
    node1Host: {
        required: true,
        type: "string",
    },
    node2Host: {
        required: false,
        type: "string",
    },
    ...exports.RestDeviceDescription
};
class TwoNodeRestDevicePropsOld extends OldRestDeviceProps {
}
exports.TwoNodeRestDevicePropsOld = TwoNodeRestDevicePropsOld;
class AbstractDBProps extends PortBaseDeviceProps {
    constructor() {
        super(...arguments);
        this.host = undefined;
        this.instance = undefined;
        this.username = undefined;
        this.password = undefined;
        this.use_whitelist = false;
        this.dbs = [undefined];
    }
}
exports.AbstractDBProps = AbstractDBProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractDBProps.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractDBProps.prototype, "instance", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractDBProps.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractDBProps.prototype, "password", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], AbstractDBProps.prototype, "use_whitelist", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.ArrayItemType)(String),
    __metadata("design:type", Array)
], AbstractDBProps.prototype, "dbs", void 0);
class AbstractOldDBProps extends OldDeviceProps {
    constructor() {
        super(...arguments);
        this.host = undefined;
        this.port = null;
        this.instance = undefined;
        this.username = undefined;
        this.password = undefined;
        this.use_whitelist = false;
        this.dbs = [''];
    }
}
exports.AbstractOldDBProps = AbstractOldDBProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractOldDBProps.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", Number)
], AbstractOldDBProps.prototype, "port", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractOldDBProps.prototype, "instance", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractOldDBProps.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], AbstractOldDBProps.prototype, "password", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", Boolean)
], AbstractOldDBProps.prototype, "use_whitelist", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.ArrayItemType)(String),
    __metadata("design:type", Array)
], AbstractOldDBProps.prototype, "dbs", void 0);
exports.AbstractDBDescription = {
    host: {
        required: true,
        type: "string",
    },
    instance: {
        required: true,
        type: "string",
    },
    username: {
        required: true,
        type: "string",
    },
    password: {
        required: true,
        type: "string",
    },
    use_whitelist: {
        required: false,
        type: "boolean",
        description: "Use database whitelist"
    },
    dbs: {
        required: false,
        type: "string[]",
        description: "List of databases to whitelist"
    },
    port: {
        required: true,
        type: "number",
    }
};
//# sourceMappingURL=deviceProps.js.map