import { IHostcfgDataDescription, OldRestDeviceProps, OldSnmpDeviceProps, RestDeviceProps, SnmpStorageDeviceProps } from "./deviceProps";
import { SnmpAuthProto, SnmpLevel, SnmpPrivProto, SnmpVersion } from "./hostcfgData.types";
export declare class Tenant {
    alias: string;
    host: string;
    username: string;
    password: string;
}
export declare class HcpProps extends RestDeviceProps implements SnmpStorageDeviceProps {
    tenants: Array<Tenant>;
    snmpHost: string;
    snmpPort: number;
    snmpVersion: SnmpVersion;
    snmpCommunity: string;
    snmpSecUser: string;
    snmpSecLevel: SnmpLevel;
    snmpPrivProtocol: SnmpPrivProto;
    snmpAuthProtocol: SnmpAuthProto;
    snmpPrivPassword: string;
    snmpAuthPassword: string;
    snmpContextName: string;
}
export declare class HcpOldProps extends OldRestDeviceProps implements OldSnmpDeviceProps {
    "snmp-priv-protocol": string;
    "snmp-auth-pass": string;
    "snmp-version": string;
    "snmp-port": string;
    "snmp-priv-pass": string;
    "snmp-user": string;
    "snmp-host": string;
    "snmp-community": string;
    "fabric": string;
    "snmp-context": string;
    "tenant": Array<Tenant>;
    "snmp-sec-level": string;
}
export declare const HcpDataDescription: IHostcfgDataDescription;
