"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HcpDataDescription = exports.HcpOldProps = exports.HcpProps = exports.Tenant = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const deviceProps_1 = require("./deviceProps");
const hostcfgData_types_1 = require("./hostcfgData.types");
class Tenant {
    constructor() {
        this.alias = undefined;
        this.host = undefined;
        this.username = undefined;
        this.password = undefined;
    }
}
exports.Tenant = Tenant;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Tenant.prototype, "alias", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Tenant.prototype, "host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Tenant.prototype, "username", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], Tenant.prototype, "password", void 0);
class HcpProps extends deviceProps_1.RestDeviceProps {
    constructor() {
        super(...arguments);
        this.tenants = [];
        this.snmpHost = undefined;
        this.snmpPort = 161;
        this.snmpVersion = hostcfgData_types_1.SnmpVersion.SNMPv2c;
        this.snmpCommunity = 'public';
        this.snmpSecUser = undefined;
        this.snmpSecLevel = hostcfgData_types_1.SnmpLevel.NOAUTH_NOPRIV;
        this.snmpPrivProtocol = hostcfgData_types_1.SnmpPrivProto.AES;
        this.snmpAuthProtocol = hostcfgData_types_1.SnmpAuthProto.SHA;
        this.snmpPrivPassword = undefined;
        this.snmpAuthPassword = undefined;
        this.snmpContextName = undefined;
    }
}
exports.HcpProps = HcpProps;
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.ArrayItemType)(Tenant),
    __metadata("design:type", Array)
], HcpProps.prototype, "tenants", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], HcpProps.prototype, "snmpHost", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)(161),
    __metadata("design:type", Number)
], HcpProps.prototype, "snmpPort", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpVersion),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpVersion.SNMPv2c),
    __metadata("design:type", String)
], HcpProps.prototype, "snmpVersion", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)("public"),
    __metadata("design:type", String)
], HcpProps.prototype, "snmpCommunity", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], HcpProps.prototype, "snmpSecUser", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpLevel),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpLevel.NOAUTH_NOPRIV),
    __metadata("design:type", String)
], HcpProps.prototype, "snmpSecLevel", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpPrivProto),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpPrivProto.AES),
    __metadata("design:type", String)
], HcpProps.prototype, "snmpPrivProtocol", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.SnmpAuthProto),
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.SnmpAuthProto.SHA),
    __metadata("design:type", String)
], HcpProps.prototype, "snmpAuthProtocol", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], HcpProps.prototype, "snmpPrivPassword", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], HcpProps.prototype, "snmpAuthPassword", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], HcpProps.prototype, "snmpContextName", void 0);
class HcpOldProps extends deviceProps_1.OldRestDeviceProps {
}
exports.HcpOldProps = HcpOldProps;
exports.HcpDataDescription = {
    tenants: {
        required: true,
        type: "format[]",
        description: "Array of tenants",
        format: {
            alias: {
                required: true,
                type: "string",
            },
            host: {
                required: true,
                type: "string",
            },
            username: {
                required: true,
                type: "string",
            },
            password: {
                required: true,
                type: "string",
            }
        }
    },
    ...deviceProps_1.SnmpStorageDeviceDescription
};
//# sourceMappingURL=hcp.data.js.map