"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VspgDataDescription = exports.VspgPropsOld = exports.VspgProps = exports.ExportTool = void 0;
const hostcfg_metadata_1 = require("../../resolve/hostcfg.metadata");
const deviceProps_1 = require("./deviceProps");
const hostcfgData_types_1 = require("./hostcfgData.types");
var ExportTool;
(function (ExportTool) {
    ExportTool["REST"] = "rest";
    ExportTool["MANAGER"] = "manager";
})(ExportTool || (exports.ExportTool = ExportTool = {}));
class VspgProps extends deviceProps_1.RestDeviceProps {
    constructor() {
        super(...arguments);
        this.node1Host = undefined;
        this.node2Host = undefined;
        this.svpHost = undefined;
        this.apiUsername = undefined;
        this.apiPassword = undefined;
        this.exportRadio = ExportTool.REST;
        this.restProto = hostcfgData_types_1.PROTO.HTTPS;
        this.hcmHost = undefined;
        this.hcmPort = 23451;
        this.hcmProto = hostcfgData_types_1.PROTO.HTTPS;
        this.hcmDeviceId = undefined;
        this.cciHorcmFile = undefined;
        this.exportToolHome = undefined;
        this.device_uuid = undefined;
    }
}
exports.VspgProps = VspgProps;
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], VspgProps.prototype, "node1Host", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VspgProps.prototype, "node2Host", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], VspgProps.prototype, "svpHost", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], VspgProps.prototype, "apiUsername", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    __metadata("design:type", String)
], VspgProps.prototype, "apiPassword", void 0);
__decorate([
    hostcfg_metadata_1.Required,
    (0, hostcfg_metadata_1.DefaultValue)(ExportTool.REST),
    (0, hostcfg_metadata_1.EnumType)(ExportTool),
    __metadata("design:type", String)
], VspgProps.prototype, "exportRadio", void 0);
__decorate([
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.PROTO.HTTPS),
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.PROTO),
    __metadata("design:type", String)
], VspgProps.prototype, "restProto", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VspgProps.prototype, "hcmHost", void 0);
__decorate([
    (0, hostcfg_metadata_1.DefaultValue)(23451),
    __metadata("design:type", Number)
], VspgProps.prototype, "hcmPort", void 0);
__decorate([
    (0, hostcfg_metadata_1.DefaultValue)(hostcfgData_types_1.PROTO.HTTPS),
    (0, hostcfg_metadata_1.EnumType)(hostcfgData_types_1.PROTO),
    __metadata("design:type", String)
], VspgProps.prototype, "hcmProto", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VspgProps.prototype, "hcmDeviceId", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VspgProps.prototype, "cciHorcmFile", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VspgProps.prototype, "exportToolHome", void 0);
__decorate([
    hostcfg_metadata_1.Unrequired,
    __metadata("design:type", String)
], VspgProps.prototype, "device_uuid", void 0);
class VspgPropsOld extends deviceProps_1.OldRestDeviceProps {
}
exports.VspgPropsOld = VspgPropsOld;
exports.VspgDataDescription = {
    node1Host: {
        required: true,
        type: "string",
    },
    node2Host: {
        required: false,
        type: "string",
    },
    svpHost: {
        required: true,
        type: "string",
    },
    apiUsername: {
        required: true,
        type: "string",
    },
    apiPassword: {
        required: true,
        type: "string",
    },
    exportRadio: {
        required: false,
        type: "string",
        description: "Specify which export tool to use",
        default: "rest",
        possibleValues: Object.keys(ExportTool).map(key => ExportTool[key])
    },
    restProto: {
        required: false,
        type: "string",
        possibleValues: Object.keys(hostcfgData_types_1.PROTO).map(key => hostcfgData_types_1.PROTO[key])
    },
    hcmHost: {
        required: false,
        type: "string",
        description: "Required when export tool (exportRadio) = manager"
    },
    hcmPort: {
        required: false,
        type: "number",
        default: 23451,
        description: "Required when export tool (exportRadio) = manager"
    },
    hcmProto: {
        required: false,
        type: "string",
        description: "Required when export tool (exportRadio) = manager",
        possibleValues: Object.keys(hostcfgData_types_1.PROTO).map(key => hostcfgData_types_1.PROTO[key])
    },
    hcmDeviceId: {
        required: false,
        type: "string",
        description: "Required when export tool (exportRadio) = manager"
    },
    currency: {
        required: false,
        type: "string",
        default: "USD"
    },
    tierFmd: {
        required: false,
        type: "string",
    },
    tierSsd: {
        required: false,
        type: "string",
    },
    tierSas10: {
        required: false,
        type: "string",
    },
    tierSas15: {
        required: false,
        type: "string",
    },
    tierSasNl: {
        required: false,
        type: "string",
    },
    ...deviceProps_1.RestDeviceDescription
};
//# sourceMappingURL=vspg.data.js.map