import { LDAP_GROUP_FILTER_TYPE, LDAP_PROTOCOL } from '@const/ldap.constants';
import { BasicResponseDTO } from './basicResponse.dto';
export type LdapProtocol = typeof LDAP_PROTOCOL[keyof typeof LDAP_PROTOCOL];
export type LdapGroupFilterType = typeof LDAP_GROUP_FILTER_TYPE[keyof typeof LDAP_GROUP_FILTER_TYPE];
export declare class LdapBase {
    label: string;
    url: string[];
    protocol: LdapProtocol;
    base_dn: string;
    group_base?: string;
    group_object_class: string;
    group_filter_attribute: string;
    group_filter_type?: LdapGroupFilterType;
    user_base?: string;
    user_object_class: string;
    user_filter_attribute: string;
    user_prefix?: string;
    user_postfix?: string;
    required_user_group?: string;
    full_dn_auth?: boolean;
    disabled?: boolean;
}
export declare class LdapGroup {
    cn: string;
    dn: string;
    objectClass: string;
}
export declare class LdapCertificate {
    ldap_certificate_id: string;
    path: string;
}
export declare class LdapGroupsResponse extends BasicResponseDTO {
    data: LdapGroup[];
}
export declare class Ldap extends LdapBase {
    ldap_id: string;
    groups: string[];
}
export declare class LdapSave extends LdapBase {
    login: string;
    password: string;
    technical?: boolean;
    ldap_id?: string;
}
export declare class LdapsResponseDTO extends BasicResponseDTO {
    data: Ldap[];
}
export declare class LdapResponseDTO extends BasicResponseDTO {
    data: Ldap;
}
export declare class LdapCertificatesResponseDTO extends BasicResponseDTO {
    data: LdapCertificate[];
}
