"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveReportResponseDTO = exports.GetReportResponseDTO = exports.GetReportsResponseDTO = exports.TimeRange = exports.SavedMailGroup = exports.SavedReport = exports.UpdateReport = exports.NewReport = exports.PlainReport = exports.Recurrence = void 0;
const openapi = require("@nestjs/swagger");
const basicResponse_dto_1 = require("./basicResponse.dto");
const report_elements_1 = require("./elements/report.elements");
Object.defineProperty(exports, "Recurrence", { enumerable: true, get: function () { return report_elements_1.RecurrenceElement; } });
class PlainReport {
    static _OPENAPI_METADATA_FACTORY() {
        return { label: { required: true, type: () => String }, time_range: { required: false, type: () => require("./report.dto").TimeRange, nullable: true }, report_items: { required: false, type: () => [require("./reportItem.dto").PlainReportItem] } };
    }
}
exports.PlainReport = PlainReport;
class NewReport {
    static _OPENAPI_METADATA_FACTORY() {
        return { user_id: { required: false, type: () => Number }, label: { required: true, type: () => String }, report_items: { required: false, type: () => [Object] }, disabled: { required: false, type: () => Boolean }, on_generate_create_report_file: { required: false, type: () => Boolean }, recurrence: { required: false, type: () => require("./elements/report.elements").RecurrenceElement, nullable: true }, mail_group_ids: { required: false, type: () => [Number] } };
    }
}
exports.NewReport = NewReport;
class UpdateReport extends NewReport {
    static _OPENAPI_METADATA_FACTORY() {
        return { report_id: { required: false, type: () => String }, report_items: { required: false, type: () => [Object] } };
    }
}
exports.UpdateReport = UpdateReport;
class SavedReport extends UpdateReport {
    static _OPENAPI_METADATA_FACTORY() {
        return { report_id: { required: true, type: () => String }, disabled: { required: true, type: () => Boolean }, on_generate_create_report_file: { required: true, type: () => Boolean }, recurrence: { required: true, type: () => require("./elements/report.elements").RecurrenceElement, nullable: true }, last_run_at: { required: true, type: () => Date, nullable: true }, created_at: { required: true, type: () => Date }, updated_at: { required: true, type: () => Date }, report_items: { required: true, type: () => [Object] }, report_files: { required: true, type: () => [require("./reportFile.dto").SavedReportFile] }, mail_group_ids: { required: false, type: () => [Number] } };
    }
}
exports.SavedReport = SavedReport;
class SavedMailGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { mail_group_id: { required: true, type: () => Number }, label: { required: true, type: () => String }, mails: { required: true, type: () => [String] } };
    }
}
exports.SavedMailGroup = SavedMailGroup;
class TimeRange {
    static _OPENAPI_METADATA_FACTORY() {
        return { date_from: { required: true, type: () => Date }, date_to: { required: true, type: () => Date } };
    }
}
exports.TimeRange = TimeRange;
class GetReportsResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => [require("./report.dto").SavedReport] } };
    }
}
exports.GetReportsResponseDTO = GetReportsResponseDTO;
class GetReportResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { data: { required: true, type: () => require("./report.dto").SavedReport } };
    }
}
exports.GetReportResponseDTO = GetReportResponseDTO;
class SaveReportResponseDTO extends basicResponse_dto_1.BasicResponseDTO {
    static _OPENAPI_METADATA_FACTORY() {
        return { message: { required: true, type: () => String }, data: { required: true, type: () => require("./report.dto").UpdateReport } };
    }
}
exports.SaveReportResponseDTO = SaveReportResponseDTO;
//# sourceMappingURL=report.dto.js.map