import { BasicResponseDTO } from './basicResponse.dto';
declare class GlobKeyTypes {
    readonly SNMP_TRAP_HOST = "";
    readonly SNMP_COMMUNITY = "";
    readonly TOKEN_EXPIRATION = 0;
    readonly TOP_ITEMS = 0;
    readonly VMWARE_SDK = 0;
    readonly PUBLIC_URL = "";
    readonly DATA_RETENTION = 365;
    readonly REMOVE_FROM_MENU = 30;
    readonly LKEY: string;
}
declare class AlertingKeyTypes {
    readonly NAGIOS = false;
    readonly IS_SCRIPT = false;
    readonly SCRIPT = "";
    readonly INCLUDE_GRAPHS = 0;
    readonly REPEAT_TIME = 0;
    readonly PEAK_TIME = 0;
    readonly XORMON_URL = "";
    readonly ALARMONE_URL = "";
    readonly SEND_PER_ITEM = false;
}
declare class SmtpKeyTypes {
    readonly HOST = "";
    readonly USER = "";
    readonly PASS = "";
    readonly PORT = "";
    readonly ENCRYPTION = "";
    readonly MAIL_FROM = "";
}
declare class ServicenowKeyTypes {
    readonly INSTANCE = "";
    readonly USER = "";
    readonly PASS = "";
    readonly TYPE = "";
    readonly CLASS = "";
}
declare class CertKeyTypes {
    readonly KEY = "";
    readonly CRT = "";
}
declare class LdapKeyTypes {
    readonly TIMEOUT_SEC = 0;
    readonly PAGE_SIZE = 0;
}
declare const ALERTING_ = "ALERTING_";
declare const GLOB_ = "GLOB_";
declare const SMTP_ = "SMTP_";
declare const CERT_ = "CERT_";
declare const LDAP_ = "LDAP_";
declare const SERVICENOW_ = "SERVICENOW_";
export declare class SettingKey<T = {
    [index: string]: any;
}> {
    static readonly ALERTING: SettingKey<AlertingKeyTypes>;
    static readonly GLOB: SettingKey<GlobKeyTypes>;
    static readonly SMTP: SettingKey<SmtpKeyTypes>;
    static readonly LDAP: SettingKey<LdapKeyTypes>;
    static readonly SERVICENOW: SettingKey<ServicenowKeyTypes>;
    readonly PREFIX: string;
    protected readonly keyTypes: T;
    private constructor();
    private getType;
    get(propertyName: keyof T): "ALERTING_NAGIOS" | "ALERTING_IS_SCRIPT" | "ALERTING_SCRIPT" | "ALERTING_INCLUDE_GRAPHS" | "ALERTING_REPEAT_TIME" | "ALERTING_PEAK_TIME" | "ALERTING_XORMON_URL" | "ALERTING_ALARMONE_URL" | "ALERTING_SEND_PER_ITEM" | "GLOB_SNMP_TRAP_HOST" | "GLOB_SNMP_COMMUNITY" | "GLOB_TOKEN_EXPIRATION" | "GLOB_TOP_ITEMS" | "GLOB_VMWARE_SDK" | "GLOB_PUBLIC_URL" | "GLOB_DATA_RETENTION" | "GLOB_REMOVE_FROM_MENU" | "GLOB_LKEY" | "SMTP_HOST" | "SMTP_USER" | "SMTP_PASS" | "SMTP_PORT" | "SMTP_ENCRYPTION" | "SMTP_MAIL_FROM" | "CERT_KEY" | "CERT_CRT" | "LDAP_TIMEOUT_SEC" | "LDAP_PAGE_SIZE" | "SERVICENOW_CLASS" | "SERVICENOW_USER" | "SERVICENOW_PASS" | "SERVICENOW_INSTANCE" | "SERVICENOW_TYPE";
    reType(settings: SettingsItem): void;
}
export type SettingsItem = Partial<Record<`${typeof ALERTING_}${keyof AlertingKeyTypes}` | `${typeof GLOB_}${keyof GlobKeyTypes}` | `${typeof SMTP_}${keyof SmtpKeyTypes}` | `${typeof CERT_}${keyof CertKeyTypes}` | `${typeof LDAP_}${keyof LdapKeyTypes}` | `${typeof SERVICENOW_}${keyof ServicenowKeyTypes}`, string>>;
export declare class SettingsResponseDTO extends BasicResponseDTO {
    data: SettingsItem;
}
export declare class MailTestDTO {
    mail: string;
}
export {};
