import { BasicResponseDTO } from './basicResponse.dto';
export declare class PredictionDTO {
    metadata: {
        metric: string;
        item_id: string;
        command: string;
        frequency: string;
    };
    models: {
        [model: string]: PredictionModel;
    };
    real: {
        [metric: string]: TimeseriesItem;
    };
}
export declare class PredictionModel {
    metadata: {
        label: string;
        start: number;
        end: number;
        interval: number;
        display: boolean;
        description?: string;
        days_to_100_percent_fill?: number | string;
        days_to_90_percent_fill?: number | string;
        days_to_70_percent_fill?: number | string;
        slope?: number;
        std?: number;
        max_dif?: number;
        min_dif?: number;
    };
    timeseries: number[];
}
export declare class ItemParent {
    label: string;
    url?: string;
}
export declare class TimeseriesMetadata {
    name: string;
    parent?: ItemParent;
    uuid?: string;
    start?: number;
    end?: number;
    interval?: number;
    metric?: string;
    avg?: number;
    max?: number;
    min?: number;
    url?: string;
    description?: string;
}
export declare class TimeseriesItem {
    metadata: TimeseriesMetadata;
    timeseries: Object | number[];
}
export declare class TimeseriesDTO {
    metadata: {
        start: number;
        end: number;
    };
    metrics: {
        [metric: string]: TimeseriesItem[];
    };
}
export declare class TimeseriesResponseDTO extends BasicResponseDTO {
    data: TimeseriesDTO;
}
export declare class PredictionResponseDTO extends BasicResponseDTO {
    data: PredictionDTO;
}
