"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpResponse = exports.StatusCodes = void 0;
exports.StatusCodes = {
    SUCCESS: 200,
    CREATED: 201,
    ERROR: 400,
    UNAUTHORIZED: 401,
};
class HttpResponse {
    error(response, message) {
        response.status(exports.StatusCodes.ERROR).send({
            statusCode: exports.StatusCodes.ERROR,
            message: message,
        });
    }
    unauthorized(response) {
        response.status(exports.StatusCodes.UNAUTHORIZED).send({
            statusCode: exports.StatusCodes.UNAUTHORIZED,
            message: 'Unauthorized access (missing/bad token?)',
        });
    }
    success(response, message = null) {
        if (message) {
            response.status(exports.StatusCodes.SUCCESS).send({
                statusCode: exports.StatusCodes.SUCCESS,
                message: message,
            });
        }
        else {
            response.status(200).send();
        }
    }
    created(response, message = null) {
        if (message) {
            response.status(exports.StatusCodes.CREATED).send({
                statusCode: exports.StatusCodes.CREATED,
                message: message,
            });
        }
        else {
            response.status(exports.StatusCodes.CREATED).send();
        }
    }
    json(response, json) {
        response.status(exports.StatusCodes.SUCCESS).send(json);
    }
}
exports.HttpResponse = HttpResponse;
//# sourceMappingURL=HttpResponse.js.map