"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlertingHistory = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const alerting_constants_1 = require("../common/constants/alerting.constants");
const alertingHistoryItem_entity_1 = require("./alertingHistoryItem.entity");
let AlertingHistory = class AlertingHistory {
    static _OPENAPI_METADATA_FACTORY() {
        return { alerting_history_id: { required: true, type: () => String }, _alerting_group: { required: true, type: () => require("./alertingGroup.entity").AlertingGroup }, alerting_group_id: { required: true, type: () => String }, metric: { required: true, type: () => String }, limit: { required: true, type: () => Number }, level: { required: true, type: () => String }, targets: { required: true, type: () => [String] }, triggeredAt: { required: false, type: () => Date }, _items: { required: false, type: () => [require("./alertingHistoryItem.entity").AlertingHistoryItem] } };
    }
};
exports.AlertingHistory = AlertingHistory;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], AlertingHistory.prototype, "alerting_history_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => alertingGroup_entity_1.AlertingGroup, (alertingGroup) => alertingGroup.alerts, { onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'alerting_group_id' }),
    __metadata("design:type", alertingGroup_entity_1.AlertingGroup)
], AlertingHistory.prototype, "_alerting_group", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], AlertingHistory.prototype, "alerting_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], AlertingHistory.prototype, "metric", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'float4' }),
    __metadata("design:type", Number)
], AlertingHistory.prototype, "limit", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: alerting_constants_1.ALERT_LEVEL.undefined,
    }),
    __metadata("design:type", String)
], AlertingHistory.prototype, "level", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'text', array: true }),
    __metadata("design:type", Array)
], AlertingHistory.prototype, "targets", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ name: 'triggered_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], AlertingHistory.prototype, "triggeredAt", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingHistoryItem_entity_1.AlertingHistoryItem, (alertingHistoryItem) => alertingHistoryItem._alerting_history),
    __metadata("design:type", Array)
], AlertingHistory.prototype, "_items", void 0);
exports.AlertingHistory = AlertingHistory = __decorate([
    (0, typeorm_1.Entity)({ name: 'alerting_history', synchronize: false })
], AlertingHistory);
//# sourceMappingURL=alertingHistory.entity.js.map