"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DashboardGraph = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const dashboardGroup_entity_1 = require("./dashboardGroup.entity");
const pageResponse_constants_1 = require("../common/constants/pageResponse.constants");
const enumsVersion = 'v' + 1;
let DashboardGraph = class DashboardGraph {
    static _OPENAPI_METADATA_FACTORY() {
        return { dashboard_graph_id: { required: true, type: () => String }, dashboard_group_id: { required: true, type: () => String }, dashboard_group: { required: true, type: () => require("./dashboardGroup.entity").DashboardGroup }, width: { required: true, type: () => Number }, height: { required: true, type: () => Number }, url: { required: true, type: () => String }, tab: { required: true, type: () => String }, interval: { required: true, type: () => Object }, x: { required: true, type: () => Number }, y: { required: true, type: () => Number } };
    }
};
exports.DashboardGraph = DashboardGraph;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], DashboardGraph.prototype, "dashboard_graph_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DashboardGraph.prototype, "dashboard_group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => dashboardGroup_entity_1.DashboardGroup, (dashboard_group) => dashboard_group.dashboard_graphs, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'dashboard_group_id' }),
    __metadata("design:type", dashboardGroup_entity_1.DashboardGroup)
], DashboardGraph.prototype, "dashboard_group", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], DashboardGraph.prototype, "width", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], DashboardGraph.prototype, "height", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DashboardGraph.prototype, "url", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DashboardGraph.prototype, "tab", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: pageResponse_constants_1.GRAPH_INTERVAL,
        default: pageResponse_constants_1.GRAPH_INTERVAL.year,
        enumName: `dashboard_interval_${enumsVersion}`,
    }),
    __metadata("design:type", String)
], DashboardGraph.prototype, "interval", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], DashboardGraph.prototype, "x", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], DashboardGraph.prototype, "y", void 0);
exports.DashboardGraph = DashboardGraph = __decorate([
    (0, typeorm_1.Entity)({ name: 'dashboard_graphs', synchronize: false })
], DashboardGraph);
//# sourceMappingURL=dashboardGraph.entity.js.map