"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Group = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const user_entity_1 = require("./user.entity");
const groupLdapGroup_entity_1 = require("./groupLdapGroup.entity");
const dashboard_entity_1 = require("./dashboard.entity");
const customGroup_entity_1 = require("./customGroup.entity");
const customGroupFolder_entity_1 = require("./customGroupFolder.entity");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const storageGroup_entity_1 = require("./storageGroup.entity");
let Group = class Group {
    static _OPENAPI_METADATA_FACTORY() {
        return { group_id: { required: true, type: () => Number }, name: { required: true, type: () => String }, description: { required: true, type: () => String }, _users: { required: false, type: () => [require("./user.entity").User] }, _groupLdapGroups: { required: false, type: () => [require("./groupLdapGroup.entity").GroupLdapGroup] }, _dashboards: { required: false, type: () => [require("./dashboard.entity").Dashboard] }, _custom_groups: { required: false, type: () => [require("./customGroup.entity").CustomGroup] }, _custom_group_folders: { required: false, type: () => [require("./customGroupFolder.entity").CustomGroupFolder] }, _alerting_groups: { required: false, type: () => [require("./alertingGroup.entity").AlertingGroup] }, _storage_groups: { required: false, type: () => [require("./storageGroup.entity").StorageGroup] } };
    }
};
exports.Group = Group;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], Group.prototype, "group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], Group.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], Group.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => user_entity_1.User),
    (0, typeorm_1.JoinTable)({
        name: 'users_groups',
        inverseJoinColumn: {
            name: 'user_id',
            referencedColumnName: 'user_id',
        },
        joinColumn: {
            name: 'group_id',
            referencedColumnName: 'group_id',
        },
    }),
    __metadata("design:type", Array)
], Group.prototype, "_users", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => groupLdapGroup_entity_1.GroupLdapGroup, (ldapGroup) => ldapGroup._group),
    __metadata("design:type", Array)
], Group.prototype, "_groupLdapGroups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => dashboard_entity_1.Dashboard, (dashboard) => dashboard._group),
    __metadata("design:type", Array)
], Group.prototype, "_dashboards", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => customGroup_entity_1.CustomGroup, (customGroup) => customGroup._group),
    __metadata("design:type", Array)
], Group.prototype, "_custom_groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => customGroupFolder_entity_1.CustomGroupFolder, (customGroupFolder) => customGroupFolder._group),
    __metadata("design:type", Array)
], Group.prototype, "_custom_group_folders", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingGroup_entity_1.AlertingGroup, (ag) => ag._group),
    __metadata("design:type", Array)
], Group.prototype, "_alerting_groups", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => storageGroup_entity_1.StorageGroup, (sg) => sg._group),
    __metadata("design:type", Array)
], Group.prototype, "_storage_groups", void 0);
exports.Group = Group = __decorate([
    (0, typeorm_1.Entity)({ name: 'groups', synchronize: false })
], Group);
//# sourceMappingURL=group.entity.js.map