"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HostCfg = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const hostcfgRelation_entity_1 = require("./hostcfgRelation.entity");
const hwType_entity_1 = require("./hwType.entity");
const microserviceVariables_entity_1 = require("./microserviceVariables.entity");
const targetDestinationHostcfg_entity_1 = require("./targetDestinationHostcfg.entity");
const hostcfgStatus_entity_1 = require("./hostcfgStatus.entity");
const healthStatusMirror_entity_1 = require("./healthStatusMirror.entity");
let HostCfg = class HostCfg {
    static _OPENAPI_METADATA_FACTORY() {
        return { hostcfg_id: { required: true, type: () => String }, label: { required: true, type: () => String }, hw_type_entity: { required: true, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, disabled: { required: true, type: () => Boolean }, target: { required: true, type: () => Boolean }, ignore_health_status: { required: true, type: () => Boolean }, ignore_health_status_reason: { required: false, type: () => String }, data: { required: true, type: () => Object }, createdAt: { required: false, type: () => Date }, updatedAt: { required: false, type: () => Date }, relations: { required: false, type: () => [require("./hostcfgRelation.entity").HostcfgRelation] }, destinations: { required: false, type: () => [require("./targetDestinationHostcfg.entity").TargetDestinationHostcfg] }, microserviceVariables: { required: false, type: () => [require("./microserviceVariables.entity").MicroserviceVariables] }, status: { required: false, type: () => require("./hostcfgStatus.entity").HostcfgStatus }, _health_status_mirrors: { required: false, type: () => [require("./healthStatusMirror.entity").HealthStatusMirror] } };
    }
};
exports.HostCfg = HostCfg;
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], HostCfg.prototype, "hostcfg_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], HostCfg.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.hostcfgs, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], HostCfg.prototype, "hw_type_entity", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], HostCfg.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], HostCfg.prototype, "disabled", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], HostCfg.prototype, "target", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], HostCfg.prototype, "ignore_health_status", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: null
    }),
    __metadata("design:type", String)
], HostCfg.prototype, "ignore_health_status_reason", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'jsonb' }),
    __metadata("design:type", Object)
], HostCfg.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ name: 'created_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], HostCfg.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ name: 'updated_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], HostCfg.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => hostcfgRelation_entity_1.HostcfgRelation, (hostcfgRelations) => hostcfgRelations._hostcfg),
    __metadata("design:type", Array)
], HostCfg.prototype, "relations", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => targetDestinationHostcfg_entity_1.TargetDestinationHostcfg, (targetDestinationHostcfg) => targetDestinationHostcfg._hostcfg),
    __metadata("design:type", Array)
], HostCfg.prototype, "destinations", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => microserviceVariables_entity_1.MicroserviceVariables, (microserviceVariable) => microserviceVariable._hostcfg_id),
    __metadata("design:type", Array)
], HostCfg.prototype, "microserviceVariables", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => hostcfgStatus_entity_1.HostcfgStatus, (hostcfgStatus) => hostcfgStatus._hostcfg),
    __metadata("design:type", hostcfgStatus_entity_1.HostcfgStatus)
], HostCfg.prototype, "status", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => healthStatusMirror_entity_1.HealthStatusMirror, (mirror) => mirror.hostcfg_id),
    __metadata("design:type", Array)
], HostCfg.prototype, "_health_status_mirrors", void 0);
exports.HostCfg = HostCfg = __decorate([
    (0, typeorm_1.Entity)({ name: 'hostcfg', synchronize: false })
], HostCfg);
//# sourceMappingURL=hostcfg.entity.js.map