"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemGroup = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const itemGroupItem_entity_1 = require("./itemGroupItem.entity");
const itemGroupParent_entity_1 = require("./itemGroupParent.entity");
const itemGroupRegexParent_entity_1 = require("./itemGroupRegexParent.entity");
const itemGroupTag_entity_1 = require("./itemGroupTag.entity");
const customGroup_entity_1 = require("./customGroup.entity");
const itemGroupParentTag_entity_1 = require("./itemGroupParentTag.entity");
const export_entity_1 = require("./export.entity");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const reportItem_entity_1 = require("./reportItem.entity");
const deviceGroupHwAlerting_entity_1 = require("./deviceGroupHwAlerting.entity");
let ItemGroup = class ItemGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_group_id: { required: true, type: () => String }, _custom_group: { required: false, type: () => require("./customGroup.entity").CustomGroup }, custom_group_id: { required: true, type: () => String }, regex: { required: true, type: () => [String] }, intersection: { required: true, type: () => Boolean }, items: { required: false, type: () => [require("./itemGroupItem.entity").ItemGroupItem] }, parents: { required: false, type: () => [require("./itemGroupParent.entity").ItemGroupParent] }, regex_parents: { required: false, type: () => [require("./itemGroupRegexParent.entity").ItemGroupRegexParent] }, tags: { required: false, type: () => [require("./itemGroupTag.entity").ItemGroupTag] }, parent_tags: { required: false, type: () => [require("./itemGroupParentTag.entity").ItemGroupParentTag] }, export: { required: false, type: () => require("./export.entity").Export }, alertingGroup: { required: false, type: () => require("./alertingGroup.entity").AlertingGroup }, report_item: { required: false, type: () => require("./reportItem.entity").ReportItem }, deviceGroup: { required: false, type: () => require("./deviceGroupHwAlerting.entity").HwEventDeviceGroup } };
    }
};
exports.ItemGroup = ItemGroup;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], ItemGroup.prototype, "item_group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => customGroup_entity_1.CustomGroup, (customGroup) => customGroup.groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'custom_group_id' }),
    __metadata("design:type", customGroup_entity_1.CustomGroup)
], ItemGroup.prototype, "_custom_group", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ItemGroup.prototype, "custom_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'text', array: true, nullable: true }),
    __metadata("design:type", Array)
], ItemGroup.prototype, "regex", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false
    }),
    __metadata("design:type", Boolean)
], ItemGroup.prototype, "intersection", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupItem_entity_1.ItemGroupItem, (itemGroupItems) => itemGroupItems._item_group),
    __metadata("design:type", Array)
], ItemGroup.prototype, "items", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupParent_entity_1.ItemGroupParent, (itemGroupItems) => itemGroupItems._item_group),
    __metadata("design:type", Array)
], ItemGroup.prototype, "parents", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupRegexParent_entity_1.ItemGroupRegexParent, (customGroupItems) => customGroupItems._item_group),
    __metadata("design:type", Array)
], ItemGroup.prototype, "regex_parents", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupTag_entity_1.ItemGroupTag, (itemGroupTag) => itemGroupTag._item_group),
    __metadata("design:type", Array)
], ItemGroup.prototype, "tags", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupParentTag_entity_1.ItemGroupParentTag, (itemGroupParentTag) => itemGroupParentTag._item_group),
    __metadata("design:type", Array)
], ItemGroup.prototype, "parent_tags", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => export_entity_1.Export, (exporter) => exporter._item_group),
    __metadata("design:type", export_entity_1.Export)
], ItemGroup.prototype, "export", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => alertingGroup_entity_1.AlertingGroup, (alertingGroup) => alertingGroup._item_group),
    __metadata("design:type", alertingGroup_entity_1.AlertingGroup)
], ItemGroup.prototype, "alertingGroup", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => reportItem_entity_1.ReportItem, (reportItem) => reportItem._item_group),
    __metadata("design:type", reportItem_entity_1.ReportItem)
], ItemGroup.prototype, "report_item", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => deviceGroupHwAlerting_entity_1.HwEventDeviceGroup, (deviceGroup) => deviceGroup._item_group, { cascade: true, onDelete: 'CASCADE' }),
    __metadata("design:type", deviceGroupHwAlerting_entity_1.HwEventDeviceGroup)
], ItemGroup.prototype, "deviceGroup", void 0);
exports.ItemGroup = ItemGroup = __decorate([
    (0, typeorm_1.Entity)({ name: 'item_groups', synchronize: false })
], ItemGroup);
//# sourceMappingURL=itemGroup.entity.js.map