"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Db2Member = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.Db2Member = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_db2_member',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        AGENTSTOP: {
            type: 'float4',
            nullable: true,
        },
        NUMPOOLEDAGENTS: {
            type: 'float4',
            nullable: true,
        },
        NUMASSOCAGENTS: {
            type: 'float4',
            nullable: true,
        },
        NUMCOORDAGENTS: {
            type: 'float4',
            nullable: true,
        },
        NUMLOCKSHELD: {
            type: 'float4',
            nullable: true,
        },
        NUMLOCKSWAITING: {
            type: 'float4',
            nullable: true,
        },
        LOCKESCALS: {
            type: 'float4',
            nullable: true,
        },
        LOCKTIMEOUTS: {
            type: 'float4',
            nullable: true,
        },
        DEADLOCKS: {
            type: 'float4',
            nullable: true,
        },
        LOGICALREADS: {
            type: 'float4',
            nullable: true,
        },
        PHYSICALREADS: {
            type: 'float4',
            nullable: true,
        },
        WRITES: {
            type: 'float4',
            nullable: true,
        },
        DIRECTREADS: {
            type: 'float4',
            nullable: true,
        },
        DIRECTWRITES: {
            type: 'float4',
            nullable: true,
        },
        DIRECTREADTIME: {
            type: 'float4',
            nullable: true,
        },
        DIRECTWRITETIME: {
            type: 'float4',
            nullable: true,
        },
        POOLREADTIME: {
            type: 'float4',
            nullable: true,
        },
        POOLWRITETIME: {
            type: 'float4',
            nullable: true,
        },
        ROWSMODIFIED: {
            type: 'float4',
            nullable: true,
        },
        ROWSRETURNED: {
            type: 'float4',
            nullable: true,
        },
        ROWSREAD: {
            type: 'float4',
            nullable: true,
        },
        ROWSUPDATED: {
            type: 'float4',
            nullable: true,
        },
        ROWSDELETED: {
            type: 'float4',
            nullable: true,
        },
        ROWSINSERTED: {
            type: 'float4',
            nullable: true,
        },
        INTROWSDELETED: {
            type: 'float4',
            nullable: true,
        },
        INTROWSINSERTED: {
            type: 'float4',
            nullable: true,
        },
        INTROWSUPDATED: {
            type: 'float4',
            nullable: true,
        },
        FEDROWSRETURNED: {
            type: 'float4',
            nullable: true,
        },
        FEDROWSREAD: {
            type: 'float4',
            nullable: true,
        },
        FEDROWSUPDATED: {
            type: 'float4',
            nullable: true,
        },
        FEDROWSDELETED: {
            type: 'float4',
            nullable: true,
        },
        FEDROWSINSERTED: {
            type: 'float4',
            nullable: true,
        },
        TCPIPSENDVOLUME: {
            type: 'float4',
            nullable: true,
        },
        TCPIPRECVVOLUME: {
            type: 'float4',
            nullable: true,
        },
        IPCSENDVOLUME: {
            type: 'float4',
            nullable: true,
        },
        IPCRECVVOLUME: {
            type: 'float4',
            nullable: true,
        },
        FCMSENDVOLUME: {
            type: 'float4',
            nullable: true,
        },
        FCMRECVVOLUME: {
            type: 'float4',
            nullable: true,
        },
        PKGCACHEINSERTS: {
            type: 'float4',
            nullable: true,
        },
        PKGCACHELOOKUPS: {
            type: 'float4',
            nullable: true,
        },
        TOTALAPPCOMMITS: {
            type: 'float4',
            nullable: true,
        },
        TOTALAPPROLLBACKS: {
            type: 'float4',
            nullable: true,
        },
        LOGDISKWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        TCPIPSENDWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        TCPIPRECVWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        IPCSENDWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        IPCRECVWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        FCMSENDWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        FCMRECVWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        CFWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        CLIENTIDLEWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        LOCKWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        AGENTWAITTIME: {
            type: 'float4',
            nullable: true,
        },
        WLMQUEUETIMETOTAL: {
            type: 'float4',
            nullable: true,
        },
        RATINLOG: {
            type: 'float4',
            nullable: true,
        },
        RATIOCACHE: {
            type: 'float4',
            nullable: true,
        },
        RATIOBUFFER: {
            type: 'float4',
            nullable: true,
        },
        RATIOCPUT: {
            type: 'float4',
            nullable: true,
        },
        CONNECTIONSTOP: {
            type: 'float4',
            nullable: true,
        },
        TOTALCONS: {
            type: 'float4',
            nullable: true,
        },
        TOTALSECCONS: {
            type: 'float4',
            nullable: true,
        },
        APPLSCURCONS: {
            type: 'float4',
            nullable: true,
        },
        AGENTSREGISTERED: {
            type: 'float4',
            nullable: true,
        },
        IDLEAGENTS: {
            type: 'float4',
            nullable: true,
        },
        AGENTSSTOLEN: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=db2Member.entity.js.map