"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GCloudDatabase = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.GCloudDatabase = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_gcloud_database',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_util: {
            type: 'float4',
            nullable: true,
        },
        disk_used: {
            type: 'float4',
            nullable: true,
        },
        disk_quota: {
            type: 'float4',
            nullable: true,
        },
        read_ops: {
            type: 'float4',
            nullable: true,
        },
        write_ops: {
            type: 'float4',
            nullable: true,
        },
        mem_total: {
            type: 'float4',
            nullable: true,
        },
        mem_used: {
            type: 'float4',
            nullable: true,
        },
        connections: {
            type: 'float4',
            nullable: true,
        },
        received_bytes: {
            type: 'float4',
            nullable: true,
        },
        sent_bytes: {
            type: 'float4',
            nullable: true,
        },
        innodb_read: {
            type: 'float4',
            nullable: true,
        },
        innodb_write: {
            type: 'float4',
            nullable: true,
        },
        queries: {
            type: 'float4',
            nullable: true,
        },
        questions: {
            type: 'float4',
            nullable: true,
        },
        innodb_buffer_free: {
            type: 'float4',
            nullable: true,
        },
        innodb_buffer_total: {
            type: 'float4',
            nullable: true,
        },
        innodb_data_fsyncs: {
            type: 'float4',
            nullable: true,
        },
        innodb_os_fsyncs: {
            type: 'float4',
            nullable: true,
        },
        transaction_count: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=gcloudDatabase.entity.js.map