"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEntitySchema = void 0;
const typeorm_1 = require("typeorm");
function getEntitySchema(hwType, subsystem, columns) {
    function getColumns() {
        const meticColumns = {};
        columns.forEach(clm => {
            if (typeof clm == 'string') {
                meticColumns[clm] = {
                    type: 'float4',
                    nullable: true,
                };
                return;
            }
            const [key, rest] = clm;
            meticColumns[key] = rest;
        });
        return meticColumns;
    }
    return new typeorm_1.EntitySchema({
        schema: 'metrics',
        name: `metrics_${hwType}_${subsystem}`,
        columns: {
            time: {
                type: 'timestamp with time zone',
                primary: true,
                nullable: false,
            },
            item_id: {
                type: String,
                primary: true,
                nullable: false,
            },
            ...getColumns()
        }
    });
}
exports.getEntitySchema = getEntitySchema;
//# sourceMappingURL=Compose.js.map