"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinuxServer = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.LinuxServer = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_linux_server',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_idle: {
            type: 'int2',
            nullable: true,
        },
        cpu_sys: {
            type: 'int2',
            nullable: true,
        },
        cpu_usr: {
            type: 'int2',
            nullable: true,
        },
        cpu_wait: {
            type: 'int2',
            nullable: true,
        },
        cpu_util: {
            type: 'int2',
            nullable: true,
        },
        received_bytes: {
            type: 'float4',
            nullable: true,
        },
        send_bytes: {
            type: 'float4',
            nullable: true,
        },
        mem_total: {
            type: 'float4',
            nullable: true,
        },
        mem2: {
            type: 'float4',
            nullable: true,
        },
        mem_free: {
            type: 'float4',
            nullable: true,
        },
        mem4: {
            type: 'float4',
            nullable: true,
        },
        mem_used: {
            type: 'float4',
            nullable: true,
        },
        mem_fs_cache: {
            type: 'float4',
            nullable: true,
        },
        mem_util: {
            type: 'float4',
            nullable: true,
        },
        wtsize: {
            type: 'float4',
            nullable: true,
        },
        pgs1: {
            type: 'float4',
            nullable: true,
        },
        pgs2: {
            type: 'float4',
            nullable: true,
        },
        pgs3: {
            type: 'float4',
            nullable: true,
        },
        pgs4: {
            type: 'float4',
            nullable: true,
        },
        load_avrg: {
            type: 'float4',
            nullable: true,
        },
        logical_processors: {
            type: 'float4',
            nullable: true,
        },
        blocked_processes: {
            type: 'float4',
            nullable: true,
        },
        blocked_raw: {
            type: 'float4',
            nullable: true,
        },
        blocked_direct: {
            type: 'float4',
            nullable: true,
        },
        read_iops: {
            type: 'float4',
            nullable: true,
        },
        read_data: {
            type: 'float4',
            nullable: true,
        },
        read_latency: {
            type: 'float4',
            nullable: true,
        },
        write_iops: {
            type: 'float4',
            nullable: true,
        },
        write_data: {
            type: 'float4',
            nullable: true,
        },
        write_latency: {
            type: 'float4',
            nullable: true,
        },
        st_cpu: {
            type: 'float4',
            nullable: true,
        },
        ame_compres: {
            type: 'float4',
            nullable: true,
        },
        ame_deficit: {
            type: 'float4',
            nullable: true,
        },
        ame_ratio: {
            type: 'float4',
            nullable: true,
        },
        cpu_core: {
            type: 'float4',
            nullable: true,
        },
        san_received_bytes: {
            type: 'float4',
            nullable: true,
        },
        san_send_bytes: {
            type: 'float4',
            nullable: true,
        },
    },
});
//# sourceMappingURL=linuxServer.entity.js.map