"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NutanixVm = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.NutanixVm = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_nutanix_vm',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io_bandwidth: {
            type: 'float4',
            nullable: true,
        },
        write_io_bandwidth: {
            type: 'float4',
            nullable: true,
        },
        total_io_bandwidth: {
            type: 'float4',
            nullable: true,
        },
        write_io_latency: {
            type: 'float4',
            nullable: true,
        },
        read_io_latency: {
            type: 'float4',
            nullable: true,
        },
        total_io_latency: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_cores: {
            type: 'float4',
            nullable: true,
        },
        cpu_cores: {
            type: 'float4',
            nullable: true,
        },
        memory_usage_percent: {
            type: 'float4',
            nullable: true,
        },
        memory_used: {
            type: 'float4',
            nullable: true,
        },
        memory_free: {
            type: 'float4',
            nullable: true,
        },
        memory_total: {
            type: 'float4',
            nullable: true,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        total_io: {
            type: 'float4',
            nullable: true,
        },
        received: {
            type: 'float4',
            nullable: true,
        },
        transmitted: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=nutanixVm.entity.js.map