"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OceanstorLogport = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OceanstorLogport = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_oceanstor_logport',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        resp_t: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        block_size: {
            type: 'float4',
            nullable: true,
        },
        block_size_r: {
            type: 'float4',
            nullable: true,
        },
        block_size_w: {
            type: 'float4',
            nullable: true,
        },
        nfs_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs_read_ops: {
            type: 'float4',
            nullable: true,
        },
        nfs_write_ops: {
            type: 'float4',
            nullable: true,
        },
        nfs_data_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs_read: {
            type: 'float4',
            nullable: true,
        },
        nfs_write: {
            type: 'float4',
            nullable: true,
        },
        cifs_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        cifs_read_ops: {
            type: 'float4',
            nullable: true,
        },
        cifs_write_ops: {
            type: 'float4',
            nullable: true,
        },
        cifs_data_rate: {
            type: 'float4',
            nullable: true,
        },
        cifs_read: {
            type: 'float4',
            nullable: true,
        },
        cifs_write: {
            type: 'float4',
            nullable: true,
        },
        nfs_resp_t: {
            type: 'float4',
            nullable: true,
        },
        nfs_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        nfs_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        cifs_resp_t: {
            type: 'float4',
            nullable: true,
        },
        cifs_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        cifs_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        nfs_other_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        cifs_other_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=oceanstorLogport.entity.js.map