"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OceanstorNode = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OceanstorNode = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_oceanstor_node',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        resp_t: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        queue_length: {
            type: 'float4',
            nullable: true,
        },
        cpu_system: {
            type: 'float4',
            nullable: true,
        },
        cache_usage_percent: {
            type: 'float4',
            nullable: true,
        },
        r_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        w_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        r_cache_usage_percent: {
            type: 'float4',
            nullable: true,
        },
        w_cache_usage_percent: {
            type: 'float4',
            nullable: true,
        },
        temperature: {
            type: 'float4',
            nullable: true,
        },
        block_size: {
            type: 'float4',
            nullable: true,
        },
        block_size_r: {
            type: 'float4',
            nullable: true,
        },
        block_size_w: {
            type: 'float4',
            nullable: true,
        },
        nfs3_read: {
            type: 'float4',
            nullable: true,
        },
        nfs3_write: {
            type: 'float4',
            nullable: true,
        },
        nfs3_data_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs3_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs3_read_ops: {
            type: 'float4',
            nullable: true,
        },
        nfs3_write_ops: {
            type: 'float4',
            nullable: true,
        },
        nfs3_resp_t: {
            type: 'float4',
            nullable: true,
        },
        nfs3_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        nfs3_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        nfs41_read: {
            type: 'float4',
            nullable: true,
        },
        nfs41_write: {
            type: 'float4',
            nullable: true,
        },
        nfs41_data_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs41_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs41_read_ops: {
            type: 'float4',
            nullable: true,
        },
        nfs41_write_ops: {
            type: 'float4',
            nullable: true,
        },
        nfs41_resp_t: {
            type: 'float4',
            nullable: true,
        },
        nfs41_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        nfs41_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        smb2_read: {
            type: 'float4',
            nullable: true,
        },
        smb2_write: {
            type: 'float4',
            nullable: true,
        },
        smb2_data_rate: {
            type: 'float4',
            nullable: true,
        },
        smb2_ops_rate: {
            type: 'float4',
            nullable: true,
        },
        smb2_read_ops: {
            type: 'float4',
            nullable: true,
        },
        smb2_write_ops: {
            type: 'float4',
            nullable: true,
        },
        smb2_resp_t: {
            type: 'float4',
            nullable: true,
        },
        smb2_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        smb2_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=oceanstorNode.entity.js.map