"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OceanstorpacificnasNode = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OceanstorpacificnasNode = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_oceanstorpacificnas_node',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        nfs_resp_t: {
            type: 'float4',
            nullable: true,
        },
        nfs_resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        nfs_resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        cpu_system: {
            type: 'float4',
            nullable: true,
        },
        cache_usage_percent: {
            type: 'float4',
            nullable: true,
        },
        read_ops: {
            type: 'float4',
            nullable: true,
        },
        write_ops: {
            type: 'float4',
            nullable: true,
        },
        ops_rate: {
            type: 'float4',
            nullable: true,
        },
        block_size: {
            type: 'float4',
            nullable: true,
        },
        block_size_r: {
            type: 'float4',
            nullable: true,
        },
        block_size_w: {
            type: 'float4',
            nullable: true,
        },
        hdfs_io_rate: {
            type: 'float4',
            nullable: true,
        },
        hdfs_read_io: {
            type: 'float4',
            nullable: true,
        },
        hdfs_write_io: {
            type: 'float4',
            nullable: true,
        },
        object_io_rate: {
            type: 'float4',
            nullable: true,
        },
        object_read_io: {
            type: 'float4',
            nullable: true,
        },
        object_write_io: {
            type: 'float4',
            nullable: true,
        },
        object_read: {
            type: 'float4',
            nullable: true,
        },
        object_write: {
            type: 'float4',
            nullable: true,
        },
        object_data_rate: {
            type: 'float4',
            nullable: true,
        },
        hdfs_read: {
            type: 'float4',
            nullable: true,
        },
        hdfs_write: {
            type: 'float4',
            nullable: true,
        },
        hdfs_data_rate: {
            type: 'float4',
            nullable: true,
        },
        file_read: {
            type: 'float4',
            nullable: true,
        },
        file_write: {
            type: 'float4',
            nullable: true,
        },
        file_data_rate: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=oceanstorpacificnasNode.entity.js.map