"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OraclezfsCache = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.OraclezfsCache = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_oraclezfs_cache',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        r_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        w_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        cfc_dirty: {
            type: 'float4',
            nullable: true,
        },
        del_ack: {
            type: 'float4',
            nullable: true,
        },
        arc_hitratio: {
            type: 'float4',
            nullable: true,
        },
        prefetched_metadata_hits: {
            type: 'float4',
            nullable: true,
        },
        metadata_misses: {
            type: 'float4',
            nullable: true,
        },
        ARC_headers: {
            type: 'float4',
            nullable: true,
        },
        data_hits: {
            type: 'float4',
            nullable: true,
        },
        data_misses: {
            type: 'float4',
            nullable: true,
        },
        prefetched_data_hits: {
            type: 'float4',
            nullable: true,
        },
        metadata_hits: {
            type: 'float4',
            nullable: true,
        },
        ARC_other: {
            type: 'float4',
            nullable: true,
        },
        arc_size: {
            type: 'float4',
            nullable: true,
        },
        ARC_data: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=oraclezfsCache.entity.js.map