"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresDb = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.PostgresDb = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_postgres_db',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        numbackends: {
            nullable: true,
            type: 'float4',
        },
        buffercontent: {
            nullable: true,
            type: 'float4',
        },
        currenttransactions: {
            nullable: true,
            type: 'float4',
        },
        size: {
            type: 'float4',
            nullable: true,
        },
        tuple: {
            type: 'float4',
            nullable: true,
        },
        OldSnapshotTimeMapLock: {
            nullable: true,
            type: 'float4',
        },
        ShmemIndexLock: {
            nullable: true,
            type: 'float4',
        },
        BackgroundWorkerLock: {
            type: 'float4',
            nullable: true,
        },
        CheckpointerCommLock: {
            nullable: true,
            type: 'float4',
        },
        AutovacuumScheduleLock: {
            nullable: true,
            type: 'float4',
        },
        advisory: {
            nullable: true,
            type: 'float4',
        },
        idle: {
            nullable: true,
            type: 'float4',
        },
        replicationorigin: {
            type: 'float4',
            nullable: true,
        },
        tempfiles: {
            nullable: true,
            type: 'float4',
        },
        multixactoffset: {
            nullable: true,
            type: 'float4',
        },
        apage: {
            type: 'float4',
            nullable: true,
        },
        multixactmember: {
            nullable: true,
            type: 'float4',
        },
        async: {
            nullable: true,
            type: 'float4',
        },
        MultiXactTruncationLock: {
            type: 'float4',
            nullable: true,
        },
        CheckpointLock: {
            nullable: true,
            type: 'float4',
        },
        BufferPin: {
            nullable: true,
            type: 'float4',
        },
        tupfetched: {
            type: 'float4',
            nullable: true,
        },
        active: {
            type: 'float4',
            nullable: true,
        },
        AsyncCtlLock: {
            nullable: true,
            type: 'float4',
        },
        ReplicationOriginLock: {
            nullable: true,
            type: 'float4',
        },
        huserlock: {
            nullable: true,
            type: 'float4',
        },
        arelation: {
            type: 'float4',
            nullable: true,
        },
        hobject: {
            nullable: true,
            type: 'float4',
        },
        cachehitratio: {
            type: 'float4',
            nullable: true,
        },
        ReplicationSlotAllocationLock: {
            nullable: true,
            type: 'float4',
        },
        LWLockTranche: {
            nullable: true,
            type: 'float4',
        },
        SerializableFinishedListLock: {
            nullable: true,
            type: 'float4',
        },
        replicationslotio: {
            nullable: true,
            type: 'float4',
        },
        htuple: {
            nullable: true,
            type: 'float4',
        },
        xactcommit: {
            nullable: true,
            type: 'float4',
        },
        page: {
            nullable: true,
            type: 'float4',
        },
        blksread: {
            type: 'float4',
            nullable: true,
        },
        tupreturned: {
            type: 'float4',
            nullable: true,
        },
        object: {
            nullable: true,
            type: 'float4',
        },
        subtrans: {
            type: 'float4',
            nullable: true,
        },
        committimestamp: {
            nullable: true,
            type: 'float4',
        },
        hextend: {
            nullable: true,
            type: 'float4',
        },
        auserlock: {
            type: 'float4',
            nullable: true,
        },
        speculativetoken: {
            nullable: true,
            type: 'float4',
        },
        extend: {
            nullable: true,
            type: 'float4',
        },
        tempbytes: {
            type: 'float4',
            nullable: true,
        },
        virtualxid: {
            nullable: true,
            type: 'float4',
        },
        cursors: {
            nullable: true,
            type: 'float4',
        },
        ProcArrayLock: {
            nullable: true,
            type: 'float4',
        },
        frozenid: {
            type: 'float4',
            nullable: true,
        },
        walinsert: {
            type: 'float4',
            nullable: true,
        },
        fastpathfunctioncall: {
            nullable: true,
            type: 'float4',
        },
        aextend: {
            type: 'float4',
            nullable: true,
        },
        transactionid: {
            nullable: true,
            type: 'float4',
        },
        hpage: {
            nullable: true,
            type: 'float4',
        },
        tupinserted: {
            nullable: true,
            type: 'float4',
        },
        LWLockNamed: {
            type: 'float4',
            nullable: true,
        },
        SerializablePredicateLockListLock: {
            type: 'float4',
            nullable: true,
        },
        WALWriteLock: {
            type: 'float4',
            nullable: true,
        },
        userlock: {
            type: 'float4',
            nullable: true,
        },
        TablespaceCreateLock: {
            nullable: true,
            type: 'float4',
        },
        idleintransaction: {
            type: 'float4',
            nullable: true,
        },
        WrapLimitsVacuumLock: {
            type: 'float4',
            nullable: true,
        },
        RelationMappingLock: {
            nullable: true,
            type: 'float4',
        },
        bufferio: {
            type: 'float4',
            nullable: true,
        },
        AddinShmemInitLock: {
            type: 'float4',
            nullable: true,
        },
        tupdeleted: {
            type: 'float4',
            nullable: true,
        },
        relation: {
            nullable: true,
            type: 'float4',
        },
        WALBufMappingLock: {
            type: 'float4',
            nullable: true,
        },
        commitratio: {
            type: 'float4',
            nullable: true,
        },
        deadlocks: {
            nullable: true,
            type: 'float4',
        },
        SyncScanLock: {
            type: 'float4',
            nullable: true,
        },
        disabled: {
            type: 'float4',
            nullable: true,
        },
        OldSerXidLock: {
            nullable: true,
            type: 'float4',
        },
        clog: {
            type: 'float4',
            nullable: true,
        },
        aobject: {
            type: 'float4',
            nullable: true,
        },
        xactrollback: {
            nullable: true,
            type: 'float4',
        },
        atuple: {
            type: 'float4',
            nullable: true,
        },
        idleintransactionaborted: {
            nullable: true,
            type: 'float4',
        },
        oldserxid: {
            nullable: true,
            type: 'float4',
        },
        tupupdated: {
            nullable: true,
            type: 'float4',
        },
        predicatelockmanager: {
            nullable: true,
            type: 'float4',
        },
        blkshit: {
            nullable: true,
            type: 'float4',
        },
        lockmanager: {
            nullable: true,
            type: 'float4',
        },
        proc: {
            nullable: true,
            type: 'float4',
        },
        CommitTsLock: {
            type: 'float4',
            nullable: true,
        },
        hrelation: {
            nullable: true,
            type: 'float4',
        },
        Lock: {
            nullable: true,
            type: 'float4',
        },
        buffermapping: {
            nullable: true,
            type: 'float4',
        },
        RelCacheInitLock: {
            type: 'float4',
            nullable: true,
        },
        ControlFileLock: {
            type: 'float4',
            nullable: true,
        },
        XidGenLock: {
            type: 'float4',
            nullable: true,
        },
        AutovacuumLock: {
            nullable: true,
            type: 'float4',
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=postgresDb.entity.js.map