"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PowerflexDrive = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.PowerflexDrive = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_powerflex_drive',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read_io: {
            type: 'float4',
            nullable: true,
        },
        write_io: {
            type: 'float4',
            nullable: true,
        },
        io_rate: {
            type: 'float4',
            nullable: true,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        resp_t: {
            type: 'float4',
            nullable: true,
        },
        resp_t_r: {
            type: 'float4',
            nullable: true,
        },
        resp_t_w: {
            type: 'float4',
            nullable: true,
        },
        r_cache_hit: {
            type: 'float4',
            nullable: true,
        },
        rebalance_rate: {
            type: 'float4',
            nullable: true,
        },
        rebuild_rate: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=powerflexDrive.entity.js.map