"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolarisZone = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.SolarisZone = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_solaris_zone',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        total_memory: {
            type: 'float4',
            nullable: true,
        },
        used_memory: {
            type: 'float4',
            nullable: true,
        },
        cpu_used_in_cores: {
            type: 'float4',
            nullable: true,
        },
        cpu_used_in_perc: {
            type: 'float4',
            nullable: true,
        },
        cap_memory_used_in_perc: {
            type: 'float4',
            nullable: true,
        },
        memory_used_in_perc: {
            type: 'float4',
            nullable: true,
        },
        virt_memory_used_in_perc: {
            type: 'float4',
            nullable: true,
        },
        net_used_in_perc: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
    },
});
//# sourceMappingURL=solarisZone.entity.js.map