"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqlserverSqlsfolder = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.SqlserverSqlsfolder = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_sqlserver_sqlsfolder',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        LATCH_UP: {
            nullable: true,
            type: 'float4',
        },
        Readaheadpagessec: {
            type: 'float4',
            nullable: true,
        },
        LATCH_KP: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_RS_S: {
            nullable: true,
            type: 'float4',
        },
        Pagewritessec: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_U: {
            type: 'float4',
            nullable: true,
        },
        WRITELOG: {
            type: 'float4',
            nullable: true,
        },
        Loginssec: {
            type: 'float4',
            nullable: true,
        },
        EXECSYNC: {
            type: 'float4',
            nullable: true,
        },
        PAGELATCH_EX: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_SIU: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_S: {
            nullable: true,
            type: 'float4',
        },
        Readaheadtimesec: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_RX_S: {
            type: 'float4',
            nullable: true,
        },
        FreeMemory: {
            nullable: true,
            type: 'float4',
        },
        PAGEIOLATCH_SH: {
            type: 'float4',
            nullable: true,
        },
        PAGEIOLATCH_KP: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_UIX: {
            nullable: true,
            type: 'float4',
        },
        LATCH_EX: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_BU: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_RX_X: {
            nullable: true,
            type: 'float4',
        },
        ConnectionResetsec: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_RIn_X: {
            nullable: true,
            type: 'float4',
        },
        MSQL_XP: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_SCH_S: {
            nullable: true,
            type: 'float4',
        },
        Targetpages: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_RX_U: {
            nullable: true,
            type: 'float4',
        },
        TotalServerMemory: {
            type: 'float4',
            nullable: true,
        },
        ASYNC_NETWORK_IO: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_IU: {
            type: 'float4',
            nullable: true,
        },
        Extensionallocatedpages: {
            type: 'float4',
            nullable: true,
        },
        PAGELATCH_DT: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_RIn_NL: {
            nullable: true,
            type: 'float4',
        },
        WRITE_COMPLETION: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_IS: {
            type: 'float4',
            nullable: true,
        },
        LATCH_SH: {
            type: 'float4',
            nullable: true,
        },
        RS_SM_QUERY_CMPL: {
            nullable: true,
            type: 'float4',
        },
        Extensionfreepages: {
            type: 'float4',
            nullable: true,
        },
        Logoutssec: {
            nullable: true,
            type: 'float4',
        },
        LATCH_NL: {
            nullable: true,
            type: 'float4',
        },
        TargetServerMemory: {
            type: 'float4',
            nullable: true,
        },
        PAGEIOLATCH_EX: {
            nullable: true,
            type: 'float4',
        },
        Databasepages: {
            nullable: true,
            type: 'float4',
        },
        ReservedServerMemory: {
            nullable: true,
            type: 'float4',
        },
        IO_COMPLETION: {
            nullable: true,
            type: 'float4',
        },
        PAGELATCH_KP: {
            nullable: true,
            type: 'float4',
        },
        PAGELATCH_NL: {
            type: 'float4',
            nullable: true,
        },
        Lazywritessec: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_RIn_U: {
            type: 'float4',
            nullable: true,
        },
        LATCH_DT: {
            type: 'float4',
            nullable: true,
        },
        CXPACKET: {
            type: 'float4',
            nullable: true,
        },
        PAGELATCH_UP: {
            type: 'float4',
            nullable: true,
        },
        SOS_SCHEDULER_YIELD: {
            nullable: true,
            type: 'float4',
        },
        Backgroundwriterpagessec: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_SCH_M: {
            type: 'float4',
            nullable: true,
        },
        PAGELATCH_SH: {
            type: 'float4',
            nullable: true,
        },
        THREADPOOL: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_IX: {
            nullable: true,
            type: 'float4',
        },
        Checkpointpagessec: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_RS_U: {
            type: 'float4',
            nullable: true,
        },
        PAGEIOLATCH_UP: {
            type: 'float4',
            nullable: true,
        },
        Pagereadssec: {
            type: 'float4',
            nullable: true,
        },
        PAGEIOLATCH_DT: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_X: {
            type: 'float4',
            nullable: true,
        },
        PAGEIOLATCH_NL: {
            type: 'float4',
            nullable: true,
        },
        LCK_M_SIX: {
            type: 'float4',
            nullable: true,
        },
        Pagelifeexpectancy: {
            nullable: true,
            type: 'float4',
        },
        LCK_M_RIn_S: {
            nullable: true,
            type: 'float4',
        },
        UserConnections: {
            nullable: true,
            type: 'float4',
        },
        LocksWaitssec: {
            type: 'float4',
            nullable: true,
        },
        LocksRequestssec: {
            type: 'float4',
            nullable: true,
        },
        LockTimeoutssec: {
            type: 'float4',
            nullable: true,
        },
        NumberofDeadlockssec: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=sqlserverSqlsfolder.entity.js.map