"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreoncePool = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.StoreoncePool = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_storeonce_pool',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        read: {
            type: 'float4',
            nullable: true,
        },
        write: {
            type: 'float4',
            nullable: true,
        },
        data_rate: {
            type: 'float4',
            nullable: true,
        },
        read_replication: {
            type: 'float4',
            nullable: true,
        },
        write_replication: {
            type: 'float4',
            nullable: true,
        },
        housekeep_status: {
            type: 'float4',
            nullable: true,
        },
        housekeep_pend_data: {
            type: 'float4',
            nullable: true,
        },
        dedupe_ratio: {
            type: 'float4',
            nullable: true,
        },
        copy_job_read: {
            type: 'float4',
            nullable: true,
        },
        copy_job_write: {
            type: 'float4',
            nullable: true,
        },
        data_job_read: {
            type: 'float4',
            nullable: true,
        },
        data_job_write: {
            type: 'float4',
            nullable: true,
        },
        user_data_store: {
            type: 'float4',
            nullable: true,
        },
        disk_size: {
            type: 'float4',
            nullable: true,
        },
        capacity_total: {
            type: 'float4',
            primary: true,
            nullable: false,
        },
        capacity_used: {
            type: 'float4',
            primary: true,
            nullable: false,
        },
        capacity_free: {
            type: 'float4',
            primary: true,
            nullable: false,
        },
        capacity_used_percent: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        },
        tmp8: {
            type: 'float4',
            nullable: true,
        },
        tmp9: {
            type: 'float4',
            nullable: true,
        },
        tmp10: {
            type: 'float4',
            nullable: true,
        },
        tmp11: {
            type: 'float4',
            nullable: true,
        },
        tmp12: {
            type: 'float4',
            nullable: true,
        },
        tmp13: {
            type: 'float4',
            nullable: true,
        },
        tmp14: {
            type: 'float4',
            nullable: true,
        },
        tmp15: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=storeoncePool.entity.js.map