"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VmwareEsxi = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.VmwareEsxi = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_vmware_esxi',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_alloc: {
            type: 'float4',
            nullable: true,
        },
        cpu_usage: {
            type: 'float4',
            nullable: true,
        },
        host_hz: {
            type: 'float4',
            nullable: true,
        },
        memory_active: {
            type: 'float4',
            nullable: true,
        },
        memory_granted: {
            type: 'float4',
            nullable: true,
        },
        memory_baloon: {
            type: 'float4',
            nullable: true,
        },
        disk_usage: {
            type: 'float4',
            nullable: true,
        },
        disk_read: {
            type: 'float4',
            nullable: true,
        },
        disk_write: {
            type: 'float4',
            nullable: true,
        },
        network_usage: {
            type: 'float4',
            nullable: true,
        },
        network_received: {
            type: 'float4',
            nullable: true,
        },
        network_transmitted: {
            type: 'float4',
            nullable: true,
        },
        memory_swapin: {
            type: 'float4',
            nullable: true,
        },
        memory_swapout: {
            type: 'float4',
            nullable: true,
        },
        memory_compress: {
            type: 'float4',
            nullable: true,
        },
        memory_decompress: {
            type: 'float4',
            nullable: true,
        },
        cpu_utilization_percent: {
            type: 'float4',
            nullable: true,
        },
        memory_host_size: {
            type: 'float4',
            nullable: true,
        },
        cpu_ready: {
            type: 'float4',
            nullable: true,
        },
        power_usage: {
            type: 'float4',
            nullable: true,
        },
        tmp0: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=vmwareEsxi.entity.js.map