"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowsVm = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
exports.WindowsVm = new typeorm_1.EntitySchema({
    schema: 'metrics',
    name: 'metrics_windows_vm',
    columns: {
        time: {
            type: 'timestamp with time zone',
            primary: true,
            nullable: false,
        },
        item_id: {
            type: String,
            primary: true,
            nullable: false,
        },
        cpu_utilization_cores: {
            type: 'float4',
            nullable: true,
        },
        host_hz: {
            type: 'float4',
            nullable: true,
        },
        memory_total: {
            type: 'float4',
            nullable: true,
        },
        memory_used: {
            type: 'float4',
            nullable: true,
        },
        disk_bytes_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_read_bytes_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_reads_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_tranfers_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_write_bytes_persec: {
            type: 'float4',
            nullable: true,
        },
        disk_writes_persec: {
            type: 'float4',
            nullable: true,
        },
        bytes_received_persec: {
            type: 'float4',
            nullable: true,
        },
        bytes_sent_persec: {
            type: 'float4',
            nullable: true,
        },
        bytes_total_persec: {
            type: 'float4',
            nullable: true,
        },
        vmCPU: {
            type: 'float4',
            nullable: true,
        },
        cpu_usage_perc: {
            type: 'float4',
            nullable: true,
        },
        tmp1: {
            type: 'float4',
            nullable: true,
        },
        tmp2: {
            type: 'float4',
            nullable: true,
        },
        tmp3: {
            type: 'float4',
            nullable: true,
        },
        tmp4: {
            type: 'float4',
            nullable: true,
        },
        tmp5: {
            type: 'float4',
            nullable: true,
        },
        tmp6: {
            type: 'float4',
            nullable: true,
        },
        tmp7: {
            type: 'float4',
            nullable: true,
        }
    },
});
//# sourceMappingURL=windowsVm.entity.js.map