"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectItem = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const alertingGroup_entity_1 = require("./alertingGroup.entity");
const alertingLaunch_entity_1 = require("./alertingLaunch.entity");
const itemGroupItem_entity_1 = require("./itemGroupItem.entity");
const itemGroupParent_entity_1 = require("./itemGroupParent.entity");
const healthStatus_entity_1 = require("./healthStatus.entity");
const healthStatusHistory_entity_1 = require("./healthStatusHistory.entity");
const heatmap_entity_1 = require("./heatmap.entity");
const heatmapTierItem_entity_1 = require("./heatmapTierItem.entity");
const hostcfgRelation_entity_1 = require("./hostcfgRelation.entity");
const hwType_entity_1 = require("./hwType.entity");
const itemProperty_entity_1 = require("./itemProperty.entity");
const itemRelation_entity_1 = require("./itemRelation.entity");
const storageGroupDevice_entity_1 = require("./storageGroupDevice.entity");
const storageMapping_entity_1 = require("./storageMapping.entity");
const top_entity_1 = require("./top.entity");
const healthStatusMirror_entity_1 = require("./healthStatusMirror.entity");
const agentMapping_entity_1 = require("./agentMapping.entity");
const serverGroupItems_entity_1 = require("./serverGroupItems.entity");
const tagValueItem_entity_1 = require("./tagValueItem.entity");
const alertingHistoryItem_entity_1 = require("./alertingHistoryItem.entity");
let ObjectItem = class ObjectItem {
    static _OPENAPI_METADATA_FACTORY() {
        return { item_id: { required: true, type: () => String }, label: { required: true, type: () => String }, alias: { required: false, type: () => String }, object_id: { required: true, type: () => String }, hw_type_entity: { required: false, type: () => require("./hwType.entity").HwType }, hw_type: { required: true, type: () => String }, subsystem: { required: true, type: () => String }, hasAgent: { required: false, type: () => Boolean }, createdAt: { required: false, type: () => Date }, updatedAt: { required: false, type: () => Date }, deletedAt: { required: false, type: () => Date }, storage_group_devices: { required: false, type: () => [require("./storageGroupDevice.entity").StorageGroupDevice] }, server_group_items: { required: false, type: () => [require("./serverGroupItems.entity").ServerGroupItems] }, mappings: { required: false, type: () => [require("./storageMapping.entity").StorageMapping] }, top: { required: false, type: () => [require("./top.entity").Top] }, properties: { required: false, type: () => [require("./itemProperty.entity").ItemProperty] }, children: { required: false, type: () => [require("./itemRelation.entity").ItemRelation] }, parents: { required: false, type: () => [require("./itemRelation.entity").ItemRelation] }, agent: { required: false, type: () => require("./agentMapping.entity").AgentMapping }, agent_host: { required: false, type: () => require("./agentMapping.entity").AgentMapping }, hostcfg_relations: { required: false, type: () => [require("./hostcfgRelation.entity").HostcfgRelation] }, health_status: { required: false, type: () => [require("./healthStatus.entity").HealthStatus] }, health_status_history: { required: false, type: () => [require("./healthStatusHistory.entity").HealthStatusHistory] }, heatmaps: { required: false, type: () => [require("./heatmap.entity").Heatmap] }, alerting_group_children: { required: false, type: () => [require("./alertingGroup.entity").AlertingGroup] }, heatmap_tier_item: { required: false, type: () => require("./heatmapTierItem.entity").HeatmapTierItem }, alerting_launches: { required: false, type: () => [require("./alertingLaunch.entity").AlertingLaunch] }, item_group_items: { required: false, type: () => [require("./itemGroupItem.entity").ItemGroupItem] }, item_group_parents: { required: false, type: () => [require("./itemGroupParent.entity").ItemGroupParent] }, tag_value_items: { required: false, type: () => [require("./tagValueItem.entity").TagValueItem] }, _mirrorItems: { required: false, type: () => [require("./healthStatusMirror.entity").HealthStatusMirror] }, _alerting_history_items: { required: false, type: () => [require("./alertingHistoryItem.entity").AlertingHistoryItem] } };
    }
};
exports.ObjectItem = ObjectItem;
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], ObjectItem.prototype, "item_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ObjectItem.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)({
        nullable: true
    }),
    __metadata("design:type", String)
], ObjectItem.prototype, "alias", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ObjectItem.prototype, "object_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => hwType_entity_1.HwType, (hwType) => hwType.object_items, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'hw_type' }),
    __metadata("design:type", hwType_entity_1.HwType)
], ObjectItem.prototype, "hw_type_entity", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ObjectItem.prototype, "hw_type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ObjectItem.prototype, "subsystem", void 0);
__decorate([
    (0, typeorm_1.Column)('boolean', { default: false, name: 'has_agent' }),
    __metadata("design:type", Boolean)
], ObjectItem.prototype, "hasAgent", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ name: 'created_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], ObjectItem.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ name: 'updated_at', type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], ObjectItem.prototype, "updatedAt", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)({ name: 'deleted_at', type: 'timestamp with time zone', nullable: true }),
    __metadata("design:type", Date)
], ObjectItem.prototype, "deletedAt", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => storageGroupDevice_entity_1.StorageGroupDevice, (storageGroupDevice) => storageGroupDevice._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "storage_group_devices", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => serverGroupItems_entity_1.ServerGroupItems, (serverGroupItem) => serverGroupItem._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "server_group_items", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => storageMapping_entity_1.StorageMapping, (storageMapping) => storageMapping._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "mappings", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => top_entity_1.Top, (top) => top._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "top", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemProperty_entity_1.ItemProperty, (itemProperties) => itemProperties._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "properties", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemRelation_entity_1.ItemRelation, (itemRelations) => itemRelations._parent),
    __metadata("design:type", Array)
], ObjectItem.prototype, "children", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemRelation_entity_1.ItemRelation, (itemRelations) => itemRelations._child),
    __metadata("design:type", Array)
], ObjectItem.prototype, "parents", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => agentMapping_entity_1.AgentMapping, (agentMappings) => agentMappings._item),
    __metadata("design:type", agentMapping_entity_1.AgentMapping)
], ObjectItem.prototype, "agent", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => agentMapping_entity_1.AgentMapping, (agentMappings) => agentMappings._agent),
    __metadata("design:type", agentMapping_entity_1.AgentMapping)
], ObjectItem.prototype, "agent_host", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => hostcfgRelation_entity_1.HostcfgRelation, (hostcfgRelations) => hostcfgRelations._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "hostcfg_relations", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => healthStatus_entity_1.HealthStatus, (healthStatus) => healthStatus._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "health_status", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => healthStatusHistory_entity_1.HealthStatusHistory, (healthStatusHistory) => healthStatusHistory._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "health_status_history", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => heatmap_entity_1.Heatmap, (heatmap) => heatmap._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "heatmaps", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingGroup_entity_1.AlertingGroup, (alerting_group) => alerting_group._item_group),
    __metadata("design:type", Array)
], ObjectItem.prototype, "alerting_group_children", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => heatmapTierItem_entity_1.HeatmapTierItem, (heatmapTierItem) => heatmapTierItem._item),
    __metadata("design:type", heatmapTierItem_entity_1.HeatmapTierItem)
], ObjectItem.prototype, "heatmap_tier_item", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingLaunch_entity_1.AlertingLaunch, (alertingLaunch) => alertingLaunch._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "alerting_launches", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupItem_entity_1.ItemGroupItem, (itemGroupItem) => itemGroupItem._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "item_group_items", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => itemGroupParent_entity_1.ItemGroupParent, (itemGroupParent) => itemGroupParent._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "item_group_parents", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => tagValueItem_entity_1.TagValueItem, (tagValueItem) => tagValueItem._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "tag_value_items", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => healthStatusMirror_entity_1.HealthStatusMirror, (mirror) => mirror._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "_mirrorItems", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => alertingHistoryItem_entity_1.AlertingHistoryItem, (alertingHistoryItem) => alertingHistoryItem._item),
    __metadata("design:type", Array)
], ObjectItem.prototype, "_alerting_history_items", void 0);
exports.ObjectItem = ObjectItem = __decorate([
    (0, typeorm_1.Entity)({ name: 'object_items', synchronize: false }),
    (0, typeorm_1.Index)(["hw_type", "subsystem"])
], ObjectItem);
//# sourceMappingURL=objectItem.entity.js.map