"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Report = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const reportItem_entity_1 = require("./reportItem.entity");
const reportFile_entity_1 = require("./reportFile.entity");
const mailGroup_entity_1 = require("./mailGroup.entity");
const report_elements_1 = require("../common/elements/report.elements");
const user_entity_1 = require("./user.entity");
let Report = class Report {
    static _OPENAPI_METADATA_FACTORY() {
        return { report_id: { required: true, type: () => String }, label: { required: true, type: () => String }, recurrence: { required: true, type: () => require("../common/elements/report.elements").RecurrenceElement, nullable: true }, last_run_at: { required: true, type: () => Date, nullable: true }, created_at: { required: true, type: () => Date }, updated_at: { required: true, type: () => Date }, user_id: { required: true, type: () => Number }, created_by: { required: false, type: () => require("./user.entity").User }, disabled: { required: true, type: () => Boolean }, on_generate_create_report_file: { required: true, type: () => Boolean }, report_items: { required: false, type: () => [require("./reportItem.entity").ReportItem] }, report_files: { required: false, type: () => [require("./reportFile.entity").ReportFile] }, mail_groups: { required: false, type: () => [require("./mailGroup.entity").MailGroup] } };
    }
};
exports.Report = Report;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], Report.prototype, "report_id", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: 'unlabeled',
    }),
    __metadata("design:type", String)
], Report.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'jsonb',
        default: null,
        nullable: true
    }),
    __metadata("design:type", report_elements_1.RecurrenceElement)
], Report.prototype, "recurrence", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'timestamp with time zone',
        default: null,
        nullable: true
    }),
    __metadata("design:type", Date)
], Report.prototype, "last_run_at", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], Report.prototype, "created_at", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: 'timestamp with time zone' }),
    __metadata("design:type", Date)
], Report.prototype, "updated_at", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], Report.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_reports, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], Report.prototype, "created_by", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: false }),
    __metadata("design:type", Boolean)
], Report.prototype, "disabled", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: true }),
    __metadata("design:type", Boolean)
], Report.prototype, "on_generate_create_report_file", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => reportItem_entity_1.ReportItem, (report_item) => report_item.report),
    __metadata("design:type", Array)
], Report.prototype, "report_items", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => reportFile_entity_1.ReportFile, (report_file) => report_file.report),
    __metadata("design:type", Array)
], Report.prototype, "report_files", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => mailGroup_entity_1.MailGroup, { cascade: true }),
    (0, typeorm_1.JoinTable)({
        name: 'reports_mail_groups',
        joinColumn: {
            name: 'report_id',
            referencedColumnName: 'report_id',
        },
        inverseJoinColumn: {
            name: 'mail_group_id',
            referencedColumnName: 'mail_group_id',
        },
    }),
    __metadata("design:type", Array)
], Report.prototype, "mail_groups", void 0);
exports.Report = Report = __decorate([
    (0, typeorm_1.Entity)({ name: 'reports', synchronize: false })
], Report);
//# sourceMappingURL=report.entity.js.map