"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StorageGroup = void 0;
const openapi = require("@nestjs/swagger");
const typeorm_1 = require("typeorm");
const storageGroupDevice_entity_1 = require("./storageGroupDevice.entity");
const storageGroupRegex_entity_1 = require("./storageGroupRegex.entity");
const user_entity_1 = require("./user.entity");
const group_entity_1 = require("./group.entity");
let StorageGroup = class StorageGroup {
    static _OPENAPI_METADATA_FACTORY() {
        return { storage_group_id: { required: true, type: () => String }, label: { required: true, type: () => String }, description: { required: true, type: () => String }, user_id: { required: true, type: () => Number }, created_by: { required: false, type: () => require("./user.entity").User }, storage_group_devices: { required: false, type: () => [require("./storageGroupDevice.entity").StorageGroupDevice] }, storage_group_regex: { required: false, type: () => [require("./storageGroupRegex.entity").StorageGroupRegex] }, group_id: { required: true, type: () => Number }, _group: { required: false, type: () => require("./group.entity").Group } };
    }
};
exports.StorageGroup = StorageGroup;
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], StorageGroup.prototype, "storage_group_id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], StorageGroup.prototype, "label", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], StorageGroup.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], StorageGroup.prototype, "user_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => user_entity_1.User, (user) => user.created_storage_groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'user_id' }),
    __metadata("design:type", user_entity_1.User)
], StorageGroup.prototype, "created_by", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => storageGroupDevice_entity_1.StorageGroupDevice, (storageGroupDevice) => storageGroupDevice._storage_group),
    __metadata("design:type", Array)
], StorageGroup.prototype, "storage_group_devices", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => storageGroupRegex_entity_1.StorageGroupRegex, (storageGroupRegex) => storageGroupRegex._storage_group),
    __metadata("design:type", Array)
], StorageGroup.prototype, "storage_group_regex", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], StorageGroup.prototype, "group_id", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => group_entity_1.Group, (group) => group._storage_groups, { cascade: true, onDelete: 'CASCADE' }),
    (0, typeorm_1.JoinColumn)({ name: 'group_id' }),
    __metadata("design:type", group_entity_1.Group)
], StorageGroup.prototype, "_group", void 0);
exports.StorageGroup = StorageGroup = __decorate([
    (0, typeorm_1.Entity)({ name: 'storage_groups', synchronize: false })
], StorageGroup);
//# sourceMappingURL=storageGroup.entity.js.map