"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminRolesGuard = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const User_1 = require("../service/users/User");
const dataSource_1 = require("../config/dataSource");
const adminGroup_entity_1 = require("../entity/adminGroup.entity");
const adminGroups_constants_1 = require("../common/constants/adminGroups.constants");
const Architecture_1 = require("../service/architecture/Architecture");
let AdminRolesGuard = class AdminRolesGuard {
    constructor(reflector) {
        this.reflector = reflector;
    }
    async canActivate(context) {
        const rulesRepository = (0, dataSource_1.getDataSource)().getRepository(adminGroup_entity_1.AdminGroup);
        const request = context.switchToHttp().getRequest();
        const response = context.switchToHttp().getResponse();
        const user = await User_1.User.getUserByRequest(request, true);
        const groupIds = user.groups.map((group) => group.group_id);
        const url = new URL('https://do.not.care' + response.req.url);
        const classParam = url.searchParams.get('class');
        const hwTypeParam = url.searchParams.get('hw_type');
        const hwTypeEntry = await Architecture_1.Architecture.getHwType(hwTypeParam);
        const classValue = classParam ? classParam : hwTypeEntry.class.toString();
        const hwTypeValue = hwTypeParam;
        for (let groupId of groupIds) {
            if (groupId == 1) {
                return true;
            }
            else {
                const classRules = await rulesRepository.find({ relations: { group: true }, where: { group: { group_id: groupId }, type: adminGroups_constants_1.RULE_TYPE.CLASS } });
                for (let rule of classRules) {
                    if (rule.value && rule.value == classValue) {
                        return true;
                    }
                }
                const hwTypeRules = await rulesRepository.find({ relations: { group: true }, where: { group: { group_id: groupId }, type: adminGroups_constants_1.RULE_TYPE.HWTYPE } });
                for (let rule of hwTypeRules) {
                    if (rule.value && rule.value == hwTypeValue) {
                        return true;
                    }
                }
            }
        }
        return false;
    }
};
exports.AdminRolesGuard = AdminRolesGuard;
exports.AdminRolesGuard = AdminRolesGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.Reflector])
], AdminRolesGuard);
//# sourceMappingURL=adminRoles.guard.js.map