"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const typeorm_1 = require("@nestjs/typeorm");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const configuration_controller_1 = require("./configuration.controller");
const configuration_service_1 = require("./configuration.service");
const db_config_1 = require("./db.config");
const token_middleware_1 = require("../middleware/token.middleware");
const itemProperty_entity_1 = require("../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../entity/itemRelation.entity");
const agentMapping_entity_1 = require("../entity/agentMapping.entity");
const storageMapping_entity_1 = require("../entity/storageMapping.entity");
const objectItem_entity_1 = require("../entity/objectItem.entity");
const healthStatus_entity_1 = require("../entity/healthStatus.entity");
const hostcfgRelation_entity_1 = require("../entity/hostcfgRelation.entity");
const heatmap_entity_1 = require("../entity/heatmap.entity");
const hostcfg_entity_1 = require("../entity/hostcfg.entity");
const metricsTable_service_1 = require("../service/metrics/metricsTable.service");
const healthStatus_service_1 = require("./healthStatus.service");
const healthStatus_controller_1 = require("./healthStatus.controller");
const healthStatusMirror_entity_1 = require("../entity/healthStatusMirror.entity");
const consistencyGroup_entity_1 = require("../entity/consistencyGroup.entity");
const healtStatusMirror_service_1 = require("./healtStatusMirror.service");
const healthStatusMirror_controller_1 = require("./healthStatusMirror.controller");
const hostcfgStatus_entity_1 = require("../entity/hostcfgStatus.entity");
const mail_module_1 = require("../mail/mail.module");
const setting_entity_1 = require("../entity/setting.entity");
const alertingHwEmail_entity_1 = require("../entity/alertingHwEmail.entity");
const healthStatusHistory_entity_1 = require("../entity/healthStatusHistory.entity");
const mailGroup_entity_1 = require("../entity/mailGroup.entity");
const Crypto_1 = require("../service/configuration/Crypto");
const top_entity_1 = require("../entity/top.entity");
const proxy_controller_1 = require("./proxy.controller");
const mapping_service_1 = require("./mapping.service");
const mapping_controller_1 = require("./mapping.controller");
const healthStatusMirrorRel_entity_1 = require("../entity/healthStatusMirrorRel.entity");
const imports = [
    typeorm_1.TypeOrmModule.forRootAsync({
        inject: [config_1.ConfigService],
        useFactory: async (configService) => ({ ...configService.get('database') }),
    }),
    typeorm_1.TypeOrmModule.forFeature([
        itemProperty_entity_1.ItemProperty,
        itemRelation_entity_1.ItemRelation,
        objectItem_entity_1.ObjectItem,
        agentMapping_entity_1.AgentMapping,
        storageMapping_entity_1.StorageMapping,
        hostcfgRelation_entity_1.HostcfgRelation,
        healthStatus_entity_1.HealthStatus,
        healthStatusHistory_entity_1.HealthStatusHistory,
        heatmap_entity_1.Heatmap,
        hostcfg_entity_1.HostCfg,
        healthStatusMirror_entity_1.HealthStatusMirror,
        healthStatusMirrorRel_entity_1.HealthStatusMirrorRel,
        consistencyGroup_entity_1.ConsistencyGroup,
        hostcfgStatus_entity_1.HostcfgStatus,
        setting_entity_1.Setting,
        alertingHwEmail_entity_1.AlertingHwEmail,
        mailGroup_entity_1.MailGroup,
        Crypto_1.Crypto,
        top_entity_1.Top
    ]),
    mail_module_1.MailModule,
    config_1.ConfigModule.forRoot({ isGlobal: true, load: [db_config_1.default] }),
];
let AppModule = class AppModule {
    configure(consumer) {
        consumer
            .apply(token_middleware_1.TokenMiddleware)
            .forRoutes({ path: '*', method: common_1.RequestMethod.ALL });
    }
};
exports.AppModule = AppModule;
exports.AppModule = AppModule = __decorate([
    (0, common_1.Module)({
        imports: imports,
        controllers: [app_controller_1.AppController, configuration_controller_1.ConfigurationController, healthStatus_controller_1.HealthStatusController, healthStatusMirror_controller_1.HealthStatusMirrorController, mapping_controller_1.MappingController, proxy_controller_1.ProxyController],
        providers: [app_service_1.AppService, configuration_service_1.ConfigurationService, metricsTable_service_1.MetricsTableService, healthStatus_service_1.HealthStatusService, healtStatusMirror_service_1.HealthStatusMirrorService, mapping_service_1.MappingService],
    })
], AppModule);
//# sourceMappingURL=app.module.js.map