"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusMirrorController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const healtStatusMirror_service_1 = require("./healtStatusMirror.service");
const healthStatusMirror_dto_1 = require("../common/healthStatusMirror.dto");
const xormon_exception_1 = require("../exception/xormon.exception");
let HealthStatusMirrorController = class HealthStatusMirrorController {
    constructor(healthStatusMirrorService) {
        this.healthStatusMirrorService = healthStatusMirrorService;
    }
    async insertGroupAndMirrors(mirrors) {
        try {
            await this.healthStatusMirrorService.insertHealthStatusMirror(mirrors.mirrors, mirrors.consistencyGroups);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: "Successfuly saved mirrors."
            };
        }
        catch (error) {
            console.error(error);
            throw new xormon_exception_1.XormonException("Error while saving mirrors: " + error, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
};
exports.HealthStatusMirrorController = HealthStatusMirrorController;
__decorate([
    (0, common_1.Post)("v1/group/mirrors"),
    openapi.ApiResponse({ status: 201, type: require("../common/basicResponse.dto").BasicResponseDTO }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [healthStatusMirror_dto_1.MirrorsDTO]),
    __metadata("design:returntype", Promise)
], HealthStatusMirrorController.prototype, "insertGroupAndMirrors", null);
exports.HealthStatusMirrorController = HealthStatusMirrorController = __decorate([
    (0, swagger_1.ApiTags)('Health Status Mirror'),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_1.Controller)('api/health_status_mirror'),
    __metadata("design:paramtypes", [healtStatusMirror_service_1.HealthStatusMirrorService])
], HealthStatusMirrorController);
//# sourceMappingURL=healthStatusMirror.controller.js.map