"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var TokenMiddleware_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenMiddleware = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const App_1 = require("../service/configuration/App");
let TokenMiddleware = TokenMiddleware_1 = class TokenMiddleware {
    constructor(configService) {
        this.configService = configService;
        this.logger = new common_1.Logger(TokenMiddleware_1.name);
        this.debug = configService.get('APP_DEBUG');
    }
    async use(req, res, next) {
        if (req.session && req.session['userId']) {
            next();
        }
        else {
            const secret = App_1.App.getSecret();
            const jwt = require('jsonwebtoken');
            if (req.cookies && req.cookies['xormon-token'] || (req.header('authorization') && req.header('authorization').includes('Bearer'))) {
                const codedToken = req.cookies && req.cookies['xormon-token'] ? req.cookies['xormon-token'] : req.header('authorization').replace('Bearer ', '');
                try {
                    const decoded = await jwt.verify(codedToken, secret);
                    if (!decoded.username && !decoded.email && !decoded.microservice && !decoded.proxy) {
                        res.status(common_1.HttpStatus.UNAUTHORIZED).send({
                            statusCode: common_1.HttpStatus.UNAUTHORIZED,
                            error: 'Unauthorized access',
                            message: 'Bad scope',
                        });
                    }
                    next();
                }
                catch (err) {
                    res.status(common_1.HttpStatus.UNAUTHORIZED).send({
                        statusCode: common_1.HttpStatus.UNAUTHORIZED,
                        error: 'Unauthorized access',
                        message: 'Bad token',
                    });
                }
            }
            else {
                res.status(common_1.HttpStatus.UNAUTHORIZED).send({
                    statusCode: common_1.HttpStatus.UNAUTHORIZED,
                    error: 'Unauthorized access',
                    message: 'Missing token',
                });
            }
        }
    }
};
exports.TokenMiddleware = TokenMiddleware;
exports.TokenMiddleware = TokenMiddleware = TokenMiddleware_1 = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [config_1.ConfigService])
], TokenMiddleware);
//# sourceMappingURL=token.middleware.js.map