"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindowsPerfTableFix1714719333725 = void 0;
const DatabaseHelper_1 = require("../../config/DatabaseHelper");
const TableGenerator_1 = require("../../service/metrics/TableGenerator");
class WindowsPerfTableFix1714719333725 {
    constructor() {
        this.name = 'WindowsPerfTableFix1714719333725';
    }
    async up(queryRunner) {
        const tables = [
            'metrics_windows_vm',
            'metrics_windows_server',
            'metrics_windows_cluster',
            'metrics_windows_job',
            'metrics_windows_fixed_disk'
        ];
        for (const table of tables) {
            if (queryRunner.hasTable(`metrics.${table}`)) {
                await DatabaseHelper_1.DatabaseHelper.deletePerfTable(table, queryRunner);
                const entity = queryRunner.connection.entityMetadatas.find(e => e.tableName === table);
                if (entity) {
                    await TableGenerator_1.TableGenerator.createPerformanceTableFromEntity(entity);
                }
            }
        }
    }
    async down(queryRunner) { }
}
exports.WindowsPerfTableFix1714719333725 = WindowsPerfTableFix1714719333725;
//# sourceMappingURL=1714719333725-WindowsPerfTableFix.migration.js.map