"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HwEventEntity1720695465388 = void 0;
class HwEventEntity1720695465388 {
    constructor() {
        this.name = 'HwEventEntity1720695465388';
    }
    async up(queryRunner) {
        await queryRunner.query(`
    CREATE TABLE IF NOT EXISTS public.device_group_hw_alerting (
      device_group_id uuid PRIMARY KEY DEFAULT uuid_generate_v4(),
      label varchar NOT NULL,
      class varchar NULL,
      hw_type varchar NULL,
      subsystem varchar NULL,
      enabled boolean DEFAULT true,
      user_id integer NOT NULL,
      item_group_id uuid,
      created_at TIMESTAMPTZ DEFAULT CURRENT_TIMESTAMP,
      CONSTRAINT fk_item_group FOREIGN KEY(item_group_id) REFERENCES public.item_groups(item_group_id),
      CONSTRAINT fk_user FOREIGN KEY(user_id) REFERENCES public.users(user_id) ON DELETE CASCADE
    );
  `);
        await queryRunner.query(`
    CREATE TABLE IF NOT EXISTS public.device_group_hw_alerting_mail_group (
      mail_group_id integer NOT NULL,
      device_group_id uuid NOT NULL,
      PRIMARY KEY (device_group_id, mail_group_id),
      CONSTRAINT fk_device_group FOREIGN KEY(device_group_id) REFERENCES public.device_group_hw_alerting(device_group_id) ON DELETE CASCADE,
      CONSTRAINT fk_hostcfg FOREIGN KEY(mail_group_id) REFERENCES public.mail_groups(mail_group_id) ON DELETE CASCADE
    );
  `);
    }
    async down(queryRunner) {
        await queryRunner.query(`
      DROP TABLE IF EXISTS public.device_group_hw_alerting_mail_group;
    `);
        await queryRunner.query(`
      DROP TABLE IF EXISTS public.device_group_hw_alerting;
    `);
    }
}
exports.HwEventEntity1720695465388 = HwEventEntity1720695465388;
//# sourceMappingURL=1720695465388-HwEventEntity.migration.js.map