"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagV2Refactor1723025403036 = void 0;
class TagV2Refactor1723025403036 {
    constructor() {
        this.name = 'TagV2Refactor1723025403036';
    }
    async up(queryRunner) {
        await queryRunner.query(`
    ALTER TABLE public.tags RENAME TO tags_legacy;
    `);
        await queryRunner.query(`
    ALTER TABLE public.tag_items RENAME TO tag_items_legacy;
    `);
        await queryRunner.query(`
      DROP TABLE IF EXISTS public.tags;
    `);
        await queryRunner.query(`
    CREATE TABLE public.tags (
      tag_id uuid DEFAULT uuid_generate_v4() NOT NULL,
      "label" varchar NOT NULL,
      user_id int4 NULL,
      created_at timestamptz DEFAULT now() NOT NULL,
      updated_at timestamptz DEFAULT now() NOT NULL,
      include_self bool DEFAULT false NOT NULL,
      CONSTRAINT "PK_06a35221325edeb80ad2ec1ff86" PRIMARY KEY (tag_id)
    );
    CREATE UNIQUE INDEX "IDX_c3f918aeb3a1bba2e46f594580" ON public.tags USING btree (label);
    
    -- public.tags foreign keys
    
    ALTER TABLE public.tags ADD CONSTRAINT "FK_74603743868d1e4f4fc2c0225b7" FOREIGN KEY (user_id) REFERENCES public.users(user_id) ON DELETE CASCADE;

  `);
        await queryRunner.query(`

    CREATE TABLE public.tag_values (
      tag_value_id uuid NOT NULL DEFAULT uuid_generate_v4(),
      value varchar NOT NULL,
      user_id int4 NULL,
      created_at timestamptz NOT NULL DEFAULT now(),
      updated_at timestamptz NOT NULL DEFAULT now(),
      tag_id uuid NOT NULL,
      CONSTRAINT "PK_6536e11ef4ee26dc526b7bff09b" PRIMARY KEY (tag_value_id)
    );


    -- public.tag_values foreign keys

    ALTER TABLE public.tag_values ADD CONSTRAINT "FK_53588569df06a5d9b2c19b84788" FOREIGN KEY (user_id) REFERENCES public.users(user_id) ON DELETE CASCADE;
    ALTER TABLE public.tag_values ADD CONSTRAINT "FK_8af9655f9dae949f78652a3a4ba" FOREIGN KEY (tag_id) REFERENCES public.tags(tag_id) ON DELETE CASCADE;
  
  `);
        await queryRunner.query(`

  CREATE TABLE public.tag_value_items (
    tag_value_item_id uuid NOT NULL DEFAULT uuid_generate_v4(),
    item_id varchar NOT NULL,
    tag_value_id uuid NOT NULL,
    created_at timestamptz NOT NULL DEFAULT now(),
    CONSTRAINT "PK_098a3a1a83572460c175a319c57" PRIMARY KEY (tag_value_item_id)
  );


  -- public.tag_value_items foreign keys

  ALTER TABLE public.tag_value_items ADD CONSTRAINT "FK_16a018956879667e8d86cb39ad3" FOREIGN KEY (tag_value_id) REFERENCES public.tag_values(tag_value_id) ON DELETE CASCADE;
  ALTER TABLE public.tag_value_items ADD CONSTRAINT "FK_9e016c111562f36e79328fa38dd" FOREIGN KEY (item_id) REFERENCES public.object_items(item_id) ON DELETE CASCADE;
    
  `);
    }
    async down(queryRunner) {
        await queryRunner.query(`
      DROP TABLE public.tag_value_items;
    `);
        await queryRunner.query(`
      DROP TABLE public.tag_values;
    `);
        await queryRunner.query(`
    DROP TABLE public.tags;
    `);
        await queryRunner.query(`
    ALTER TABLE public.tags_legacy RENAME TO tags;
    `);
        await queryRunner.query(`
    ALTER TABLE public.tag_items_legacy RENAME TO tag_items;
    `);
    }
}
exports.TagV2Refactor1723025403036 = TagV2Refactor1723025403036;
//# sourceMappingURL=1723025403036-TagV2Refactor.migration.js.map