"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedoMirror1723033123493 = void 0;
class RedoMirror1723033123493 {
    constructor() {
        this.name = 'RedoMirror1723033123493';
    }
    async up(queryRunner) {
        await queryRunner.dropTable("health_status_mirror");
        await queryRunner.dropTable("health_status_mirror_history");
        await queryRunner.dropTable("consistency_groups");
        await queryRunner.query(`CREATE TABLE public.consistency_groups (
      consistency_group_id varchar NOT NULL,
      "label" varchar NOT NULL,
      "mode" varchar NULL,
      status varchar NULL,
      syncing_lvl varchar NULL,
      "role" varchar NULL,
      CONSTRAINT "PK_67f98dde880049bbce16727e577" PRIMARY KEY (consistency_group_id, label)
    );`);
        await queryRunner.query(`
      CREATE TABLE "health_status_mirror_rel"(
          "source_vol_id" VARCHAR(255) NOT NULL,
          "source_hostcfg_id" VARCHAR(255) NOT NULL,
          "target_vol_id" VARCHAR(255) NOT NULL,
          "target_hostcfg_id" VARCHAR(255) NULL,
          "system_name" VARCHAR(255) NOT NULL,
          "remote_system_name" VARCHAR(255) NOT NULL,
          "consistency_group_id" varchar NULL,
          "consistency_group_label" varchar NULL,
          "type_state" VARCHAR(255) NOT NULL,
          "severity" int NOT NULL,
          "freeze_time" INTEGER NULL,
          "progress" INTEGER,
          "created_at" TIMESTAMP(0) WITH
              TIME zone NOT NULL DEFAULT NOW(),
          "updated_at" TIMESTAMP(0) WITH
              TIME zone NOT NULL DEFAULT NOW()
      );
      CREATE INDEX "health_status_mirror_rel_source_vol_id_target_vol_id_remote_system_name_index" ON
          "health_status_mirror_rel"(
              "source_vol_id",
              "target_vol_id",
              "remote_system_name"
          );
      ALTER TABLE
          "health_status_mirror_rel" ADD PRIMARY KEY("source_vol_id", "source_hostcfg_id", "target_vol_id");
      CREATE TABLE "health_status_mirror"(
          "vol_id" VARCHAR(255) NOT NULL,
          "hostcfg_id" VARCHAR(255) NOT NULL,
          "item_id" VARCHAR(255) NOT NULL,
          "created_at" TIMESTAMP(0) WITH
              TIME zone NOT NULL DEFAULT NOW(),
          "updated_at" TIMESTAMP(0) WITH
              TIME zone NOT NULL DEFAULT NOW()
      );
      ALTER TABLE
          "health_status_mirror" ADD PRIMARY KEY("vol_id", "hostcfg_id");
      ALTER TABLE
          "health_status_mirror"ADD CONSTRAINT "health_status_mirror_consistency_group_id_foreign" FOREIGN KEY("item_id") REFERENCES "object_items"("item_id") ON DELETE CASCADE;
      ALTER TABLE
          "health_status_mirror" ADD CONSTRAINT "health_status_mirror_object_items_id_foreign" FOREIGN KEY("item_id") REFERENCES "object_items"("item_id") ON DELETE CASCADE;
      ALTER TABLE
          "health_status_mirror_rel" ADD CONSTRAINT "health_status_mirror_rel_consistency_group_id_foreign" FOREIGN KEY("consistency_group_id", "consistency_group_label") REFERENCES "consistency_groups"("consistency_group_id", "label") ON DELETE CASCADE;
      ALTER TABLE
          "health_status_mirror_rel" ADD CONSTRAINT "health_status_mirror_rel_consistency_source_fk" FOREIGN KEY("source_vol_id", "source_hostcfg_id") REFERENCES "health_status_mirror"("vol_id", "hostcfg_id") ON DELETE CASCADE;
      ALTER TABLE
          "health_status_mirror_rel" ADD CONSTRAINT "health_status_mirror_rel_consistency_target_fk" FOREIGN KEY("target_vol_id", "target_hostcfg_id") REFERENCES "health_status_mirror"("vol_id", "hostcfg_id") ON DELETE CASCADE;

    `);
    }
    async down(queryRunner) {
        await queryRunner.dropTable("health_status_mirror_rel");
        await queryRunner.dropTable("health_status_mirror");
        await queryRunner.dropTable("consistency_groups");
        await queryRunner.query(`CREATE TABLE public.consistency_groups (
      consistency_group_id uuid DEFAULT uuid_generate_v4() NOT NULL,
      "label" varchar NOT NULL,
      "mode" varchar NULL,
      status varchar NULL,
      syncing_lvl varchar NULL,
      "role" varchar NULL,
      CONSTRAINT "PK_67f98dde880049bbce16727e577" PRIMARY KEY (consistency_group_id)
    );`);
        await queryRunner.query(`CREATE TABLE public.health_status_mirror (
      source_item varchar NOT NULL,
      target_item varchar NOT NULL,
      consistency_group_id uuid NULL,
      "type" varchar NOT NULL,
      state varchar NOT NULL,
      freeze_time int4 NULL,
      created_at timestamp DEFAULT now() NOT NULL,
      updated_at timestamp NULL,
      CONSTRAINT "PK_57a009886f97c8cc3d7608eb40a" PRIMARY KEY (source_item, target_item),
      CONSTRAINT "FK_HEALTH_STATUS_MIRROR_ON_CONSISTENCY_GROUP" FOREIGN KEY (consistency_group_id) REFERENCES public.consistency_groups(consistency_group_id),
      CONSTRAINT "FK_HEALTH_STATUS_MIRROR_ON_SOURCE_OBJECT_ITEM" FOREIGN KEY (source_item) REFERENCES public.object_items(item_id),
      CONSTRAINT "FK_HEALTH_STATUS_MIRROR_ON_TARGET_OBJECT_ITEM" FOREIGN KEY (target_item) REFERENCES public.object_items(item_id)
    );`);
        await queryRunner.query(`CREATE TABLE public.health_status_mirror_history (
      health_status_mirror_history_id uuid DEFAULT uuid_generate_v4() NOT NULL,
      source_item varchar NOT NULL,
      target_item varchar NOT NULL,
      state varchar NOT NULL,
      created_at timestamptz DEFAULT now() NOT NULL,
      ended_at timestamptz NULL,
      CONSTRAINT "PK_349b1e4bfa237a61a15a66a05ae" PRIMARY KEY (health_status_mirror_history_id),
      CONSTRAINT "FK_3c67400034d6f889e996bd3993d" FOREIGN KEY (source_item) REFERENCES public.object_items(item_id) ON DELETE CASCADE,
      CONSTRAINT "FK_aa2e2a9cc28b9b3db0a15bcc4af" FOREIGN KEY (target_item) REFERENCES public.object_items(item_id) ON DELETE CASCADE
    );`);
    }
}
exports.RedoMirror1723033123493 = RedoMirror1723033123493;
//# sourceMappingURL=1723033123493-RedoMirror.migration.js.map