"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlertingHistory1723792712242 = void 0;
class AlertingHistory1723792712242 {
    constructor() {
        this.name = 'AlertingHistory1723792712242';
    }
    async up(queryRunner) {
        await queryRunner.query(`
      CREATE TABLE public.alerting_history (
        alerting_history_id uuid NOT NULL DEFAULT uuid_generate_v4(),
        alerting_group_id uuid NOT NULL,
        metric varchar NOT NULL,
        "limit" float4 NOT NULL,
        "level" varchar NOT NULL DEFAULT 'undefined'::character varying,
        targets _text NOT NULL,
        triggered_at timestamptz NOT NULL DEFAULT now(),
        CONSTRAINT "PK_50a52b7bd2f1dbeac7eeb06b4ea" PRIMARY KEY (alerting_history_id)
      );
      
      ALTER TABLE public.alerting_history ADD CONSTRAINT "FK_0dbdd01d23ebe84fbb5313d2db8" FOREIGN KEY (alerting_group_id) REFERENCES public.alerting_groups(alerting_group_id) ON DELETE CASCADE;
    `);
        await queryRunner.query(`
      CREATE TABLE public.alerting_history_items (
        alerting_history_id uuid NOT NULL,
        item_id varchar NOT NULL,
        CONSTRAINT "PK_aa1dd5d5582882779d9576ce7f2" PRIMARY KEY (alerting_history_id, item_id)
      );
      
      ALTER TABLE public.alerting_history_items ADD CONSTRAINT "FK_4958adf7bec1cf008d6db3d9d4e" FOREIGN KEY (item_id) REFERENCES public.object_items(item_id) ON DELETE CASCADE;
      ALTER TABLE public.alerting_history_items ADD CONSTRAINT "FK_c4b91b53e745f212ea491e84a05" FOREIGN KEY (alerting_history_id) REFERENCES public.alerting_history(alerting_history_id) ON DELETE CASCADE;
    `);
    }
    async down(queryRunner) {
        await queryRunner.dropTable("alerting_history_items");
        await queryRunner.dropTable("alerting_history");
    }
}
exports.AlertingHistory1723792712242 = AlertingHistory1723792712242;
//# sourceMappingURL=1723792712242-AlertingHistory.migration.js.map