"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEnumValues = exports.getArrayItemType = exports.getType = exports.getDescription = exports.getDefaultValue = exports.isRequired = exports.EnumType = exports.ArrayItemType = exports.Description = exports.DefaultValue = exports.Unrequired = exports.Required = exports.ClassMetadata = exports.descriptionMetadataKey = exports.classMetadataKey = exports.enumTypeMetadataKey = exports.arrayItemTypeMetadataKey = exports.defaultValueMetadataKey = exports.requiredMetadataKey = void 0;
require("reflect-metadata");
exports.requiredMetadataKey = Symbol('required');
exports.defaultValueMetadataKey = Symbol('defaultValue');
exports.arrayItemTypeMetadataKey = Symbol('arrayItemType');
exports.enumTypeMetadataKey = Symbol('enumType');
exports.classMetadataKey = Symbol('classMetadata');
exports.descriptionMetadataKey = Symbol('description');
const MyReflect = Reflect ? Reflect : {
    defineMetadata: (...a) => { },
    getMetadata: (...a) => { },
};
function ClassMetadata(target) {
    const properties = Object.getOwnPropertyNames(new target());
    properties.forEach(property => {
        MyReflect.defineMetadata(exports.classMetadataKey, true, target.prototype, property);
    });
}
exports.ClassMetadata = ClassMetadata;
function Required(target, propertyKey) {
    MyReflect.defineMetadata(exports.requiredMetadataKey, true, target, propertyKey);
}
exports.Required = Required;
function Unrequired(target, propertyKey) {
    MyReflect.defineMetadata(exports.requiredMetadataKey, false, target, propertyKey);
}
exports.Unrequired = Unrequired;
function DefaultValue(value) {
    return function (target, propertyKey) {
        MyReflect.defineMetadata(exports.defaultValueMetadataKey, value, target, propertyKey);
    };
}
exports.DefaultValue = DefaultValue;
function Description(value) {
    return function (target, propertyKey) {
        MyReflect.defineMetadata(exports.descriptionMetadataKey, value, target, propertyKey);
    };
}
exports.Description = Description;
function ArrayItemType(itemType) {
    return function (target, propertyKey) {
        MyReflect.defineMetadata(exports.arrayItemTypeMetadataKey, itemType, target, propertyKey);
    };
}
exports.ArrayItemType = ArrayItemType;
function EnumType(enumType) {
    return function (target, propertyKey) {
        MyReflect.defineMetadata(exports.enumTypeMetadataKey, enumType, target, propertyKey);
    };
}
exports.EnumType = EnumType;
function isRequired(target, propertyKey) {
    return MyReflect.getMetadata(exports.requiredMetadataKey, target, propertyKey) === true;
}
exports.isRequired = isRequired;
function getDefaultValue(target, propertyKey) {
    return MyReflect.getMetadata(exports.defaultValueMetadataKey, target, propertyKey);
}
exports.getDefaultValue = getDefaultValue;
function getDescription(target, propertyKey) {
    return MyReflect.getMetadata(exports.descriptionMetadataKey, target, propertyKey);
}
exports.getDescription = getDescription;
function getType(target, propertyKey) {
    return MyReflect.getMetadata('design:type', target, propertyKey);
}
exports.getType = getType;
function getArrayItemType(target, propertyKey) {
    return MyReflect.getMetadata(exports.arrayItemTypeMetadataKey, target, propertyKey);
}
exports.getArrayItemType = getArrayItemType;
function getEnumValues(target, propertyKey) {
    return Object.values(MyReflect.getMetadata(exports.enumTypeMetadataKey, target, propertyKey)).filter(value => typeof value === 'string' || typeof value === 'number');
}
exports.getEnumValues = getEnumValues;
//# sourceMappingURL=hostcfg.metadata.js.map