import { AclMenuChangesResponseDTO, AclMenuResponseDTO, AclResponseDTO } from '@xormon/common/aclResponse.dto';
import { MenuItem } from '@xormon/common/menuResponse.dto';
import { ACL } from '@xormon/entity/acl.entity';
import { Class } from '@xormon/entity/class.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Repository } from 'typeorm';
export declare class ACLService {
    private aclRepository;
    private objectItemsRepository;
    private classesRepository;
    constructor(aclRepository: Repository<ACL>, objectItemsRepository: Repository<ObjectItem>, classesRepository: Repository<Class>);
    getRules(group_id?: number): Promise<ACL[]>;
    saveRules(group_id: number, rules: AclResponseDTO): Promise<ACL[]>;
    saveItemRule(menuItem: MenuItem, group_id: number): Promise<ACL>;
    clearRules(): Promise<void>;
    deleteRules(group_id: number): Promise<void>;
    deleteItemRules(menuItem: MenuItem, group_id: number): Promise<boolean>;
    createAdminRolesRules(group_id: number): Promise<void>;
    getHwTypeClass(hwType: string): Promise<string>;
    getItemClass(menuItem: MenuItem): Promise<any>;
    getStatus(menuItem: MenuItem, group_id: number, strict?: boolean): Promise<"partial" | "granted" | "denied">;
    getVirtualizationSubsys(hwType: string): Promise<any[]>;
    getVirtualizationSubsysItems(hwType: string, subsystem: string): Promise<any[]>;
    getStorageDeviceSubsysItems(hwType: string, item_ids: string): Promise<any[]>;
    filterFolder(menuItems: MenuItem[]): Promise<any[]>;
    filterSubsystems(menuItems: MenuItem[]): Promise<any[]>;
    convertItemPaths(menuItems: MenuItem[]): Promise<any[]>;
    assignStatus(menuItems: MenuItem[], group_id: number): Promise<any[]>;
    assignStatusDeviceFolder(menuItems: MenuItem[], group_id: number, _class: string): Promise<any[]>;
    assignStatusSubsysFolder(menuItems: MenuItem[], group_id: number, hw_type: string, subsystem?: string, item_ids?: string): Promise<any[]>;
    isDisabled(group_id: number, technology_class: string, hw_type?: string): Promise<boolean>;
    updateRules(group_id: number, AclTree: AclMenuResponseDTO): Promise<boolean>;
    updateRuleChanges(group_id: number, changes: AclMenuChangesResponseDTO): Promise<boolean>;
}
