import { AlertGroup, CreateAlertGroupDTO } from '@xormon/common/alerting.dto';
import { CreateMailGroupDTO, MailGroup } from '@xormon/common/mailGroup.dto';
import { AlertingGroup } from '@xormon/entity/alertingGroup.entity';
import { AlertingHwEmail } from '@xormon/entity/alertingHwEmail.entity';
import { HwType } from '@xormon/entity/hwType.entity';
import { MailGroup as MailGroupEntity } from '@xormon/entity/mailGroup.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { User } from '@xormon/entity/user.entity';
import { Repository } from 'typeorm';
import { DeviceGroup, UpdateDeviceGroupHwAlertingBody } from '@xormon/common/deviceGroupHwAlerting.dto';
import { HwEventDeviceGroup } from '@xormon/entity/deviceGroupHwAlerting.entity';
import { ItemGroup } from '@xormon/entity/itemGroup.entity';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
interface UpdateDeviceGroup {
    success: boolean;
    device_group: DeviceGroup;
}
import { AlertingHistory } from '@xormon/entity/alertingHistory.entity';
export declare class AlertingService {
    private hwTypesRepository;
    private objectItemsRepository;
    private alertingGroupRepository;
    private mailGroupsRepository;
    private alertingHwEmailsRepository;
    private hwEventDeviceGroupRepository;
    private itemGroupRepository;
    private userRepository;
    private hostcfgRepository;
    private alertingHistoryRepository;
    static readonly logger: import("winston").Logger;
    constructor(hwTypesRepository: Repository<HwType>, objectItemsRepository: Repository<ObjectItem>, alertingGroupRepository: Repository<AlertingGroup>, mailGroupsRepository: Repository<MailGroupEntity>, alertingHwEmailsRepository: Repository<AlertingHwEmail>, hwEventDeviceGroupRepository: Repository<HwEventDeviceGroup>, itemGroupRepository: Repository<ItemGroup>, userRepository: Repository<User>, hostcfgRepository: Repository<HostCfg>, alertingHistoryRepository: Repository<AlertingHistory>);
    getMailGroups(): Promise<MailGroupEntity[]>;
    saveMailGroup(mail: CreateMailGroupDTO): Promise<MailGroupEntity>;
    deleteMailGroup(mail_group_id: number): Promise<boolean>;
    updateMailGroup(mail_group_id: number, mail: MailGroup): Promise<boolean>;
    getAlertingGroups(userId: number, groupIds: number[]): Promise<AlertingGroup[]>;
    getAlertingGroupsByIds(agIds: string[]): Promise<AlertingGroup[]>;
    saveAlertingGroups(alertGroups: CreateAlertGroupDTO[], user: User): Promise<string[]>;
    deleteAlertingGroups(alertGroupIds: string[]): Promise<import("typeorm").DeleteResult>;
    getLabel(item_id: string): Promise<string>;
    getHwTypeLabel(hw_type: string): Promise<string>;
    getItem(item_id: string): Promise<ObjectItem>;
    getLabels(item_ids: string[]): Promise<{
        uuid: string;
        label: string;
    }[]>;
    getHwAlertingEmails(): Promise<AlertingHwEmail[]>;
    updateHwAlertingEmails(mailGroupIds: number[]): Promise<({
        mail_group_id: number;
    } & AlertingHwEmail)[]>;
    getDeviceGroups(userId: number): Promise<DeviceGroup[]>;
    isUserInAdminGroup(userId: any): Promise<boolean>;
    createDeviceGroups(deviceGroupObject: any, userId: number): Promise<DeviceGroup>;
    deleteDeviceGroup(deviceGroupId: string): Promise<boolean>;
    updateDeviceGroup(deviceGroupHwAlerting: Partial<UpdateDeviceGroupHwAlertingBody>): Promise<UpdateDeviceGroup>;
    filterAlertGroups(alertGroups: CreateAlertGroupDTO[], userId: number, groupIds: number[]): Promise<CreateAlertGroupDTO[]>;
    transformMailGroups(mailGroups: MailGroup[], users: User[], userId: number): MailGroup[];
    transformAlertGroup(alertGroups: AlertingGroup[], userId: number): Promise<AlertGroup[]>;
    getAlertingHistory(userId: number, groupIds: number[], from: Date, to: Date): Promise<AlertingHistory[]>;
}
export {};
