import { IHwTypeBase } from '@xormon/common/architecture.dto';
import { SubsystemProperties } from '@xormon/common/elements/subsystem.elements';
interface TypeWithLabel {
    label: string;
}
export interface IClass {
    class: string;
    label: string;
    order?: number;
    hw_types?: IHwType[];
}
export interface IHwType extends IHwTypeBase {
    class: string;
    subsystems?: ISubsystem[];
    order?: number;
    matching_models?: string[];
}
export interface ISubsystem {
    subsystem: string;
    label: string;
    hw_type?: string;
    hw_type_label?: string;
    class?: string;
    top?: string[];
    properties?: SubsystemProperties;
}
export declare class Architecture {
    static allowedHwTypes(): string[];
    static getInternalMonitoringSubsystems(): ISubsystem[];
    static getClasses(withHwTypes?: boolean): Promise<IClass[]>;
    static getHwTypes(withSubsystems?: boolean, _class?: string | string[]): Promise<IHwType[]>;
    static getHwType(findHwType: string, withSubsystems?: boolean): Promise<{
        class: string;
        hw_type: string;
        label: string;
        subsystems?: undefined;
    } | {
        class: string;
        hw_type: string;
        label: string;
        subsystems: ISubsystem[];
    }>;
    static getSubsystems(byHwType?: string, type?: string): Promise<ISubsystem[]>;
    static getClassesFromMetrics(withHwTypes?: boolean): IClass[];
    static getHwTypesFromMetrics(withSubsystems?: boolean, _class?: string): IHwType[];
    static getHwTypeFromMetrics(findHwType: string, withSubsystems?: boolean): {
        class: string;
        hw_type: string;
        label: any;
        subsystems?: undefined;
    } | {
        class: string;
        hw_type: string;
        label: any;
        subsystems: ISubsystem[];
    };
    static getSubsystemsFromMetrics(byHwType?: string): ISubsystem[];
    static sortByLabel<Type extends TypeWithLabel>(items: Type[]): Type[];
}
export {};
