import { SettingsItem } from '@xormon/common/settings.dto';
interface SettingsGetArguments {
    keys?: (keyof SettingsItem)[];
    prefix?: string;
}
export declare class Settings {
    static protected: string[];
    static hided: string[];
    static get(args: SettingsGetArguments): Promise<SettingsItem>;
    static getWithTime(args: SettingsGetArguments): Promise<{
        [key: string]: {
            value: string;
            updated: string;
        };
    }>;
    static all(): Promise<SettingsItem>;
    static save(items: SettingsItem): Promise<boolean>;
    static delete(keys: string[]): Promise<boolean>;
    static generateLKey(): Promise<string>;
}
export {};
