"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Variables = void 0;
const dataSource_1 = require("../../config/dataSource");
const microserviceVariables_entity_1 = require("../../entity/microserviceVariables.entity");
const typeorm_1 = require("typeorm");
class Variables {
    static async get(keys, hw_type, hostcfg_id) {
        const options = keys && keys.length
            ? {
                key: (0, typeorm_1.In)(keys),
                hw_type: hw_type ? hw_type : (0, typeorm_1.IsNull)(),
                hostcfg_id: hostcfg_id ? hostcfg_id : (0, typeorm_1.IsNull)()
            }
            : {
                hw_type: hw_type ? hw_type : (0, typeorm_1.IsNull)(),
                hostcfg_id: hostcfg_id ? hostcfg_id : (0, typeorm_1.IsNull)()
            };
        const variables = await (0, dataSource_1.getDataSource)().getRepository(microserviceVariables_entity_1.MicroserviceVariables).findBy(options);
        const variableMap = {};
        for (const variable of variables) {
            variableMap[variable.key] = variable.value;
        }
        return variableMap;
    }
    static async getAcrossAllTypesAndIDs(keys) {
        const variables = await (0, dataSource_1.getDataSource)().getRepository(microserviceVariables_entity_1.MicroserviceVariables).findBy({
            key: (0, typeorm_1.In)(keys)
        });
        return variables;
    }
    static async getAllKeys(hw_type, hostcfg_id) {
        return await this.get(null, hw_type, hostcfg_id);
    }
}
exports.Variables = Variables;
//# sourceMappingURL=Variables.js.map