"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReloadGateway = void 0;
const event_emitter_1 = require("@nestjs/event-emitter");
const websockets_1 = require("@nestjs/websockets");
const websocketMessage_dto_1 = require("../../common/websocketMessage.dto");
const socket_io_1 = require("socket.io");
const PM2_1 = require("./PM2");
let ReloadGateway = class ReloadGateway {
    constructor() {
        this.TOKEN_KEY = 'token';
        this.wsClients = [];
    }
    afterInit() {
        setInterval(async () => {
            this.handleWebsocketMessageEvent({ event: 'reload', message: { reload: 'health-status' } });
        }, 5 * 60 * 1000);
    }
    async onModuleInit() {
        process.on('message', (data) => {
            const parsed = PM2_1.PM2.parseMessage(data);
            if (parsed.action === 'refresh-menu') {
                this.handleWebsocketMessageEvent({
                    event: 'reload',
                    message: {
                        reload: 'menu'
                    },
                });
            }
        });
    }
    handleWebsocketMessageEvent(payload) {
        this.broadcast(payload.event, payload.message);
    }
    handleLogoutEvent(token) {
        const client = this.wsClients.find(client => client['token'] === token);
        client.close();
    }
    handleConnection(client, data) {
        const headers = data.headers;
        if (!headers[this.TOKEN_KEY]) {
        }
        else {
            client['token'] = headers[this.TOKEN_KEY];
        }
        this.wsClients.push(client);
    }
    handleDisconnect(client) {
        for (let i = 0; i < this.wsClients.length; i++) {
            if (this.wsClients[i] === client) {
                this.wsClients.splice(i, 1);
                break;
            }
        }
    }
    broadcast(event, message) {
        const broadCastMessage = JSON.stringify(message);
        for (let c of this.wsClients) {
            c.send(broadCastMessage);
        }
    }
    handleEvent(data) {
        const event = 'events';
        return { event, data };
    }
};
exports.ReloadGateway = ReloadGateway;
__decorate([
    (0, websockets_1.WebSocketServer)(),
    __metadata("design:type", socket_io_1.Server)
], ReloadGateway.prototype, "server", void 0);
__decorate([
    (0, event_emitter_1.OnEvent)('reload'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [websocketMessage_dto_1.WebsocketBody]),
    __metadata("design:returntype", void 0)
], ReloadGateway.prototype, "handleWebsocketMessageEvent", null);
__decorate([
    (0, event_emitter_1.OnEvent)('logout'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ReloadGateway.prototype, "handleLogoutEvent", null);
__decorate([
    (0, websockets_1.SubscribeMessage)('events'),
    __param(0, (0, websockets_1.MessageBody)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], ReloadGateway.prototype, "handleEvent", null);
exports.ReloadGateway = ReloadGateway = __decorate([
    (0, websockets_1.WebSocketGateway)({
        cors: {
            origin: '*',
        },
        path: '/websocket/reload'
    }),
    __metadata("design:paramtypes", [])
], ReloadGateway);
//# sourceMappingURL=reload.gateway.js.map