import { IMetric, Item } from "@xormon/common/architecture.dto";
import { ItemStructure } from "@xormon/common/customGroup.dto";
import { Box, Tab } from "@xormon/common/pageResponse.dto";
import { CustomGroup } from "@xormon/entity/customGroup.entity";
import { IMetric as ICMetric } from '../metrics/Classes';
import { ParentType } from '../metrics/Metric';
import { ILastMetricItem } from '../metrics/MetricsWrapper';
import { ClassKey } from '@xormon/common/constants/class.constants';
import { Request } from 'express';
interface ErrorCheck {
    valid: boolean;
    message?: string;
}
export declare class CustomGroupWrapper {
    static DEFAULT_FREE_MAX_ITEMS: number;
    static getCustomGroup(custom_group_id: string): Promise<CustomGroup>;
    static saveInternalCustomGroup(itemStructure: ItemStructure): Promise<CustomGroup>;
    static checkItemStructure(itemStructure: ItemStructure): ErrorCheck;
    static getItems(custom_group_id: string, withArch?: boolean): Promise<Item[]>;
    static getMetrics(custom_group_id: string, withRawMetric?: boolean): Promise<ICMetric[]>;
    static reduceItems(itemIds: string[], metric: string, max?: number, lastValues?: ILastMetricItem | {}): Promise<string[]>;
    static getInfoAndParent(customGroup: CustomGroup): Promise<{
        isClassDefined: boolean;
        subsystemLabel: string;
        parentType: Partial<ParentType>;
    }>;
    static hasItemStructureAnyItems(itemStructure: ItemStructure): Promise<boolean>;
    static genTab(items: Item[], metric: IMetric, parentType: Partial<ParentType>, subsystemLabel: string, isFree: boolean, tabLabel?: string, lastValues?: ILastMetricItem | {}, licensedTechnologies?: string[]): Promise<Tab>;
    static genHeatmapTab(customGroup: CustomGroup, items: Item[], request: Request): Promise<Tab<Box>>;
    static checkCustomGroupHeatmap(_class: ClassKey, subsystem: string): boolean;
}
export {};
