import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { ExportCapacityRequestDTO, ExportConfigurationRequestDTO, ExportFormat, ExportMappingRequestDTO, ExportMetricsRequestDTO, ExportTimeseriesRequestDTO, ExportTopRequestDTO, ExportValuesRequestDTO, ExporterDetailResponseDTO, ExporterHistoryResponseDTO, SaveExport } from '@xormon/common/exporter.dto';
import { Request, Response } from 'express';
import { CustomGroupService } from '../custom_group/custom_group.service';
import { ExporterService } from './exporter.service';
export declare class ExporterController {
    private readonly exporterService;
    private readonly customGroupService;
    constructor(exporterService: ExporterService, customGroupService: CustomGroupService);
    exports(request: Request): Promise<ExporterHistoryResponseDTO>;
    saveExport(request: Request, res: Response, exporter: SaveExport): Promise<void>;
    updateExport(request: Request, export_id: string, exporter: SaveExport): Promise<BasicResponseDTO>;
    deleteExport(request: Request, export_id: string): Promise<BasicResponseDTO>;
    export(request: Request, res: Response, export_id?: string): Promise<void>;
    exportDetail(request: Request, export_id?: string): Promise<ExporterDetailResponseDTO>;
    timeseries(request: Request, res: Response, exportRequest: ExportTimeseriesRequestDTO, format?: ExportFormat): Promise<void>;
    mapping(request: Request, res: Response, exportRequest: ExportMappingRequestDTO, format?: ExportFormat): Promise<void>;
    metrics(res: Response, request: ExportMetricsRequestDTO, format?: ExportFormat): Promise<void>;
    configuration(request: Request, res: Response, exportRequest: ExportConfigurationRequestDTO, format?: ExportFormat): Promise<void>;
    capacity(request: Request, res: Response, exportRequest: ExportCapacityRequestDTO, format?: ExportFormat): Promise<void>;
    values(request: Request, exportRequest: ExportValuesRequestDTO): Promise<string>;
    alerting(format?: ExportFormat): Promise<void>;
    top(res: Response, request: ExportTopRequestDTO, format?: ExportFormat): Promise<void>;
}
