import { SaveExport, TopInterval } from '@xormon/common/exporter.dto';
import { Export } from '@xormon/entity/export.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Top } from '@xormon/entity/top.entity';
import { Repository } from 'typeorm';
import { ItemGroup } from '@xormon/entity/itemGroup.entity';
export declare class ExporterService {
    private objectItemsRepository;
    private topRepository;
    private exporterRepository;
    private itemGroupRepository;
    constructor(objectItemsRepository: Repository<ObjectItem>, topRepository: Repository<Top>, exporterRepository: Repository<Export>, itemGroupRepository: Repository<ItemGroup>);
    findItem(): Promise<ObjectItem[]>;
    getItem(itemId: string): Promise<ObjectItem>;
    findInItems(itemIds: string[]): Promise<ObjectItem>;
    arrList(arr: any[]): string;
    toLocaleDateTime(datetime: number): string;
    getTop(uuids: string[], metric: string, interval: TopInterval): Promise<Top[]>;
    getExports(user_id?: number): Promise<Export[]>;
    getExport(export_id: string, detailed?: boolean): Promise<Export>;
    deleteExport(export_id: string): Promise<boolean>;
    saveExport(exporter: SaveExport, export_id?: string, user_id?: number): Promise<Export>;
    saveUsedTime(export_id: string): Promise<void>;
    checkExportOwner(export_id: string, user_id: number): Promise<boolean>;
}
