"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusMirrorService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const consistencyGroup_entity_1 = require("../../entity/consistencyGroup.entity");
const healthStatusMirror_entity_1 = require("../../entity/healthStatusMirror.entity");
const healthStatusMirrorRel_entity_1 = require("../../entity/healthStatusMirrorRel.entity");
const typeorm_2 = require("typeorm");
let HealthStatusMirrorService = class HealthStatusMirrorService {
    constructor(healthStatusMirrorRepository, consistencyGroupRepository, healthStatusMirrorRelRepository) {
        this.healthStatusMirrorRepository = healthStatusMirrorRepository;
        this.consistencyGroupRepository = consistencyGroupRepository;
        this.healthStatusMirrorRelRepository = healthStatusMirrorRelRepository;
    }
    ;
    async getMirrors() {
        const mirrors = await this.healthStatusMirrorRelRepository.find({
            relations: {
                _consistency_group: true,
                _sourceMirror: {
                    _item: true
                },
                _targetMirror: {
                    _item: true
                }
            }
        });
        return mirrors.map(m => {
            return {
                source_vol_id: m.source_vol_id,
                target_vol_id: m.target_vol_id,
                source_item_id: m._sourceMirror ? m._sourceMirror.item_id : undefined,
                target_item_id: m._targetMirror ? m._targetMirror.item_id : undefined,
                source_item_label: m._sourceMirror ? m._sourceMirror._item.label : undefined,
                target_item_label: m._targetMirror ? m._targetMirror._item.label : undefined,
                type_state: m.type_state,
                severity: m.severity,
                system_name: m.system_name,
                remote_system_name: m.remote_system_name,
                freeze_time: m.freeze_time,
                progress: m.progress,
                consistency_group_id: m.consistency_group_id,
                consistency_group_label: m.consistency_group_label,
                _consistency_group: m._consistency_group ? {
                    consistency_group_id: m._consistency_group.consistency_group_id,
                    label: m._consistency_group.label,
                    mode: m._consistency_group.mode,
                    status: m._consistency_group.status,
                    syncing_lvl: m._consistency_group.syncing_lvl,
                    role: m._consistency_group.role
                } : undefined
            };
        });
    }
};
exports.HealthStatusMirrorService = HealthStatusMirrorService;
exports.HealthStatusMirrorService = HealthStatusMirrorService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(healthStatusMirror_entity_1.HealthStatusMirror)),
    __param(1, (0, typeorm_1.InjectRepository)(consistencyGroup_entity_1.ConsistencyGroup)),
    __param(2, (0, typeorm_1.InjectRepository)(healthStatusMirrorRel_entity_1.HealthStatusMirrorRel)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], HealthStatusMirrorService);
//# sourceMappingURL=healtStatusMirror.service.js.map