import { TierBase } from '@xormon/common/heatmap.dto';
import { HeatmapTier } from '@xormon/entity/heatmapTier.entity';
import { HeatmapTierItem } from '@xormon/entity/heatmapTierItem.entity';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Repository } from 'typeorm';
export declare class HeatmapService {
    private heatmapTierItemRepository;
    private heatmapTierRepository;
    private objectItemsRepository;
    private itemRelationsRepository;
    constructor(heatmapTierItemRepository: Repository<HeatmapTierItem>, heatmapTierRepository: Repository<HeatmapTier>, objectItemsRepository: Repository<ObjectItem>, itemRelationsRepository: Repository<ItemRelation>);
    getHeatmapTierItems(): Promise<HeatmapTierItem[]>;
    saveHeatmapTierItems(heatmapTierItems: HeatmapTierItem[]): Promise<HeatmapTierItem[]>;
    deleteHeatmapTierItemsByIds(itemIds: string[]): Promise<import("typeorm").DeleteResult>;
    getHeatmapTiers(): Promise<HeatmapTier[]>;
    getHeatmapTier(heatmap_tier_id: string): Promise<HeatmapTier>;
    saveHeatmapTier(heatmapTier: TierBase | HeatmapTier): Promise<HeatmapTier | (TierBase & HeatmapTier)>;
    deleteHeatmapTier(heatmap_tier_id: string): Promise<import("typeorm").DeleteResult>;
    getDevice(item_id: string): Promise<ObjectItem>;
    getDevices(): Promise<ObjectItem[]>;
    getMapping(): Promise<{}>;
}
