"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeatmapService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const heatmapTier_entity_1 = require("../../entity/heatmapTier.entity");
const heatmapTierItem_entity_1 = require("../../entity/heatmapTierItem.entity");
const itemRelation_entity_1 = require("../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../entity/objectItem.entity");
const typeorm_2 = require("typeorm");
const class_constants_1 = require("../../common/constants/class.constants");
;
;
let HeatmapService = class HeatmapService {
    constructor(heatmapTierItemRepository, heatmapTierRepository, objectItemsRepository, itemRelationsRepository) {
        this.heatmapTierItemRepository = heatmapTierItemRepository;
        this.heatmapTierRepository = heatmapTierRepository;
        this.objectItemsRepository = objectItemsRepository;
        this.itemRelationsRepository = itemRelationsRepository;
    }
    async getHeatmapTierItems() {
        return await this.heatmapTierItemRepository.find({ relations: ['_item', '_heatmap_tier'] });
    }
    async saveHeatmapTierItems(heatmapTierItems) {
        return await this.heatmapTierItemRepository.save(heatmapTierItems);
    }
    async deleteHeatmapTierItemsByIds(itemIds) {
        return await this.heatmapTierItemRepository.delete({ item_id: (0, typeorm_2.In)(itemIds) });
    }
    async getHeatmapTiers() {
        return await this.heatmapTierRepository.find();
    }
    async getHeatmapTier(heatmap_tier_id) {
        return await this.heatmapTierRepository.findOneBy({ heatmap_tier_id: heatmap_tier_id });
    }
    async saveHeatmapTier(heatmapTier) {
        heatmapTier.read_intervals.sort((a, b) => a.limit - b.limit);
        heatmapTier.write_intervals.sort((a, b) => a.limit - b.limit);
        return await this.heatmapTierRepository.save(heatmapTier);
    }
    async deleteHeatmapTier(heatmap_tier_id) {
        return await this.heatmapTierRepository.delete(heatmap_tier_id);
    }
    async getDevice(item_id) {
        const itemIds = (await this.itemRelationsRepository.findBy({ child: item_id })).map((item) => item.parent);
        return await this.objectItemsRepository.findOne({ where: { item_id: (0, typeorm_2.In)(itemIds), subsystem: 'DEVICE' } });
    }
    async getDevices() {
        return await this.objectItemsRepository.find({
            relations: {
                hw_type_entity: true,
                children: {
                    _child: {
                        heatmap_tier_item: true
                    }
                }
            },
            where: {
                hw_type_entity: {
                    class: class_constants_1.ClassKey.STORAGE
                },
                subsystem: 'device',
            }
        });
    }
    async getMapping() {
        let mapping = {};
        const elements = await this.objectItemsRepository.query(`select object_items.item_id, object_items.label, oi.label as parent, oi.item_id as parent_id from object_items right join item_relations on item_relations.child = object_items.item_id right join object_items oi on item_relations.parent = oi.item_id where object_items.subsystem = 'pool' and oi.subsystem = 'device';`);
        for (const element of elements) {
            mapping[element.item_id] = {
                parent_label: element.parent,
                parent_id: element.parent_id,
            };
        }
        return mapping;
    }
};
exports.HeatmapService = HeatmapService;
exports.HeatmapService = HeatmapService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(heatmapTierItem_entity_1.HeatmapTierItem)),
    __param(1, (0, typeorm_1.InjectRepository)(heatmapTier_entity_1.HeatmapTier)),
    __param(2, (0, typeorm_1.InjectRepository)(objectItem_entity_1.ObjectItem)),
    __param(3, (0, typeorm_1.InjectRepository)(itemRelation_entity_1.ItemRelation)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], HeatmapService);
//# sourceMappingURL=heatmap.service.js.map