/// <reference types="multer" />
import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { LdapCertificatesResponseDTO, LdapGroupsResponse, LdapResponseDTO, LdapSave, LdapsResponseDTO } from '@xormon/common/ldap.dto';
import { LdapService } from './ldap.service';
import { LdapCertService } from './ldap.cert.service';
export declare class LdapController {
    private readonly ldapService;
    private readonly ldapCertService;
    private logger;
    constructor(ldapService: LdapService, ldapCertService: LdapCertService);
    listLdaps(): Promise<LdapsResponseDTO>;
    saveLdap(saveLdap: LdapSave): Promise<LdapResponseDTO>;
    getLdap(ldap_id: string): Promise<LdapResponseDTO>;
    updateLdap(ldap_id: string, ldapSave: LdapSave): Promise<LdapResponseDTO>;
    deleteLdap(ldap_id: string): Promise<BasicResponseDTO>;
    listCert(): Promise<LdapCertificatesResponseDTO>;
    saveCert(file: Express.Multer.File): Promise<BasicResponseDTO>;
    deleteCert(ldapCertificateId: string): Promise<BasicResponseDTO>;
    testLdap(ldapData: LdapSave): Promise<LdapGroupsResponse>;
}
