import { MenuItem } from '@xormon/common/menuResponse.dto';
import { Request } from 'express';
import { Page, Tab } from '@xormon/common/pageResponse.dto';
export declare class MenuHandler {
    private hwType;
    private request?;
    private hwTypeHandlerName;
    private debugMode;
    private namespace;
    constructor(hwType: string, request?: Request);
    setDebug(): void;
    getContent<ContentType>(pageType: string, itemId: string, tab?: string): Promise<ContentType>;
    getPage(pageType: string, itemId: string): Promise<Page>;
    getTab(pageType: string, itemId: string, tab: string): Promise<Tab>;
    getFolder(folderType: string, ids: string, acl?: boolean): Promise<MenuItem[]>;
    private getClassFolderHandler;
    private getClassPageHandler;
    getPath(pageType: string, itemId: string): Promise<MenuItem[]>;
    getRootFolder(acl?: boolean): Promise<MenuItem[]>;
    private isExist;
    private isRootFolderExist;
    private isStorageOrSan;
    private formatHwTypeName;
    private formatTypeName;
    static addLeaf(menuItems: MenuItem[], itemIds: string[], leaf: MenuItem[], found?: number): MenuItem[];
}
