import { MenuItem } from '@xormon/common/menuResponse.dto';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { HwType } from '@xormon/entity/hwType.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { StorageGroup } from '@xormon/entity/storageGroup.entity';
import { Subsystem } from '@xormon/entity/subsystem.entity';
import { IHwType } from '@xormon/service/architecture/Architecture';
import { Repository } from 'typeorm';
import { Request } from 'express';
export declare class MenuService {
    private objectItemsRepository;
    private hwTypesRepository;
    private hostCfgRepository;
    private subsystemsRepository;
    private storageGroupsRepository;
    constructor(objectItemsRepository: Repository<ObjectItem>, hwTypesRepository: Repository<HwType>, hostCfgRepository: Repository<HostCfg>, subsystemsRepository: Repository<Subsystem>, storageGroupsRepository: Repository<StorageGroup>);
    getRoot(technology_class?: string): Promise<IHwType[]>;
    checkHost(hw_type?: string): Promise<boolean>;
    checkItem(hw_type?: string): Promise<boolean>;
    sortMenuItems(items: MenuItem[]): MenuItem[];
    getObjectItems(hw_type: string, subsystem: string): Promise<ObjectItem[]>;
    getDevices(_class?: string): Promise<ObjectItem[]>;
    getSanRoot(): Promise<MenuItem[]>;
    getLanRoot(request: Request): Promise<MenuItem[]>;
    generatePagePath(technology: string, type: string): string;
    getHwTypeItems(hw_type: string, acl?: boolean, request?: Request): Promise<any>;
    getSubsystemItems(hw_type: string, subsystem: string, ids?: string, acl?: boolean, request?: Request): Promise<any>;
    getPage(hw_type: string, type: string, item_id?: string, request?: Request): Promise<import("../../common/pageResponse.dto").Page>;
    getPath(hw_type: string, type: string, item_id?: string): Promise<MenuItem[]>;
}
