"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _CapacityTableBuilder_instances, _CapacityTableBuilder_subsystem, _CapacityTableBuilder_itemIds, _CapacityTableBuilder_items, _CapacityTableBuilder_metricsDefinitions, _CapacityTableBuilder_metrics, _CapacityTableBuilder_itemLabel, _CapacityTableBuilder_request, _CapacityTableBuilder_user, _CapacityTableBuilder_total, _CapacityTableBuilder_rows, _CapacityTableBuilder_headers, _CapacityTableBuilder_capacityTable, _CapacityTableBuilder_lastVirtualMetrics, _CapacityTableBuilder_predictionData, _CapacityTableBuilder_capTabLabelPerHwType, _CapacityTableBuilder_prediction, _CapacityTableBuilder_used, _CapacityTableBuilder_isAnalyzerActive, _CapacityTableBuilder_lastMetrics, _CapacityTableBuilder_url, _CapacityTableBuilder_withoutPerPool, _CapacityTableBuilder_storageGroups, _CapacityTableBuilder_customHeaders, _CapacityTableBuilder_usedMetrics, _CapacityTableBuilder_predictionMetric, _CapacityTableBuilder_predictionMaxMetric, _CapacityTableBuilder_totalRow, _CapacityTableBuilder_loadItems, _CapacityTableBuilder_aclFilter, _CapacityTableBuilder_loadMetrics;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CapacityTableBuilder = void 0;
const dataSource_1 = require("../../../config/dataSource");
const objectItem_entity_1 = require("../../../entity/objectItem.entity");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const typeorm_1 = require("typeorm");
const CapacityTable_1 = require("./CapacityTable");
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const User_1 = require("../../users/User");
const ACLCheck_1 = require("../../acl/ACLCheck");
const Prediction_1 = require("../../metrics/Prediction");
const URL_1 = require("./URL");
const Classes_1 = require("../../metrics/Classes");
const class_constants_1 = require("../../../common/constants/class.constants");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
class CapacityTableBuilder {
    constructor(subsystem, request) {
        _CapacityTableBuilder_instances.add(this);
        _CapacityTableBuilder_subsystem.set(this, void 0);
        _CapacityTableBuilder_itemIds.set(this, []);
        _CapacityTableBuilder_items.set(this, []);
        _CapacityTableBuilder_metricsDefinitions.set(this, []);
        _CapacityTableBuilder_metrics.set(this, []);
        _CapacityTableBuilder_itemLabel.set(this, void 0);
        _CapacityTableBuilder_request.set(this, void 0);
        _CapacityTableBuilder_user.set(this, void 0);
        _CapacityTableBuilder_total.set(this, false);
        _CapacityTableBuilder_rows.set(this, []);
        _CapacityTableBuilder_headers.set(this, []);
        _CapacityTableBuilder_capacityTable.set(this, void 0);
        _CapacityTableBuilder_lastVirtualMetrics.set(this, {});
        _CapacityTableBuilder_predictionData.set(this, void 0);
        _CapacityTableBuilder_capTabLabelPerHwType.set(this, {});
        _CapacityTableBuilder_prediction.set(this, false);
        _CapacityTableBuilder_used.set(this, false);
        _CapacityTableBuilder_isAnalyzerActive.set(this, false);
        _CapacityTableBuilder_lastMetrics.set(this, {});
        _CapacityTableBuilder_url.set(this, false);
        _CapacityTableBuilder_withoutPerPool.set(this, false);
        _CapacityTableBuilder_storageGroups.set(this, void 0);
        _CapacityTableBuilder_customHeaders.set(this, []);
        _CapacityTableBuilder_usedMetrics.set(this, void 0);
        _CapacityTableBuilder_predictionMetric.set(this, void 0);
        _CapacityTableBuilder_predictionMaxMetric.set(this, void 0);
        _CapacityTableBuilder_totalRow.set(this, void 0);
        __classPrivateFieldSet(this, _CapacityTableBuilder_subsystem, subsystem, "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_request, request, "f");
    }
    addMetric(metric, label, thermometer) {
        __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f").push({
            metric: metric,
            label: label,
            thermometer: thermometer
        });
        return this;
    }
    addDefaultMetrics() {
        return this
            .addMetric("capacity_total", "Total")
            .addMetric("capacity_used", "Used")
            .addMetric("capacity_free", "Free");
    }
    addUsed(metricsToUse = { used: "capacity_used", total: "capacity_total" }) {
        __classPrivateFieldSet(this, _CapacityTableBuilder_used, true, "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_usedMetrics, metricsToUse, "f");
        return this;
    }
    addPrediction(withoutPerPool = false, metric = "capacity_used", maxMetric = "capacity_total") {
        __classPrivateFieldSet(this, _CapacityTableBuilder_prediction, true, "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_withoutPerPool, withoutPerPool, "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_predictionMetric, metric, "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_predictionMaxMetric, maxMetric, "f");
        return this;
    }
    addUrl() {
        __classPrivateFieldSet(this, _CapacityTableBuilder_url, true, "f");
        return this;
    }
    addItems(itemIds) {
        __classPrivateFieldSet(this, _CapacityTableBuilder_itemIds, itemIds, "f");
        return this;
    }
    setItemLabel(label) {
        __classPrivateFieldSet(this, _CapacityTableBuilder_itemLabel, label, "f");
        return this;
    }
    setUser(user) {
        if (user) {
            __classPrivateFieldSet(this, _CapacityTableBuilder_user, user, "f");
        }
        return this;
    }
    addTotal() {
        __classPrivateFieldSet(this, _CapacityTableBuilder_total, true, "f");
        return this;
    }
    addCustomHeader(header) {
        __classPrivateFieldGet(this, _CapacityTableBuilder_customHeaders, "f").push(header);
        return this;
    }
    async generateData() {
        await __classPrivateFieldGet(this, _CapacityTableBuilder_instances, "m", _CapacityTableBuilder_loadItems).call(this);
        await __classPrivateFieldGet(this, _CapacityTableBuilder_instances, "m", _CapacityTableBuilder_loadMetrics).call(this);
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_prediction, "f")) {
            await this.addPredictionMetrics();
        }
        for (const customHeader of __classPrivateFieldGet(this, _CapacityTableBuilder_customHeaders, "f")) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: customHeader.label });
        }
        for (const metric of __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f")) {
            const definition = __classPrivateFieldGet(this, _CapacityTableBuilder_metricsDefinitions, "f").find(m => m.metric === metric.metric);
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: metric.label ? metric.label : definition ? definition.label : metric.metric, shortcut: definition ? definition.shortcut : undefined, number: true, prefix: definition ? definition.defaultPrefix : pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: definition ? definition.defaultPrecision : 0, thermometer: metric.thermometer ? metric.thermometer : undefined });
        }
        if (Object.keys(__classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")).length >= 1) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: 'Virtual', number: true, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0, shortcut: subsystemMetricsResponse_constants_1.SHORTCUT[subsystemMetricsResponse_constants_1.UNIT.bytes] });
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: 'Oversubscr', number: true, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0, shortcut: subsystemMetricsResponse_constants_1.SHORTCUT[subsystemMetricsResponse_constants_1.UNIT.bytes] });
        }
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: 'Days to 90%' });
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: 'Days to 100%' });
        }
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_used, "f")) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f").push({ value: 'Used', number: true, thermometer: true, shortcut: subsystemMetricsResponse_constants_1.SHORTCUT[subsystemMetricsResponse_constants_1.UNIT.percent] });
        }
        __classPrivateFieldSet(this, _CapacityTableBuilder_lastMetrics, await new MetricsWrapper_1.MetricsWrapper(__classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f").map(m => m.metric), __classPrivateFieldGet(this, _CapacityTableBuilder_itemIds, "f")).getLastValuesFromTable(), "f");
        for (const item of __classPrivateFieldGet(this, _CapacityTableBuilder_items, "f")) {
            if (item.hw_type === "vspg" && item.label === "GAD_unknown")
                continue;
            let row = [{
                    order: 0,
                    value: item.label,
                }];
            if (item.subsystem === "device") {
                row[0]["url"] = URL_1.URL.generate(item.hw_type, 'capacity', item.item_id);
            }
            let i = 1;
            if (__classPrivateFieldGet(this, _CapacityTableBuilder_url, "f")) {
                i = 2;
                const device = item.parents.find(parent => parent._parent.subsystem === 'device');
                row = [{
                        order: 0,
                        value: device ? device._parent.label : ' ',
                        url: device ? URL_1.URL.generate(device._parent.hw_type, 'capacity', device._parent.item_id) : undefined
                    }, {
                        order: 1,
                        value: item.label,
                        url: URL_1.URL.generate(item.hw_type, item.subsystem, item.item_id)
                    }];
            }
            for (const customHeader of __classPrivateFieldGet(this, _CapacityTableBuilder_customHeaders, "f")) {
                row.push({
                    order: i++,
                    value: customHeader.valuesByItemId[item.item_id]
                });
            }
            for (const metric of __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f")) {
                let tooltip = undefined;
                if (metric.thermometer) {
                    if (!__classPrivateFieldGet(this, _CapacityTableBuilder_user, "f")) {
                        __classPrivateFieldSet(this, _CapacityTableBuilder_user, await User_1.User.getUserByRequest(__classPrivateFieldGet(this, _CapacityTableBuilder_request, "f")), "f");
                    }
                    const timezone = __classPrivateFieldGet(this, _CapacityTableBuilder_user, "f") ? __classPrivateFieldGet(this, _CapacityTableBuilder_user, "f").timezone : 'Etc/UTC';
                    tooltip = __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id] && __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][metric.metric] && __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id]['bucket']
                        ? `${__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][metric.metric]}% of pool capacity used (${new Date(__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id]['bucket'] * 1000).toLocaleString(undefined, { timeZone: timezone })})`
                        : 'no data found';
                }
                row.push({
                    order: i,
                    value: __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id] ? __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][metric.metric] : null,
                    tooltip: tooltip ? tooltip : undefined
                });
                i++;
            }
            if (Object.keys(__classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")).length >= 1) {
                row.push({
                    order: i++,
                    value: __classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f") && __classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")[item.item_id] ? __classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")[item.item_id]['virtual_capacity_total'] : null
                });
                row.push({
                    order: i++,
                    value: __classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f") && __classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")[item.item_id] ? __classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")[item.item_id]['capacity_oversubscr'] : null
                });
            }
            if (__classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")) {
                row.push({
                    order: i++,
                    value: __classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")[item.item_id] ? __classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")[item.item_id]['time_to_less'] : null,
                    url: __classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")[item.item_id] && __classPrivateFieldGet(this, _CapacityTableBuilder_capTabLabelPerHwType, "f")[item.hw_type] ? URL_1.URL.generate(item.hw_type, item.subsystem, item.item_id + "#tab=" + __classPrivateFieldGet(this, _CapacityTableBuilder_capTabLabelPerHwType, "f")[item.hw_type]) : undefined
                });
                row.push({
                    order: i++,
                    value: __classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")[item.item_id] ? __classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")[item.item_id]['time_to_full'] : null,
                    url: __classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")[item.item_id] && __classPrivateFieldGet(this, _CapacityTableBuilder_capTabLabelPerHwType, "f")[item.hw_type] ? URL_1.URL.generate(item.hw_type, item.subsystem, item.item_id + "#tab=" + __classPrivateFieldGet(this, _CapacityTableBuilder_capTabLabelPerHwType, "f")[item.hw_type]) : undefined
                });
            }
            if (__classPrivateFieldGet(this, _CapacityTableBuilder_used, "f")) {
                const usedPercent = __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id] && __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][__classPrivateFieldGet(this, _CapacityTableBuilder_usedMetrics, "f").total] && __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][__classPrivateFieldGet(this, _CapacityTableBuilder_usedMetrics, "f").used]
                    ? Math.round(__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][__classPrivateFieldGet(this, _CapacityTableBuilder_usedMetrics, "f").used] / (__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id][__classPrivateFieldGet(this, _CapacityTableBuilder_usedMetrics, "f").total] / 100))
                    : null;
                if (!__classPrivateFieldGet(this, _CapacityTableBuilder_user, "f")) {
                    __classPrivateFieldSet(this, _CapacityTableBuilder_user, await User_1.User.getUserByRequest(__classPrivateFieldGet(this, _CapacityTableBuilder_request, "f")), "f");
                }
                const timezone = __classPrivateFieldGet(this, _CapacityTableBuilder_user, "f") ? __classPrivateFieldGet(this, _CapacityTableBuilder_user, "f").timezone : 'Etc/UTC';
                const tooltip = __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id] && __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id]['bucket']
                    ? `${usedPercent}% of storage capacity used (${new Date(__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id]['bucket'] * 1000).toLocaleString(undefined, { timeZone: timezone })})`
                    : 'no data found';
                row.push({
                    order: i++,
                    value: usedPercent,
                    tooltip: tooltip
                });
            }
            __classPrivateFieldGet(this, _CapacityTableBuilder_rows, "f").push(row);
        }
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_total, "f")) {
            let totalRow = [{
                    order: 0,
                    value: "Total"
                }];
            let i = 1;
            if (__classPrivateFieldGet(this, _CapacityTableBuilder_url, "f")) {
                totalRow.push({
                    order: i++,
                    value: null
                });
            }
            for (const customHeader of __classPrivateFieldGet(this, _CapacityTableBuilder_customHeaders, "f")) {
                totalRow.push({
                    order: i++,
                    value: null
                });
            }
            for (const metric of __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f")) {
                totalRow.push({
                    order: i,
                    value: Object.keys(__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")).map(id => __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[id][metric.metric]).reduce((previous, current) => previous + (typeof current === 'number' ? current : 0), 0)
                });
            }
            if (Object.keys(__classPrivateFieldGet(this, _CapacityTableBuilder_lastVirtualMetrics, "f")).length >= 1) {
                totalRow.push({
                    order: i++,
                    value: null
                });
                totalRow.push({
                    order: i++,
                    value: null
                });
            }
            if (__classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")) {
                totalRow.push({
                    order: i++,
                    value: null
                });
                totalRow.push({
                    order: i++,
                    value: null
                });
            }
            if (__classPrivateFieldGet(this, _CapacityTableBuilder_used, "f")) {
                totalRow.push({
                    order: i,
                    value: Math.round(__classPrivateFieldGet(this, _CapacityTableBuilder_rows, "f").map(r => r.at(-1).value).reduce((previous, current) => previous + (typeof current === 'number' ? current : 0), 0) / __classPrivateFieldGet(this, _CapacityTableBuilder_rows, "f").length)
                });
            }
            __classPrivateFieldSet(this, _CapacityTableBuilder_totalRow, totalRow, "f");
        }
        return this;
    }
    async generateBox() {
        await this.generateData();
        return this.generateTable().generateBox();
    }
    setStorageGroups(storageGroups) {
        __classPrivateFieldSet(this, _CapacityTableBuilder_storageGroups, storageGroups, "f");
        return this;
    }
    async generateStorageGroupBox() {
        if (!__classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f")) {
            await this.generateData();
        }
        let summedMetrics = {};
        let headers = [];
        let rows = [];
        headers.push({ value: "Group" });
        for (const metric of __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f")) {
            const definition = __classPrivateFieldGet(this, _CapacityTableBuilder_metricsDefinitions, "f").find(m => m.metric === metric.metric);
            headers.push({ value: metric.label ? metric.label : definition ? definition.label : metric.metric, shortcut: definition ? definition.shortcut : undefined, number: true, prefix: definition ? definition.defaultPrefix : pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: definition ? definition.defaultPrecision : 0, thermometer: metric.thermometer ? metric.thermometer : undefined });
        }
        headers.push({ value: "Used", number: true, thermometer: true });
        for (const storageGroup of __classPrivateFieldGet(this, _CapacityTableBuilder_storageGroups, "f")) {
            let row = [{ order: 0, value: storageGroup.label }];
            for (const groupDevice of storageGroup.storage_group_devices) {
                for (const metric of __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f")) {
                    const value = __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[groupDevice.item_id] ? +__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[groupDevice.item_id][metric.metric] : 0;
                    if (!summedMetrics[metric.metric]) {
                        summedMetrics[metric.metric] = 0;
                    }
                    summedMetrics[metric.metric] = summedMetrics[metric.metric] + value;
                }
            }
            let i = 1;
            for (const metric of __classPrivateFieldGet(this, _CapacityTableBuilder_metrics, "f")) {
                row.push({ order: i++, value: summedMetrics[metric.metric] });
            }
            const usedPercent = summedMetrics["capacity_total"] !== 0 ? Math.round(summedMetrics["capacity_used"] / (summedMetrics["capacity_total"] / 100)) : null;
            row.push({ order: i++, value: usedPercent, tooltip: `${usedPercent}% of storage group used` });
            rows.push(row);
        }
        const sgCapacityTable = new CapacityTable_1.CapacityTable();
        sgCapacityTable.addHeaders(headers);
        sgCapacityTable.addRows(rows);
        sgCapacityTable.sortByIndex(0, false, true);
        return sgCapacityTable.generateBox();
    }
    async generateContentWithPredictions() {
        await this.generateData();
        let content = [this.generateTable().generateBox()];
        if (!__classPrivateFieldGet(this, _CapacityTableBuilder_isAnalyzerActive, "f")) {
            content.push(Prediction_1.Prediction.analyzerTextBox['not-active']);
        }
        else if (__classPrivateFieldGet(this, _CapacityTableBuilder_isAnalyzerActive, "f") && Object.keys(__classPrivateFieldGet(this, _CapacityTableBuilder_predictionData, "f")).length === 0) {
            content.push(Prediction_1.Prediction.analyzerTextBox['no-data']);
        }
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_isAnalyzerActive, "f") && !__classPrivateFieldGet(this, _CapacityTableBuilder_withoutPerPool, "f")) {
            const capacityMetric = Classes_1.Storage.metrics['capacity_used'];
            for (const item of __classPrivateFieldGet(this, _CapacityTableBuilder_items, "f")) {
                if (__classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id] && __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id]['capacity_total']) {
                    const device = item.parents.find(relation => relation._parent.subsystem === 'device')?._parent;
                    content.push(await Prediction_1.Prediction.generatePredictionBox({
                        graphLabel: `Capacity prediction: ${device ? "[" + device.label + "]:" : ""} [${item.label}]`,
                        item_id: item.item_id,
                        metric: {
                            ...capacityMetric,
                            order: 0,
                            type: pageResponse_constants_1.CHART_TYPE.line,
                            stacked: false,
                        },
                        other_metrics: [],
                        frequency: '1d',
                        command: 'predict_capacity',
                        interval: 'year',
                        max: __classPrivateFieldGet(this, _CapacityTableBuilder_lastMetrics, "f")[item.item_id]['capacity_total']
                    }));
                }
            }
        }
        return content;
    }
    async addPredictionMetrics() {
        const uniqHwTypes = [...new Set(__classPrivateFieldGet(this, _CapacityTableBuilder_items, "f").map(item => item.hw_type))];
        for (const hwType of uniqHwTypes) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_capTabLabelPerHwType, "f")[hwType] = MetricsWrapper_1.MetricsWrapper.findTabLabelByMetric(class_constants_1.ClassKey.STORAGE, hwType, __classPrivateFieldGet(this, _CapacityTableBuilder_subsystem, "f"), __classPrivateFieldGet(this, _CapacityTableBuilder_predictionMetric, "f"));
        }
        __classPrivateFieldSet(this, _CapacityTableBuilder_isAnalyzerActive, await Prediction_1.Prediction.isAnalyzerActive(), "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_predictionData, __classPrivateFieldGet(this, _CapacityTableBuilder_isAnalyzerActive, "f")
            ? await Prediction_1.Prediction.getCapacityTableData(__classPrivateFieldGet(this, _CapacityTableBuilder_items, "f"), __classPrivateFieldGet(this, _CapacityTableBuilder_predictionMetric, "f"), __classPrivateFieldGet(this, _CapacityTableBuilder_predictionMaxMetric, "f"))
            : {}, "f");
        __classPrivateFieldSet(this, _CapacityTableBuilder_lastVirtualMetrics, await new MetricsWrapper_1.MetricsWrapper(['virtual_capacity_total', 'capacity_oversubscr'], __classPrivateFieldGet(this, _CapacityTableBuilder_itemIds, "f")).getLastValuesFromTable(), "f");
    }
    generateTable() {
        __classPrivateFieldSet(this, _CapacityTableBuilder_capacityTable, new CapacityTable_1.CapacityTable(), "f");
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_url, "f")) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f").addHeader({ value: "Device" });
        }
        __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f").addHeader({ value: __classPrivateFieldGet(this, _CapacityTableBuilder_itemLabel, "f") ? __classPrivateFieldGet(this, _CapacityTableBuilder_itemLabel, "f") : "Item" });
        __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f").addHeaders(__classPrivateFieldGet(this, _CapacityTableBuilder_headers, "f"));
        __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f").addRows(__classPrivateFieldGet(this, _CapacityTableBuilder_rows, "f"));
        __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f").sortByIndex(0, false, true);
        if (__classPrivateFieldGet(this, _CapacityTableBuilder_total, "f")) {
            __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f").addSummaryRow(__classPrivateFieldGet(this, _CapacityTableBuilder_totalRow, "f"));
        }
        return __classPrivateFieldGet(this, _CapacityTableBuilder_capacityTable, "f");
    }
}
exports.CapacityTableBuilder = CapacityTableBuilder;
_CapacityTableBuilder_subsystem = new WeakMap(), _CapacityTableBuilder_itemIds = new WeakMap(), _CapacityTableBuilder_items = new WeakMap(), _CapacityTableBuilder_metricsDefinitions = new WeakMap(), _CapacityTableBuilder_metrics = new WeakMap(), _CapacityTableBuilder_itemLabel = new WeakMap(), _CapacityTableBuilder_request = new WeakMap(), _CapacityTableBuilder_user = new WeakMap(), _CapacityTableBuilder_total = new WeakMap(), _CapacityTableBuilder_rows = new WeakMap(), _CapacityTableBuilder_headers = new WeakMap(), _CapacityTableBuilder_capacityTable = new WeakMap(), _CapacityTableBuilder_lastVirtualMetrics = new WeakMap(), _CapacityTableBuilder_predictionData = new WeakMap(), _CapacityTableBuilder_capTabLabelPerHwType = new WeakMap(), _CapacityTableBuilder_prediction = new WeakMap(), _CapacityTableBuilder_used = new WeakMap(), _CapacityTableBuilder_isAnalyzerActive = new WeakMap(), _CapacityTableBuilder_lastMetrics = new WeakMap(), _CapacityTableBuilder_url = new WeakMap(), _CapacityTableBuilder_withoutPerPool = new WeakMap(), _CapacityTableBuilder_storageGroups = new WeakMap(), _CapacityTableBuilder_customHeaders = new WeakMap(), _CapacityTableBuilder_usedMetrics = new WeakMap(), _CapacityTableBuilder_predictionMetric = new WeakMap(), _CapacityTableBuilder_predictionMaxMetric = new WeakMap(), _CapacityTableBuilder_totalRow = new WeakMap(), _CapacityTableBuilder_instances = new WeakSet(), _CapacityTableBuilder_loadItems = async function _CapacityTableBuilder_loadItems() {
    __classPrivateFieldSet(this, _CapacityTableBuilder_items, await (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem).find({
        where: {
            item_id: (0, typeorm_1.In)(__classPrivateFieldGet(this, _CapacityTableBuilder_itemIds, "f")),
            parents: __classPrivateFieldGet(this, _CapacityTableBuilder_url, "f") ? {
                _parent: {
                    subsystem: 'device'
                }
            } : undefined
        },
        relations: {
            parents: {
                _parent: true
            }
        }
    }), "f");
    await __classPrivateFieldGet(this, _CapacityTableBuilder_instances, "m", _CapacityTableBuilder_aclFilter).call(this);
}, _CapacityTableBuilder_aclFilter = async function _CapacityTableBuilder_aclFilter() {
    __classPrivateFieldSet(this, _CapacityTableBuilder_items, __classPrivateFieldGet(this, _CapacityTableBuilder_user, "f") ? await ACLCheck_1.ACLCheck.filterObjectItemsWithGroups(__classPrivateFieldGet(this, _CapacityTableBuilder_user, "f").groups.map(group => group.group_id), __classPrivateFieldGet(this, _CapacityTableBuilder_items, "f"))
        : await ACLCheck_1.ACLCheck.filterObjectItemsWithRequest(__classPrivateFieldGet(this, _CapacityTableBuilder_request, "f"), __classPrivateFieldGet(this, _CapacityTableBuilder_items, "f")), "f");
    __classPrivateFieldSet(this, _CapacityTableBuilder_itemIds, __classPrivateFieldGet(this, _CapacityTableBuilder_items, "f").map(item => item.item_id), "f");
}, _CapacityTableBuilder_loadMetrics = async function _CapacityTableBuilder_loadMetrics() {
    const hwTypes = (await (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem)
        .createQueryBuilder('object_items')
        .where({ item_id: (0, typeorm_1.In)(__classPrivateFieldGet(this, _CapacityTableBuilder_itemIds, "f")) })
        .distinctOn(['object_items.hw_type'])
        .getMany())
        .map(item => item.hw_type);
    __classPrivateFieldSet(this, _CapacityTableBuilder_metricsDefinitions, await MetricsWrapper_1.MetricsWrapper.getMetrics(hwTypes, __classPrivateFieldGet(this, _CapacityTableBuilder_subsystem, "f")), "f");
};
//# sourceMappingURL=CapacityTableBuilder.js.map