import { MenuItem } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
export declare class CloudstackFolder {
    hwType: string;
    children?: Array<MenuItem>;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
}
export declare class CloudstackSubsystemFolder extends CloudstackFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class CloudstackRootFolder extends CloudstackFolder {
    getChildren(): Promise<any[]>;
}
export declare class CloudstackCloudFolder extends CloudstackSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class CloudstackChildSubsystemFolder extends CloudstackSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<any[]>;
}
export declare class CloudstackHostFolder extends CloudstackChildSubsystemFolder {
    subsystem: string;
}
export declare class CloudstackInstanceFolder extends CloudstackChildSubsystemFolder {
    subsystem: string;
}
export declare class CloudstackVolumeFolder extends CloudstackChildSubsystemFolder {
    subsystem: string;
}
export declare class CloudstackPrimarystorageFolder extends CloudstackChildSubsystemFolder {
    subsystem: string;
}
export declare class CloudstackMetrics {
    static InstanceCpuMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static InstanceFreememMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static InstanceMaxmemMetric: {
        new (): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare class CloudstackPage {
    hwType: string;
    page: Page;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPath(): Promise<any[]>;
}
export declare class CloudstackConfigurationPage extends CloudstackPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare abstract class CloudstackCloudTotalsPage extends CloudstackPage {
    subsystem: string;
    itemId: string;
    constructor(itemId: string);
    getPath(): Promise<any[]>;
}
export declare class CloudstackHosttotalsPage extends CloudstackCloudTotalsPage {
    getPage(): Promise<Page>;
}
export declare class CloudstackInstancetotalsPage extends CloudstackCloudTotalsPage {
    getPage(): Promise<Page>;
}
export declare class CloudstackVolumetotalsPage extends CloudstackCloudTotalsPage {
    getPage(): Promise<Page>;
}
export declare class CloudstackPrimarystoragetotalsPage extends CloudstackCloudTotalsPage {
    getPage(): Promise<Page>;
}
export declare abstract class CloudstackSingleItemPage extends CloudstackPage {
    subsystem: string;
    itemId: string;
    parentSubsystem: string;
    parentId: string;
    constructor(itemId: string);
    getPath(): Promise<any[]>;
}
export declare class CloudstackHostPage extends CloudstackSingleItemPage {
    subsystem: string;
    itemId: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class CloudstackInstancePage extends CloudstackSingleItemPage {
    subsystem: string;
    itemId: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class CloudstackVolumePage extends CloudstackSingleItemPage {
    subsystem: string;
    itemId: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class CloudstackPrimarystoragePage extends CloudstackSingleItemPage {
    subsystem: string;
    itemId: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
