import { MenuItem, Newable } from "@xormon/common/menuResponse.dto";
import { DefaultFolder, DefaultPage } from "./MenuDefinitions";
import { Page } from "@xormon/common/pageResponse.dto";
import { Status as StatusEntity } from '@xormon/entity/healthStatus.entity';
import { Status } from "@xormon/common/healthStatus.dto";
export declare namespace Ddnintelliflash {
    class Folder extends DefaultFolder {
        hwType: string;
    }
    export class DeviceFolder extends Folder {
        getChildren(): Promise<any[]>;
    }
    export class DeviceFolderRoot extends Folder {
        getChildren(): Promise<MenuItem[]>;
    }
    export abstract class SubsystemItemsFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<any[]>;
    }
    export class NodeitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class NodeFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<MenuItem[]>;
    }
    export class SfasystemsFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<MenuItem[]>;
    }
    export class ExascalersFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<MenuItem[]>;
    }
    export class SfasystemsitemsFolder extends Folder {
        getChildren(): Promise<MenuItem[]>;
    }
    export class ExascaleritemsFolder extends Folder {
        getChildren(): Promise<MenuItem[]>;
    }
    export class SfaFolder extends Folder {
        getChildren(): Promise<MenuItem[]>;
    }
    export class ExascalerFolder extends Folder {
        getChildren(): Promise<MenuItem[]>;
    }
    abstract class SubsystemFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<MenuItem[]>;
    }
    abstract class ClusterFolder extends Folder {
        subsystem: string;
        getChildren(): Promise<MenuItem[]>;
    }
    export class SfapoolFolder extends SubsystemFolder {
        subsystem: string;
    }
    export class SfavolumeFolder extends SubsystemFolder {
        subsystem: string;
    }
    export class SfadriveFolder extends SubsystemFolder {
        subsystem: string;
    }
    export class SfapoolitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class SfavolumeitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class SfadriveitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class DDNPage extends DefaultPage {
        hwType: string;
        withItemId: boolean;
        rootFolder: Newable<DefaultFolder>;
    }
    export class ConfigurationPage extends DDNPage {
        getPage(): Promise<Page>;
    }
    export class HealthstatusPage extends DDNPage {
        getPage(): Promise<Page>;
    }
    export class ShealthstatusPage extends DDNPage {
        getPage(): Promise<Page>;
    }
    export class ExascalershealthstatusPage extends DDNPage {
        getPage(): Promise<Page>;
    }
    export class SfacapacityPage extends DDNPage {
        title: string;
        getPage(): Promise<Page>;
    }
    export class ExascalerscapacityPage extends DDNPage {
        title: string;
        getPage(): Promise<Page>;
    }
    export class CapacityPage extends DDNPage {
        title: string;
        getPage(): Promise<Page>;
    }
    export class SfaconfigurationPage extends DDNPage {
        getPage(): Promise<Page>;
    }
    export class ExascalerconfigurationPage extends DDNPage {
        getPage(): Promise<Page>;
    }
    export class SfahealthstatusPage extends DDNPage {
        getPage(): Promise<Page>;
        transformEntityStatus(property_name: StatusEntity): Status;
    }
    export class ExascalerhealthstatusPage extends DDNPage {
        getPage(): Promise<Page>;
        transformEntityStatus(property_name: StatusEntity): Status;
    }
    export abstract class ItemPage extends DDNPage {
        subsystem: string;
        withItemId: boolean;
        getPage(): Promise<Page>;
    }
    export abstract class DevicePage extends DDNPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    export class NodePage extends ItemPage {
        subsystem: string;
    }
    export class PoolPage extends ItemPage {
        subsystem: string;
    }
    export class DrivePage extends ItemPage {
        subsystem: string;
    }
    export class SfaPage extends ItemPage {
        subsystem: string;
    }
    export class VolumePage extends ItemPage {
        subsystem: string;
    }
    export class ExascalerPage extends ItemPage {
        subsystem: string;
    }
    export class FsPage extends ItemPage {
        subsystem: string;
    }
    export class OssPage extends ItemPage {
        subsystem: string;
    }
    export class OstPage extends ItemPage {
        subsystem: string;
    }
    abstract class TotalsItemPage extends DDNPage {
        subsystem: string;
        page: string;
        getPage(): Promise<Page>;
    }
    export class MemoryPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class CpuPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class IoPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class DataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class LatencyPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfadataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfaioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfalatencyPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfablocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfavolumeioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfapoolioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfadriveioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfavolumedataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfapooldataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfadrivedataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfavolumeblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfapoolblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfadriveblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfavolumeresptPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfapoolresptPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfadriveresptPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfavolumecapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfapoolcapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class SfadrivecapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerdataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalermemoryPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalercpuPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalercapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerossFolder extends ClusterFolder {
        subsystem: string;
    }
    export class ExascalerostFolder extends ClusterFolder {
        subsystem: string;
    }
    export class ExascalerfsFolder extends ClusterFolder {
        subsystem: string;
    }
    export class ExascalerossitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class ExascalerostitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class ExascalerfsitemsFolder extends SubsystemItemsFolder {
        subsystem: string;
    }
    export class ExascalerfsioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerfsdataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerfscapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerfsblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerossioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerossdataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerossmemoryPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerosscpuPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerossblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerosscapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerostioPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerostdataPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerostblocksizePage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export class ExascalerostcapacityPage extends TotalsItemPage {
        subsystem: string;
        page: string;
    }
    export {};
}
