import { Newable } from '@xormon/common/menuResponse.dto';
import { Page } from '@xormon/common/pageResponse.dto';
import { DefaultFolder, DefaultPage } from './MenuDefinitions';
export declare namespace Docker {
    class Folder extends DefaultFolder {
        hwType: string;
    }
    export class RootFolder extends Folder {
        getChildren(): Promise<any[]>;
        getChildrenAcl(): Promise<any[]>;
    }
    export class HostFolder extends Folder {
        getChildren(): Promise<any[]>;
    }
    export class ContainerfolderFolder extends Folder {
        getChildren(): Promise<any[]>;
    }
    export class VolumefolderFolder extends Folder {
        getChildren(): Promise<any[]>;
    }
    class DockerPage extends DefaultPage {
        hwType: string;
        rootFolder: Newable<DefaultFolder>;
    }
    class DockerTotalsPage extends DockerPage {
        withItemId: boolean;
    }
    export class HeatmapPage extends DockerPage {
        title: string;
        getPage(): Promise<Page>;
    }
    export class HostPage extends DockerTotalsPage {
        title: string;
        getPage(): Promise<Page>;
    }
    export class TotalsPage extends DockerTotalsPage {
        title: string;
        getPage(): Promise<Page>;
    }
    export class ContainerPage extends DockerPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    export class VolumePage extends DockerPage {
        subsystem: string;
        getPage(): Promise<Page>;
    }
    export {};
}
