"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EcsHealthstatusvdcPage = exports.EcsConfigurationvdcPage = exports.EcsHealthstatusPage = exports.EcsCapacityvdcPage = exports.EcsCapacityPage = exports.EcsConfigurationPage = exports.EcsNodePage = exports.EcsVdcPage = exports.EcsNodenetworkPage = exports.EcsNodelatencyPage = exports.EcsNodememoryPage = exports.EcsNodecpuPage = exports.EcsNodetpsPage = exports.EcsNodediskPage = exports.EcsNodedataPage = exports.EcsVdccapacityPage = exports.EcsVdcnetworkPage = exports.EcsVdclatencyPage = exports.EcsVdcmemoryPage = exports.EcsVdccpuPage = exports.EcsVdcdiskPage = exports.EcsVdctpsPage = exports.EcsVdcdataPage = exports.EcsPage = exports.EcsNodeitemsFolder = exports.EcsSubsystemItemsFolder = exports.EcsNodeFolder = exports.EcsVdcitemFolder = exports.EcsVdcFolder = void 0;
const menuResponse_dto_1 = require("../../../common/menuResponse.dto");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const dataSource_1 = require("../../../config/dataSource");
const itemRelation_entity_1 = require("../../../entity/itemRelation.entity");
const objectItem_entity_1 = require("../../../entity/objectItem.entity");
const Stor_1 = require("./Stor");
const MetricsWrapper_1 = require("../../metrics/MetricsWrapper");
const Menu = require("./Menu");
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const Color_1 = require("../../metrics/Color");
const HealthStatus_1 = require("./HealthStatus");
const Table_1 = require("./Table");
const itemProperty_entity_1 = require("../../../entity/itemProperty.entity");
const class_constants_1 = require("../../../common/constants/class.constants");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const CapacityTableBuilder_1 = require("./CapacityTableBuilder");
class EcsFolder {
    constructor(itemId) {
        this.hwType = hwTypeKey_constants_1.HwTypeKey.ECS;
        this.objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
        this.itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
        if (itemId !== null) {
            this.itemId = itemId.toString();
        }
    }
    makeMenuLinks(items, prefix) {
        if (prefix) {
            return items.map(({ key, label }) => (new menuResponse_dto_1.MenuLink(label, this.hwType + `/${prefix}-${key}?item_id=` + this.itemId, `${prefix}-${key}`)));
        }
        return items.map(({ key, label }) => (new menuResponse_dto_1.MenuLink(label, this.hwType + `/${key}?item_id=` + this.itemId, `${key}`)));
    }
}
class EcsVdcFolder extends EcsFolder {
    async getChildren() {
        const items = [
            { label: 'TPS', key: 'tps' },
            { label: 'CPU', key: 'cpu' },
            { label: 'Data', key: 'data' },
            { label: 'Disk', key: 'disk' },
            { label: 'Latency', key: 'latency', },
            { label: 'Memory', key: 'memory' },
            { label: 'Network', key: 'network' },
            { label: 'Capacity', key: 'capacity' },
        ];
        const menuItems = this.makeMenuLinks(items, 'vdc');
        const vdcs = await this.objectItemsRepository.findBy({
            hw_type: this.hwType,
            subsystem: 'vdc',
        });
        vdcs.sort((a, b) => a.label.localeCompare(b.label, undefined, { numeric: true, sensitivity: 'base' }));
        for (let vdc of vdcs) {
            let path = this.hwType + '/vdc-item?ids=' + vdc.item_id;
            menuItems.push(new menuResponse_dto_1.MenuFolder(vdc.label, path, this.hwType, 'vdc-item', vdc.item_id));
        }
        this.children = menuItems;
        return menuItems;
    }
    async getPath() { }
}
exports.EcsVdcFolder = EcsVdcFolder;
class EcsVdcitemFolder extends EcsFolder {
    async getChildren() {
        const menuItems = this.makeMenuLinks([{ label: 'Totals', key: 'vdc' }]);
        const items = [
            { label: 'Configuration', key: 'configuration-vdc' },
            { label: 'Capacity', key: 'capacity-vdc' },
            { label: 'Health Status', key: 'health-status-vdc' },
        ];
        menuItems.push(...this.makeMenuLinks(items));
        const subsystems = ['Node'];
        for (let subsystem of subsystems) {
            const path = this.hwType + '/' + subsystem + '?ids=' + this.itemId;
            menuItems.push(new menuResponse_dto_1.MenuFolder(subsystem, path, this.hwType, subsystem.toLowerCase(), this.itemId));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.EcsVdcitemFolder = EcsVdcitemFolder;
class EcsNodeFolder extends EcsFolder {
    async getChildren() {
        const items = [
            { label: 'TPS', key: 'tps' },
            { label: 'CPU', key: 'cpu' },
            { label: 'Data', key: 'data' },
            { label: 'Disk', key: 'disk' },
            { label: 'Latency', key: 'latency' },
            { label: 'Memory', key: 'memory' },
            { label: 'Network', key: 'network' },
        ];
        const menuItems = this.makeMenuLinks(items, 'node');
        let path = this.hwType + '/node-items?ids=' + this.itemId;
        menuItems.push(new menuResponse_dto_1.MenuFolder('Items', path, this.hwType, 'node', this.itemId));
        this.children = menuItems;
        return menuItems;
    }
}
exports.EcsNodeFolder = EcsNodeFolder;
class EcsSubsystemItemsFolder extends EcsFolder {
    constructor(itemId, subsystem) {
        super(itemId);
        this.subsystem = subsystem;
    }
    async getChildren() {
        let menuItems = [];
        const items = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                parents: {
                    parent: this.itemId.toString()
                },
                subsystem: this.subsystem
            }
        });
        for (let item of items) {
            menuItems.push(new menuResponse_dto_1.MenuLink(item.label, this.hwType + '/' + this.subsystem + '?item_id=' + item.item_id, item.subsystem));
        }
        this.children = menuItems;
        return menuItems;
    }
}
exports.EcsSubsystemItemsFolder = EcsSubsystemItemsFolder;
class EcsNodeitemsFolder extends EcsSubsystemItemsFolder {
    constructor(itemId) {
        super(itemId, 'node');
    }
}
exports.EcsNodeitemsFolder = EcsNodeitemsFolder;
class EcsPage {
    constructor(itemId, request) {
        this.itemId = itemId;
        this.request = request;
        this.hwType = hwTypeKey_constants_1.HwTypeKey.ECS;
        this.objectItemsRepository = (0, dataSource_1.getDataSource)().getRepository(objectItem_entity_1.ObjectItem);
        this.itemRelationsRepository = (0, dataSource_1.getDataSource)().getRepository(itemRelation_entity_1.ItemRelation);
    }
    async getPath() {
        let root = new Stor_1.StorRootFolder(this.hwType);
        let menuItems = await root.getChildren();
        for (const menuItem of menuItems) {
            if (menuItem.subsystem === 'device') {
                const deviceFolder = new Stor_1.StorDeviceFolder(this.hwType, 'device', menuItem.itemId);
                menuItem.children = await deviceFolder.getChildren();
            }
        }
        return menuItems;
    }
}
exports.EcsPage = EcsPage;
class EcsSingleItemPage extends EcsPage {
    constructor(itemId, request, subsystem) {
        super(itemId, request);
        if (subsystem) {
            this.subsystem = subsystem;
        }
    }
    async getPath(subsystem, items) {
        let root = new Stor_1.StorRootFolder(this.hwType);
        let menuItems = await root.getChildren();
        const item = await this.objectItemsRepository.findOne({
            where: {
                item_id: this.itemId
            },
            relations: {
                parents: {
                    _parent: true
                }
            }
        });
        const device = item.subsystem === 'device'
            ? item
            : item.parents.find(parent => parent._parent.subsystem === 'device')?._parent;
        const vdcId = item.subsystem === 'device'
            ? undefined
            : item.subsystem === 'vdc'
                ? this.itemId
                : item.parents.find(parent => parent._parent.subsystem === 'vdc')._parent.item_id;
        for (const menuItem of menuItems) {
            if (!device || !(menuItem.subsystem === 'device' && menuItem.itemId === device.item_id)) {
                continue;
            }
            const deviceFolder = new Stor_1.StorDeviceFolder(this.hwType, 'device', device.item_id);
            menuItem.children = await deviceFolder.getChildren();
            for (const deviceItem of menuItem.children) {
                if (deviceItem.subsystem !== 'vdc') {
                    continue;
                }
                const siteFolder = new EcsVdcFolder(device.item_id);
                deviceItem.children = await siteFolder.getChildren();
                for (const siteItem of deviceItem.children) {
                    if (siteItem.subsystem !== 'vdc-item' || siteItem.itemId !== vdcId) {
                        continue;
                    }
                    const siteItemFolder = new EcsVdcitemFolder(vdcId);
                    siteItem.children = await siteItemFolder.getChildren();
                    if (!subsystem) {
                        break;
                    }
                    for (const subsystemItem of siteItem.children) {
                        if (subsystemItem.subsystem !== subsystem) {
                            continue;
                        }
                        const subsystemLabel = subsystem.charAt(0).toUpperCase() + subsystem.slice(1);
                        const subsystemFolder = new Menu[`Ecs${subsystemLabel}Folder`](vdcId);
                        subsystemItem.children = await subsystemFolder.getChildren();
                        if (items) {
                            for (const subsytemChild of subsystemItem.children) {
                                if (subsytemChild.title !== 'Items') {
                                    continue;
                                }
                                const itemsFolder = new Menu[`Ecs${subsystemLabel}itemsFolder`](vdcId);
                                subsytemChild.children = await itemsFolder.getChildren();
                                break;
                            }
                        }
                        break;
                    }
                }
            }
        }
        return menuItems;
    }
}
class EcsMetrics extends pageResponse_dto_1.Metric {
    constructor(subsystem, metric) {
        super();
        this.metric = metric;
        const definition = MetricsWrapper_1.MetricsWrapper.getMetric(class_constants_1.ClassKey.STORAGE, hwTypeKey_constants_1.HwTypeKey.ECS, subsystem, metric);
        if (definition) {
            Object.assign(this, definition);
        }
    }
    getGraph(type, stacked, order, color, aggregate) {
        this.type = type;
        this.stacked = stacked || false;
        this.order = order || 0;
        this.color = color || undefined;
        this.aggregate = aggregate || undefined;
        return this;
    }
}
class EcsVdcItemPage extends EcsSingleItemPage {
    async getIds() {
        return (await this.objectItemsRepository.find({
            where: {
                parents: {
                    parent: this.itemId
                },
                subsystem: this.subsystem,
            }, relations: {
                parents: true
            }
        })).map(subs => subs.item_id);
    }
    async getPath(subsystem, items) {
        return await super.getPath(this.subsystem ? this.subsystem : subsystem, items);
    }
    getMetricByIds({ uuids, aggregated = true }) {
        return (title, metric, ...data) => {
            return {
                title,
                content: [
                    {
                        uuids,
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        aggregated,
                        metrics: [new EcsMetrics(this.subsystem, metric).getGraph(...data)],
                    },
                ],
            };
        };
    }
    getMetricsByIds({ uuids }) {
        return (title, data) => {
            return {
                title,
                content: [
                    {
                        uuids,
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        aggregated: false,
                        metrics: data.map(([metric, ...rest]) => new EcsMetrics(this.subsystem, metric).getGraph(...rest))
                    },
                ],
            };
        };
    }
}
class EcsTabs extends EcsVdcItemPage {
    constructor(itemId, request, subsystem) {
        super(itemId, request, subsystem);
    }
    async getPage() {
        const tabs = [];
        const ids = await this.getIds();
        if (this.singleMetricGraphs) {
            const getMetric = this.getMetricByIds({ uuids: ids });
            tabs.push(...this.singleMetricGraphs.map(metricParms => getMetric(...metricParms)));
        }
        if (this.multipleMetricGraphs) {
            const getMetric = this.getMetricsByIds({ uuids: ids });
            this.multipleMetricGraphs.forEach(([tabPosition, ...metricParms]) => {
                if (isNaN(tabPosition)) {
                    tabs.push(getMetric(...metricParms));
                    return;
                }
                tabs.splice(tabPosition, 0, getMetric(...metricParms));
            });
        }
        this.page = new pageResponse_dto_1.Page(this.pageTitle, tabs);
        return this.page;
    }
}
class EcsVdcTabs extends EcsTabs {
    constructor(itemId, request) {
        super(itemId, request, 'vdc');
    }
}
class EcsNodeTabs extends EcsTabs {
    constructor(itemId, request) {
        super(itemId, request, 'node');
    }
}
class EcsVdcdataPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC Data';
        this.singleMetricGraphs = [
            ['Sum', 'data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read', 'read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write', 'write', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total', [
                    ['write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsVdcdataPage = EcsVdcdataPage;
class EcsVdctpsPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC TPS';
        this.singleMetricGraphs = [
            ['Sum', 'tps_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read', 'read_tps', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write', 'write_tps', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Error', 'error_rate_tps', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total', [
                    ['write_tps', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['read_tps', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsVdctpsPage = EcsVdctpsPage;
class EcsVdcdiskPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC Disk';
        this.singleMetricGraphs = [
            ['Sum', 'disk_data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read', 'disk_read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write', 'disk_write', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Sum Geo', 'disk_geo_data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read Geo', 'disk_geo_read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write Geo', 'disk_geo_write', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Sum User', 'disk_user_data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read User', 'disk_user_read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write User', 'disk_user_write', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total ', [
                    ['disk_write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['disk_read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]],
            [4, 'Total Geo', [
                    ['disk_geo_write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['disk_geo_read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]],
            [8, 'Total User', [
                    ['disk_user_write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['disk_user_read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]],
        ];
    }
}
exports.EcsVdcdiskPage = EcsVdcdiskPage;
class EcsVdccpuPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC CPU';
        this.singleMetricGraphs = [
            ['System', 'cpu_system', pageResponse_constants_1.CHART_TYPE.line],
        ];
    }
}
exports.EcsVdccpuPage = EcsVdccpuPage;
class EcsVdcmemoryPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC Memory';
        this.singleMetricGraphs = [
            ['Memory', 'memory', pageResponse_constants_1.CHART_TYPE.line],
            ['Used', 'memory_used', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Free', 'memory_free', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
    }
}
exports.EcsVdcmemoryPage = EcsVdcmemoryPage;
class EcsVdclatencyPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC Latency';
        this.singleMetricGraphs = [
            ['Average', 'resp_t', pageResponse_constants_1.CHART_TYPE.line],
            ['Read', 'resp_t_r', pageResponse_constants_1.CHART_TYPE.line],
            ['Write', 'resp_t_w', pageResponse_constants_1.CHART_TYPE.line],
        ];
    }
}
exports.EcsVdclatencyPage = EcsVdclatencyPage;
class EcsVdcnetworkPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC Network';
        this.singleMetricGraphs = [
            ['Sum', 'network_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Out', 'network_tx', pageResponse_constants_1.CHART_TYPE.area, true],
            ['In', 'network_rx', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Total Utilization', 'network_util', pageResponse_constants_1.CHART_TYPE.line],
            ['Out Utilization', 'network_util_tx', pageResponse_constants_1.CHART_TYPE.line],
            ['In Utilization', 'network_util_rx', pageResponse_constants_1.CHART_TYPE.line],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total', [
                    ['network_tx', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['network_rx', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsVdcnetworkPage = EcsVdcnetworkPage;
class EcsVdccapacityPage extends EcsVdcTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'VDC Capacity';
        this.singleMetricGraphs = [
            ['Used', 'capacity_used', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Used %', 'capacity_used_percent', pageResponse_constants_1.CHART_TYPE.line],
        ];
        this.multipleMetricGraphs = [
            [0, 'Capacity', [
                    ['capacity_total', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.black, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['capacity_used', pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['capacity_free', pageResponse_constants_1.CHART_TYPE.area, true, 2, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                ]]
        ];
    }
}
exports.EcsVdccapacityPage = EcsVdccapacityPage;
class EcsNodedataPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node Data';
        this.singleMetricGraphs = [
            ['Sum', 'data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read', 'read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write', 'write', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total', [
                    ['write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsNodedataPage = EcsNodedataPage;
class EcsNodediskPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node Disk';
        this.singleMetricGraphs = [
            ['Sum', 'disk_data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read', 'disk_read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write', 'disk_write', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Sum Geo', 'disk_geo_data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read Geo', 'disk_geo_read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write Geo', 'disk_geo_write', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Sum User', 'disk_user_data_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read User', 'disk_user_read', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write User', 'disk_user_write', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total ', [
                    ['disk_write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['disk_read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]],
            [4, 'Total Geo', [
                    ['disk_geo_write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['disk_geo_read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]],
            [8, 'Total User', [
                    ['disk_user_write', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['disk_user_read', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]],
        ];
    }
}
exports.EcsNodediskPage = EcsNodediskPage;
class EcsNodetpsPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node TPS';
        this.singleMetricGraphs = [
            ['Sum', 'tps_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Read', 'read_tps', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Write', 'write_tps', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Error', 'error_rate_tps', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
        this.multipleMetricGraphs = [
            [0, 'Total', [
                    ['write_tps', pageResponse_constants_1.CHART_TYPE.line, false, 0, Color_1.Color.pallete.blueDark, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['read_tps', pageResponse_constants_1.CHART_TYPE.line, false, 1, Color_1.Color.pallete.redDark, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsNodetpsPage = EcsNodetpsPage;
class EcsNodecpuPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node CPU';
        this.singleMetricGraphs = [
            ['System', 'cpu_system', pageResponse_constants_1.CHART_TYPE.line],
        ];
    }
}
exports.EcsNodecpuPage = EcsNodecpuPage;
class EcsNodememoryPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node Memory';
        this.singleMetricGraphs = [
            ['Memory', 'memory', pageResponse_constants_1.CHART_TYPE.line],
            ['Used', 'memory_used', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Free', 'memory_free', pageResponse_constants_1.CHART_TYPE.area, true],
        ];
    }
}
exports.EcsNodememoryPage = EcsNodememoryPage;
class EcsNodelatencyPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node Latency';
        this.singleMetricGraphs = [
            ['Average', 'resp_t', pageResponse_constants_1.CHART_TYPE.line],
            ['Read', 'resp_t_r', pageResponse_constants_1.CHART_TYPE.line],
            ['Write', 'resp_t_w', pageResponse_constants_1.CHART_TYPE.line],
        ];
    }
}
exports.EcsNodelatencyPage = EcsNodelatencyPage;
class EcsNodenetworkPage extends EcsNodeTabs {
    constructor(itemId, request) {
        super(itemId, request);
        this.pageTitle = 'Node Network';
        this.singleMetricGraphs = [
            ['Total', 'network_rate', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Out', 'network_tx', pageResponse_constants_1.CHART_TYPE.area, true],
            ['In', 'network_rx', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Total Utilization', 'network_util', pageResponse_constants_1.CHART_TYPE.line],
            ['Out Utilization', 'network_util_tx', pageResponse_constants_1.CHART_TYPE.line],
            ['In Utilization', 'network_util_rx', pageResponse_constants_1.CHART_TYPE.line],
        ];
    }
}
exports.EcsNodenetworkPage = EcsNodenetworkPage;
class SubsystemItemPage extends EcsVdcItemPage {
    async getPage() {
        const tabs = [];
        const item = await this.objectItemsRepository.findOneBy({ item_id: this.itemId });
        if (this.singleMetricGraphs) {
            const getMetric = this.getMetricByIds({ uuids: [item.item_id], aggregated: false });
            tabs.push(...this.singleMetricGraphs.map(metricParms => getMetric(...metricParms)));
        }
        if (this.multipleMetricGraphs) {
            const getMetric = this.getMetricsByIds({ uuids: [item.item_id] });
            this.multipleMetricGraphs.forEach(([tabPosition, ...metricParms]) => {
                if (isNaN(tabPosition)) {
                    tabs.push(getMetric(...metricParms));
                    return;
                }
                tabs.splice(tabPosition, 0, getMetric(...metricParms));
            });
        }
        this.page = new pageResponse_dto_1.Page(item.label, tabs);
        return this.page;
    }
    async getPath() {
        const superPath = await super.getPath(this.subsystem, true);
        return superPath;
    }
}
class EcsVdcPage extends SubsystemItemPage {
    constructor(itemId, request) {
        super(itemId, request, 'vdc');
        this.singleMetricGraphs = [
            ['TPS', 'tps_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['TPS Read', 'read_tps', pageResponse_constants_1.CHART_TYPE.line],
            ['TPS Write', 'write_tps', pageResponse_constants_1.CHART_TYPE.line],
            ['TPS Error', 'error_rate_tps', pageResponse_constants_1.CHART_TYPE.line],
            ['System', 'cpu_system', pageResponse_constants_1.CHART_TYPE.line],
            ['Data', 'data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Read', 'read', pageResponse_constants_1.CHART_TYPE.line],
            ['Write', 'write', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Data', 'disk_data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Read', 'disk_read', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Write', 'disk_write', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Geo Data', 'disk_geo_data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Geo Read', 'disk_geo_read', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Geo Write', 'disk_geo_write', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk User Data', 'disk_user_data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk User Read', 'disk_user_read', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk User Write', 'disk_user_write', pageResponse_constants_1.CHART_TYPE.line],
            ['Latency', 'resp_t', pageResponse_constants_1.CHART_TYPE.line],
            ['Latency Read', 'resp_t_r', pageResponse_constants_1.CHART_TYPE.line],
            ['Latency Write', 'resp_t_w', pageResponse_constants_1.CHART_TYPE.line],
            ['Memory Util', 'memory', pageResponse_constants_1.CHART_TYPE.line],
            ['Net', 'network_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Net Out', 'network_tx', pageResponse_constants_1.CHART_TYPE.line],
            ['Net In', 'network_rx', pageResponse_constants_1.CHART_TYPE.line],
            ['Net Utilization', 'network_util', pageResponse_constants_1.CHART_TYPE.line],
            ['Net Out Utilization', 'network_util_tx', pageResponse_constants_1.CHART_TYPE.line],
            ['Net In Utilization', 'network_util_rx', pageResponse_constants_1.CHART_TYPE.line],
            ['Used', 'capacity_used', pageResponse_constants_1.CHART_TYPE.area, true],
            ['Used %', 'capacity_used_percent', pageResponse_constants_1.CHART_TYPE.line],
        ];
        this.multipleMetricGraphs = [
            [18, 'Memory', [
                    ['memory_used', pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['memory_free', pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsVdcPage = EcsVdcPage;
class EcsNodePage extends SubsystemItemPage {
    constructor(itemId, request) {
        super(itemId, request, 'node');
        this.singleMetricGraphs = [
            ['TPS', 'tps_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['TPS Read', 'read_tps', pageResponse_constants_1.CHART_TYPE.line],
            ['TPS Write', 'write_tps', pageResponse_constants_1.CHART_TYPE.line],
            ['TPS Error', 'error_rate_tps', pageResponse_constants_1.CHART_TYPE.line],
            ['System', 'cpu_system', pageResponse_constants_1.CHART_TYPE.line],
            ['Data', 'data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Read', 'read', pageResponse_constants_1.CHART_TYPE.line],
            ['Write', 'write', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Data', 'disk_data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Read', 'disk_read', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Write', 'disk_write', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Geo data', 'disk_geo_data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Geo read', 'disk_geo_read', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk Geo write', 'disk_geo_write', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk User data', 'disk_user_data_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk User read', 'disk_user_read', pageResponse_constants_1.CHART_TYPE.line],
            ['Disk User write', 'disk_user_write', pageResponse_constants_1.CHART_TYPE.line],
            ['Latency', 'resp_t', pageResponse_constants_1.CHART_TYPE.line],
            ['Latency Read', 'resp_t_r', pageResponse_constants_1.CHART_TYPE.line],
            ['Latency Write', 'resp_t_w', pageResponse_constants_1.CHART_TYPE.line],
            ['Memory Util', 'memory', pageResponse_constants_1.CHART_TYPE.line],
            ['Net', 'network_rate', pageResponse_constants_1.CHART_TYPE.line],
            ['Net Out', 'network_tx', pageResponse_constants_1.CHART_TYPE.line],
            ['Net In', 'network_rx', pageResponse_constants_1.CHART_TYPE.line],
            ['Net Utilization', 'network_util', pageResponse_constants_1.CHART_TYPE.line],
            ['Net Out Utilization', 'network_util_tx', pageResponse_constants_1.CHART_TYPE.line],
            ['Net In Utilization', 'network_util_rx', pageResponse_constants_1.CHART_TYPE.line],
        ];
        this.multipleMetricGraphs = [
            [18, 'Memory', [
                    ['memory_used', pageResponse_constants_1.CHART_TYPE.area, true, 0, Color_1.Color.pallete.red, pageResponse_constants_1.METRIC_AGGREGATE.sum],
                    ['memory_free', pageResponse_constants_1.CHART_TYPE.area, true, 1, Color_1.Color.pallete.green, pageResponse_constants_1.METRIC_AGGREGATE.sum]
                ]]
        ];
    }
}
exports.EcsNodePage = EcsNodePage;
class EcsConfigurationPage extends EcsPage {
    constructor() {
        super(...arguments);
        this.itemPropertiesRepository = (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty);
    }
    async getPage() {
        const tabs = [];
        const itemProperties = await this.itemPropertiesRepository.find({
            where: {
                item_id: this.itemId,
                property_name: 'conf',
            }
        });
        const vdcTable = new Table_1.Table()
            .addHeader({ value: 'Alias' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Serial' });
        const nodeTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'VDC' })
            .addHeader({ value: 'IP' })
            .addHeader({ value: 'Version' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.vdc) {
                    for (const row of data.vdc) {
                        vdcTable.addRow([
                            { order: 0, value: row.alias },
                            { order: 1, value: row.name },
                            { order: 2, value: row.serial },
                        ]);
                    }
                }
                else {
                    vdcTable.addRow([
                        { order: 0, value: '-' },
                        { order: 1, value: '-' },
                        { order: 2, value: '-' },
                    ]);
                }
                if (data.node) {
                    for (const row of data.node) {
                        nodeTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.vdc },
                            { order: 2, value: row.host },
                            { order: 3, value: row.version },
                        ]);
                    }
                }
                else {
                    nodeTable.addRow([
                        { order: 0, value: '-' },
                        { order: 1, value: '-' },
                        { order: 2, value: '-' },
                        { order: 3, value: '-' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Configuration',
            content: [
                makeHeader('VDC'),
                vdcTable.generateBox(),
                makeHeader('NODE'),
                nodeTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page("Configuration", tabs);
        return this.page;
    }
}
exports.EcsConfigurationPage = EcsConfigurationPage;
class EcsCapacityPage extends EcsPage {
    async getPage() {
        const tabs = [];
        const subsystems = [
            ['vdc', 'VDC', {
                    total: 'capacity_total',
                    used: 'capacity_used',
                    free: 'capacity_free',
                }],
            ['namespace', 'Namespace', {
                    total: 'hard_quota',
                    used: 'size',
                    free: 'capacity_free',
                }],
            ['bucket', 'Bucket', {
                    total: 'hard_quota',
                    used: 'size',
                    free: 'capacity_free',
                }],
        ];
        for (const [subsystem, tabTitle, metrics] of subsystems) {
            const items = await this.objectItemsRepository.find({
                where: {
                    hw_type: hwTypeKey_constants_1.HwTypeKey.ECS,
                    subsystem,
                }
            });
            if (subsystem !== 'vdc') {
                tabs.push({
                    title: tabTitle,
                    content: [
                        await new CapacityTableBuilder_1.CapacityTableBuilder(subsystem, this.request)
                            .setItemLabel(tabTitle)
                            .addItems(items.map(it => it.item_id))
                            .addDefaultMetrics()
                            .addUsed()
                            .addTotal()
                            .generateBox()
                    ],
                });
                continue;
            }
            tabs.push({
                title: tabTitle,
                content: await new CapacityTableBuilder_1.CapacityTableBuilder(subsystem, this.request)
                    .setItemLabel(tabTitle)
                    .addItems(items.map(it => it.item_id))
                    .addMetric(metrics.total, "Total")
                    .addMetric(metrics.used, "Used")
                    .addMetric(metrics.free, "Free")
                    .addUsed({ total: metrics.total, used: metrics.used })
                    .addTotal()
                    .addPrediction()
                    .generateContentWithPredictions()
            });
        }
        ;
        this.page = new pageResponse_dto_1.Page("Capcity", tabs);
        return this.page;
    }
}
exports.EcsCapacityPage = EcsCapacityPage;
class EcsCapacityvdcPage extends EcsSingleItemPage {
    async getPage() {
        const items = await this.objectItemsRepository.find({
            where: {
                item_id: this.itemId
            }
        });
        this.page = new pageResponse_dto_1.Page("Capcity", [{
                title: 'VDC',
                content: await new CapacityTableBuilder_1.CapacityTableBuilder("vdc", this.request)
                    .setItemLabel("VDC")
                    .addItems(items.map(it => it.item_id))
                    .addDefaultMetrics()
                    .addUsed()
                    .addPrediction()
                    .generateContentWithPredictions(),
            }]);
        return this.page;
    }
}
exports.EcsCapacityvdcPage = EcsCapacityvdcPage;
function makeHeader(text) {
    return {
        type: pageResponse_constants_1.BOX_TYPE.TextBox,
        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
        text
    };
}
class EcsHealthstatusPage extends Stor_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const subsystemsHealthStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId);
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                makeHeader("VDC"),
                {
                    ...subsystemsHealthStatusBox,
                    rows: subsystemsHealthStatusBox.rows.filter(row => row[1].value[0] === 'vdc'),
                    header: [...subsystemsHealthStatusBox.header.slice(0, 1), ...subsystemsHealthStatusBox.header.slice(2, subsystemsHealthStatusBox.header.length - 1)]
                },
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.EcsHealthstatusPage = EcsHealthstatusPage;
class EcsConfigurationvdcPage extends EcsSingleItemPage {
    constructor() {
        super(...arguments);
        this.itemPropertiesRepository = (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty);
    }
    async getPage() {
        const tabs = [];
        const itemProperties = await this.itemPropertiesRepository.find({
            where: {
                item_id: this.itemId,
                property_name: 'conf',
            }
        });
        const vdcTable = new Table_1.Table();
        const nodeTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'IP' })
            .addHeader({ value: 'Version' });
        const vdcKeys = ['Alias', 'Name', 'Serial'];
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.vdc) {
                    const row = [];
                    vdcKeys.forEach(key => {
                        vdcTable.addHeader({ value: key });
                        row.push({ order: 0, value: data.vdc[key] || '-' });
                    });
                    vdcTable.addRow(row);
                }
                if (data.node) {
                    for (const row of data.node) {
                        nodeTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.host },
                            { order: 2, value: row.version },
                        ]);
                    }
                }
                else {
                    nodeTable.addRow([
                        { order: 0, value: '-' },
                        { order: 1, value: '-' },
                        { order: 2, value: '-' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Configuration',
            content: [
                vdcTable.generatePivotBox(),
                makeHeader('NODE'),
                nodeTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page("VDC Configuration", tabs);
        return this.page;
    }
}
exports.EcsConfigurationvdcPage = EcsConfigurationvdcPage;
class EcsHealthstatusvdcPage extends EcsSingleItemPage {
    constructor() {
        super(...arguments);
        this.itemPropertiesRepository = (0, dataSource_1.getDataSource)().getRepository(itemProperty_entity_1.ItemProperty);
    }
    async getPage() {
        const tabs = [];
        const healthStatus = new HealthStatus_1.HealthStatus().getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({
            where: {
                item_id: this.itemId,
                property_name: 'hs',
            }
        });
        const alertsTable = new Table_1.Table()
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Data' })
            .addHeader({ value: 'Description' });
        const vdcTable = new Table_1.Table();
        const vdcHsKeys = ['maintenance disks', 'bad disks', 'maintenance nodes', 'critical alerts', 'bad nodes', 'error alerts', 'warning alerts'];
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.alerts) {
                    for (const row of data.alerts) {
                        alertsTable.addRow([
                            { order: 0, value: row.alertSeverity },
                            { order: 1, value: row.id },
                            { order: 2, value: row.alertTime },
                            { order: 3, value: row.alertText },
                        ]);
                    }
                }
                else {
                    alertsTable.addRow([
                        { order: 0, value: '-' },
                        { order: 1, value: '-' },
                        { order: 2, value: '-' },
                        { order: 3, value: '-' },
                    ]);
                }
                if (data.hs) {
                    const row = [];
                    vdcHsKeys.forEach(key => {
                        vdcTable.addHeader({ value: key });
                        row.push({ order: 0, value: +data.hs[key] });
                    });
                    vdcTable.addRow(row);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                await healthStatus,
                makeHeader('VDC state'),
                vdcTable.generatePivotBox(),
                makeHeader('Alerts'),
                alertsTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page("VDC Health Status", tabs);
        return this.page;
    }
}
exports.EcsHealthstatusvdcPage = EcsHealthstatusvdcPage;
//# sourceMappingURL=Ecs.js.map