import { Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { Request } from 'express';
import { AbstractFolder, AbstractPage } from "./AbstractMenu";
export declare class KubernetesFolder extends AbstractFolder {
    hwType: string;
}
export declare class KubernetesSubsystemFolder extends KubernetesFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class KubernetesRootFolder extends KubernetesFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class KubernetesClusterFolder extends KubernetesSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class KubernetesNodeFolder extends KubernetesSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class KubernetesNamespacesFolder extends KubernetesSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class KubernetesNamespaceFolder extends KubernetesSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class KubernetesPodFolder extends KubernetesSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
}
export declare class KubernetesPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare abstract class KubernetesItemPage extends KubernetesPage {
    itemId: string;
    request: Request;
    subsystem: string;
    constructor(itemId: string, request: Request);
}
export declare class KubernetesConfigurationPage extends KubernetesPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class KubernetesClusternodetotalsPage extends KubernetesItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class KubernetesClusternamespacetotalsPage extends KubernetesItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class KubernetesClusterpodsaggregatedPage extends KubernetesItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class KubernetesNodePage extends KubernetesItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class KubernetesNamespacePage extends KubernetesItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class KubernetesPodPage extends KubernetesItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class KubernetesContainerPage extends KubernetesItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class KubernetesHeatmapPage extends KubernetesPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class KubernetesTopPage extends KubernetesPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class KubernetesPodoverviewPage extends KubernetesPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class KubernetesMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
