import { MenuItem, Newable } from '@xormon/common/menuResponse.dto';
import { ChartType, MetricAggregate, Page } from '@xormon/common/pageResponse.dto';
import { AbstractFolder, AbstractPage } from './AbstractMenu';
export declare class NutanixFolder extends AbstractFolder {
    hwType: string;
}
export declare class NutanixSubsystemFolder extends NutanixFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare class NutanixRootFolder extends NutanixFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class NutanixClusterFolder extends NutanixSubsystemFolder {
    subsystem: string;
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class NutanixChildSubsystemFolder extends NutanixSubsystemFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class NutanixHostFolder extends NutanixChildSubsystemFolder {
    subsystem: string;
}
export declare class NutanixVmFolder extends NutanixChildSubsystemFolder {
    subsystem: string;
}
export declare class NutanixStoragepoolFolder extends NutanixChildSubsystemFolder {
    subsystem: string;
}
export declare class NutanixStoragecontainerFolder extends NutanixChildSubsystemFolder {
    subsystem: string;
}
export declare class NutanixVirtualdiskFolder extends NutanixChildSubsystemFolder {
    subsystem: string;
}
export declare class NutanixPhysicaldiskFolder extends NutanixChildSubsystemFolder {
    subsystem: string;
}
export declare class NutanixStorageFolder extends NutanixSubsystemFolder {
    subsystem: string;
    itemId: string;
    getChildren(): Promise<MenuItem[]>;
}
export declare class NutanixMetrics {
    static Metric: {
        new (): {
            subsystem: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static AggrMetric: {
        new (): {
            aggregate: MetricAggregate;
            subsystem: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpuCoresMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpuCoresUsageMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpuCoresUsageAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpuPercentMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpuPercentPeakMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmCpuPercentAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmMemoryTotalMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmMemoryUsageBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmMemoryUsageBytesAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmMemoryFreeBytesMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmMemoryFreeBytesAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmDataMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmDataAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmIopsReadMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmIopsReadAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmIopsWriteMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmIopsWriteAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmLatencyReadMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmLatencyReadAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmLatencyWriteMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmLatencyWriteAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmReceivedMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmReceivedAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmTransmittedMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static VmTransmittedAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostCpuCoresUsageMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostCpuCoresUsageAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostCpuCoresMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostCpuUsageMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostCpuUsagePeakMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostCpuUsageAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostMemoryUsageMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostMemoryUsageAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostMemoryFreeMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static HostMemoryFreeAggrMetric: {
        new (): {
            subsystem: string;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate: MetricAggregate;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageWriteMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageWriteMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageWriteMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageReadMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageReadMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageReadMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageTotalIoLatencyMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageTotalIoLatencyMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageTotalIoLatencyMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageReadIoMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageReadIoMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageReadIoMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageWriteIoMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageWriteIoMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageWriteIoMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageTotalIoMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageTotalIoMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageTotalIoMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageLatencyMetricBase: {
        new (subsystem: string): {
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            type: ChartType;
            stacked: boolean;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageLatencyMetric: {
        new (subsystem: string): {
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
    static StorageLatencyMetricAggr: {
        new (subsystem: string): {
            aggregate: "items";
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            subsystem: string;
            color: string;
            init(): any;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare class NutanixPage extends AbstractPage {
    hwType: string;
    rootFolder: Newable<AbstractFolder>;
}
export declare class NutanixTotalsPage extends NutanixPage {
    withItemId: boolean;
}
export declare class NutanixHeatmapPage extends NutanixPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class NutanixTopPage extends NutanixPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class NutanixConfigurationPage extends NutanixPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class NutanixVmtopPage extends NutanixPage {
    title: string;
}
export declare class NutanixOverviewPage extends NutanixPage {
    title: string;
    getPage(): Promise<Page>;
}
export declare abstract class NutanixClusterTotalsPage extends NutanixTotalsPage {
    withItemId: boolean;
    subsystem: string;
}
export declare class NutanixClustervmtotalsPage extends NutanixClusterTotalsPage {
    getPage(): Promise<Page>;
}
export declare class NutanixClusterhosttotalsPage extends NutanixClusterTotalsPage {
    getPage(): Promise<Page>;
}
export declare class NutanixClusterstoragetotalsPage extends NutanixClusterTotalsPage {
    getPage(): Promise<Page>;
}
export declare abstract class NutanixSingleItemPage extends NutanixPage {
    subsystem: string;
}
export declare class NutanixVmPage extends NutanixSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class NutanixHostPage extends NutanixSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class NutanixStoragePage extends NutanixSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class NutanixDiskPage extends NutanixStoragePage {
    subsystem: string;
}
export declare class NutanixVdiskPage extends NutanixStoragePage {
    subsystem: string;
}
export declare class NutanixStoragecontainerPage extends NutanixStoragePage {
    subsystem: string;
}
export declare class NutanixStoragepoolPage extends NutanixStoragePage {
    subsystem: string;
}
export declare class NutanixHealthstatusPage extends NutanixPage {
    title: string;
    getPage(): Promise<Page>;
}
