import { TableHeaderGroupBox } from "@xormon/common/pageResponse.dto";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { IMetricType } from "@xormon/service/metrics/Classes";
export interface PerformanceTableHeaderTemplate {
    label: string;
    metricType?: IMetricType;
    subheader: {
        label: string;
        metric: string;
    }[];
}
export interface PTGroup {
    group: string;
    metric: string;
    metricType: IMetricType;
}
interface StartEnd {
    start: number;
    end: number;
}
export declare class PerformanceTable {
    private groups;
    private itemIds;
    private startEnd;
    private itemLabel;
    private isHeated;
    constructor(pTGroups: PTGroup[], startEnd: StartEnd, itemLabel?: string);
    static createPerformanceTableFromTemplate(label: string, headers: PerformanceTableHeaderTemplate[], items: ObjectItem[]): Promise<TableHeaderGroupBox>;
    setHeated(): void;
    addItemIds(itemIds: string[]): void;
    genTable(): Promise<TableHeaderGroupBox>;
}
export {};
