"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnityHealthstatusPage = exports.CompellentCapacityPage = exports.OceanstorpacificnasHealthstatusPage = exports.OceanstorpacificHealthstatusPage = exports.OceanstornasHealthstatusPage = exports.OceanstorHealthstatusPage = exports.VspgCapacityPage = exports._3parCapacityPage = exports.VspgCachetotalPage = exports.VspgCpucpuPage = exports.DatacoreHealthstatusPage = exports.InfiniboxHealthstatusPage = exports.StoragegridHealthstatusPage = exports.PowerstoreHealthstatusPage = exports.NimbleHealthstatusPage = exports._3parHealthstatusPage = exports.SynologyHealthstatusPage = exports.SwizHealthstatusPage = exports.EseriesHealthstatusPage = exports.XtremioHealthstatusPage = exports.VmaxHealthstatusPage = exports.StoreonceHealthstatusPage = exports.RubrikHealthstatusPage = exports.CohesityHealthstatusPage = exports.CohesityConfigurationPage = exports.PowerflexHealthstatusPage = exports.IbmcossHealthstatusPage = exports.DatadomainHealthstatusPage = exports.DothillHealthstatusPage = exports.IsilonHealthstatusPage = exports.PureHealthstatusPage = exports.VspgHealthstatusPage = exports.CompellentHealthstatusPage = void 0;
const pageResponse_constants_1 = require("../../../common/constants/pageResponse.constants");
const subsystemMetricsResponse_constants_1 = require("../../../common/constants/subsystemMetricsResponse.constants");
const pageResponse_dto_1 = require("../../../common/pageResponse.dto");
const Storage_1 = require("../../metrics/class/Storage");
const typeorm_1 = require("typeorm");
const CapacityTable_1 = require("./CapacityTable");
const ConfigurationTable_1 = require("./ConfigurationTable");
const HealthStatus_1 = require("./HealthStatus");
const Menu_1 = require("./Menu");
const Stor_1 = require("./Stor");
const Table_1 = require("./Table");
const URL_1 = require("./URL");
const User_1 = require("../../users/User");
const PerformanceTable_1 = require("./PerformanceTable");
const hwTypeKey_constants_1 = require("../../../common/constants/hwTypeKey.constants");
const CapacityTableBuilder_1 = require("./CapacityTableBuilder");
class CompellentHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'alerts' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'Storage Center' })
            .addHeader({ value: 'Category' })
            .addHeader({ value: 'Object' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Message' })
            .addHeader({ value: 'Support url' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.severity },
                        { order: 1, value: new Date(row.date * 1000) },
                        { order: 2, value: row.storage_center },
                        { order: 3, value: row.category },
                        { order: 4, value: row.object },
                        { order: 5, value: row.type },
                        { order: 6, value: row.message },
                        { order: 7, value: row.support_url },
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' },
                { order: 7, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.CompellentHealthstatusPage = CompellentHealthstatusPage;
class VspgHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'alerts' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Section' })
            .addHeader({ value: 'Component_name' })
            .addHeader({ value: 'Status' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.section },
                        { order: 1, value: row.component_unit },
                        { order: 2, value: row.status }
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' },
                { order: 7, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.VspgHealthstatusPage = VspgHealthstatusPage;
class PureHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'alerts' } });
        const itemProperties2 = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'hardware' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        const hardwareText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Hardware"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Id' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Created' })
            .addHeader({ value: 'Code' })
            .addHeader({ value: 'Summary' })
            .addHeader({ value: 'Issue' })
            .addHeader({ value: 'Details' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: row.severity },
                        { order: 2, value: new Date(row.created * 1000) },
                        { order: 3, value: row.code },
                        { order: 4, value: row.summary },
                        { order: 5, value: row.issue },
                        { order: 6, value: row.details },
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' },
            ]);
        }
        let hardwareTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' })
            .addHeader({ value: 'Identify' })
            .addHeader({ value: 'Details' })
            .addHeader({ value: 'Slot' })
            .addHeader({ value: 'Speed' })
            .addHeader({ value: 'Temperature' })
            .addHeader({ value: 'Voltage' });
        if (itemProperties2) {
            for (const items of itemProperties2) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hardwareTable.addRow([
                        { order: 0, value: row.name },
                        { order: 1, value: row.status },
                        { order: 2, value: row.identify },
                        { order: 3, value: row.details },
                        { order: 4, value: row.slot },
                        { order: 5, value: row.speed },
                        { order: 6, value: row.temperature },
                        { order: 7, value: row.voltage },
                    ]);
                }
            }
        }
        else {
            hardwareTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' },
                { order: 7, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox(),
                hardwareText,
                hardwareTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PureHealthstatusPage = PureHealthstatusPage;
class IsilonHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'message' })
            .addHeader({ value: 'Node' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: new Date(row.time * 1000) },
                        { order: 1, value: row.id },
                        { order: 2, value: row.severity },
                        { order: 3, value: row.message },
                        { order: 4, value: row.devid },
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' }
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.IsilonHealthstatusPage = IsilonHealthstatusPage;
class DothillHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const eventLogText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            text: "Event log",
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2
        };
        let eventLogTable = new Table_1.Table()
            .addHeader({ value: 'Date/Time' })
            .addHeader({ value: 'Id' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'Event Code' })
            .addHeader({ value: 'Error code' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    eventLogTable.addRow([
                        { order: 0, value: new Date(row.date * 1000) },
                        { order: 1, value: row.id },
                        { order: 2, value: row.name },
                        { order: 3, value: row.description },
                        { order: 4, value: row.event_code },
                        { order: 5, value: row.error_code },
                    ]);
                }
            }
        }
        else {
            eventLogTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
            ]);
        }
        const componentsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            text: "Components",
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2
        };
        let subsystemsHealthStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId);
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                eventLogText,
                eventLogTable.generateBox(),
                componentsText,
                subsystemsHealthStatusBox
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.DothillHealthstatusPage = DothillHealthstatusPage;
class DatadomainHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'alerts' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Post Time' })
            .addHeader({ value: 'Clear Time' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Class' })
            .addHeader({ value: 'Object' })
            .addHeader({ value: 'Message' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    let post_time = row.post_time;
                    let clear_time = row.clear_time;
                    if (post_time) {
                        post_time = new Date(post_time * 1000);
                    }
                    else {
                        post_time = "-";
                    }
                    if (clear_time) {
                        clear_time = new Date(clear_time * 1000);
                    }
                    else {
                        clear_time = "";
                    }
                    hsTable.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: post_time },
                        { order: 2, value: clear_time },
                        { order: 3, value: row.severity },
                        { order: 4, value: row.class },
                        { order: 5, value: row.object },
                        { order: 6, value: row.message },
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.DatadomainHealthstatusPage = DatadomainHealthstatusPage;
class IbmcossHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const devicesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Devices"
        };
        const vaultsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Vaults"
        };
        const drivesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Drives"
        };
        const eventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let devicesTable = new Table_1.Table()
            .addHeader({ value: 'Device' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Health' });
        let vaultsTable = new Table_1.Table()
            .addHeader({ value: 'Vault' })
            .addHeader({ value: 'Storage health' })
            .addHeader({ value: 'Access health' });
        let drivesTable = new Table_1.Table()
            .addHeader({ value: 'Drive' })
            .addHeader({ value: 'Device' })
            .addHeader({ value: 'Usage' })
            .addHeader({ value: 'Status' });
        let eventsTable = new Table_1.Table()
            .addHeader({ value: 'Id' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Source' })
            .addHeader({ value: 'Object' })
            .addHeader({ value: 'Message    ' })
            .addHeader({ value: 'Time' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.devices) {
                    for (const row of data.devices) {
                        devicesTable.addRow([
                            { order: 0, value: row.dev_name },
                            { order: 1, value: row.dev_type },
                            { order: 2, value: row.status },
                        ]);
                    }
                }
                else {
                    devicesTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
                if (data.vaults) {
                    for (const row of data.vaults) {
                        vaultsTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.st_health },
                            { order: 2, value: row.ac_health },
                        ]);
                    }
                }
                else {
                    vaultsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
                if (data.drives) {
                    for (const row of data.drives) {
                        drivesTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.dev_name },
                            { order: 2, value: row.usage },
                            { order: 3, value: row.status },
                        ]);
                    }
                }
                else {
                    drivesTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                    ]);
                }
                if (data.events) {
                    for (const row of data.events) {
                        eventsTable.addRow([
                            { order: 0, value: row.id },
                            { order: 1, value: row.type },
                            { order: 2, value: row.severity },
                            { order: 3, value: row.source },
                            { order: 4, value: row.object },
                            { order: 5, value: row.message },
                            { order: 6, value: new Date(row.time) },
                        ]);
                    }
                }
                else {
                    eventsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                        { order: 6, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                devicesText,
                devicesTable.generateBox(),
                vaultsText,
                vaultsTable.generateBox(),
                drivesText,
                drivesTable.generateBox(),
                eventsText,
                eventsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.IbmcossHealthstatusPage = IbmcossHealthstatusPage;
class PowerflexHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts (last 7 days)"
        };
        const mdmText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "MDM cluster"
        };
        const pdText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Protection Domain"
        };
        const sdsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "SDS"
        };
        const drivesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Drives"
        };
        let mdmTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Role' })
            .addHeader({ value: 'Mode' })
            .addHeader({ value: 'IP' })
            .addHeader({ value: 'Status' });
        let pdTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'State' });
        let sdsTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Membership' })
            .addHeader({ value: 'Connection' });
        let drivesTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Path' })
            .addHeader({ value: 'SDS' })
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Error' })
            .addHeader({ value: 'Aggregate' });
        let alertsTable = new Table_1.Table()
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Object' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Message' })
            .addHeader({ value: 'Start time' })
            .addHeader({ value: 'Last time' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.mdm) {
                    for (const row of data.mdm) {
                        mdmTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.role },
                            { order: 2, value: row.mode },
                            { order: 3, value: row.ips },
                            { order: 4, value: row.status },
                        ]);
                    }
                }
                else {
                    mdmTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                    ]);
                }
                if (data.protection_domain) {
                    for (const row of data.protection_domain) {
                        pdTable.addRow([
                            { order: 0, value: row.name, url: URL_1.URL.generate('powerflex', 'protection_domain', row.hash_id) },
                            { order: 1, value: row.state },
                        ]);
                    }
                }
                else {
                    pdTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.sds) {
                    for (const row of data.sds) {
                        sdsTable.addRow([
                            { order: 0, value: row.name, url: URL_1.URL.generate('powerflex', 'sds', row.hash_id) },
                            { order: 1, value: row.state },
                            { order: 2, value: row.membership },
                            { order: 3, value: row.connection },
                        ]);
                    }
                }
                else {
                    sdsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                    ]);
                }
                if (data.drives) {
                    for (const row of data.drives) {
                        drivesTable.addRow([
                            { order: 0, value: row.name, url: URL_1.URL.generate('powerflex', 'drive', row.hash_id) },
                            { order: 1, value: row.path },
                            { order: 2, value: row.sds },
                            { order: 3, value: row.state },
                            { order: 4, value: row.error },
                            { order: 5, value: row.aggregate },
                        ]);
                    }
                }
                else {
                    drivesTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                    ]);
                }
                if (data.alerts) {
                    for (const row of data.alerts) {
                        alertsTable.addRow([
                            { order: 0, value: row.severity },
                            { order: 1, value: row.object },
                            { order: 2, value: row.name },
                            { order: 3, value: row.type },
                            { order: 4, value: row.message },
                            { order: 5, value: row.starttime },
                            { order: 6, value: row.lasttime },
                        ]);
                    }
                }
                else {
                    alertsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                        { order: 6, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                mdmText,
                mdmTable.generateBox(),
                pdText,
                pdTable.generateBox(),
                sdsText,
                sdsTable.generateBox(),
                drivesText,
                drivesTable.generateBox(),
                alertsText,
                alertsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerflexHealthstatusPage = PowerflexHealthstatusPage;
class CohesityConfigurationPage extends Stor_1.StorConfigurationPage {
    async getPage() {
        const page = await super.getPage();
        const items = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey.COHESITY,
                subsystem: 'node',
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                parents: true
            }
        });
        let item_ids = [];
        for (let item of items) {
            item_ids = [...item_ids, item['item_id']];
        }
        const configurationTable = new ConfigurationTable_1.ConfigurationTable(item_ids, ['sw_version', 'node_type', 'disk_count', 'removal_state', 'capacity_node_total']);
        page.tabs.push({
            title: 'Node',
            content: [
                await configurationTable.generate()
            ],
        });
        return page;
    }
}
exports.CohesityConfigurationPage = CohesityConfigurationPage;
class CohesityHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const eventProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const healthProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_summary' } });
        const healthOrderProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_summary_order' } });
        const healthText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Health (last 7 days)"
        };
        let saver;
        if (healthProperties) {
            saver = [];
            let cohe_common;
            for (let items of healthOrderProperties) {
                cohe_common = (JSON.parse(items.property_value));
            }
            for (let items of healthProperties) {
                let data = (JSON.parse(items.property_value));
                for (let group_name of Object.keys(data).sort()) {
                    let localTable = new Table_1.Table();
                    let cohe_names = cohe_common[group_name];
                    let cohe_headers = cohe_common[group_name];
                    let localText = {
                        type: pageResponse_constants_1.BOX_TYPE.TextBox,
                        styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
                        text: group_name
                    };
                    for (let cohe_header of Object.keys(cohe_headers)) {
                        localTable.addHeader({ value: cohe_headers[cohe_header] });
                    }
                    let row_body;
                    for (let row_name of Object.keys(data[group_name]).sort()) {
                        let counter = 0;
                        row_body = [];
                        for (let cohe_name of Object.keys(cohe_names)) {
                            let cohe_actual_name = cohe_names[cohe_name];
                            let local_value = data[group_name][row_name][cohe_actual_name];
                            row_body = [...row_body, ...[{ order: counter, value: local_value.toString() }]];
                            counter++;
                        }
                        localTable.addRow(row_body);
                    }
                    saver = [...saver, ...[localText], ...[localTable.generateBox()]];
                }
            }
        }
        const eventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events (last 7 days)"
        };
        let eventTable = new Table_1.Table();
        let cohe_names = ['Severity', 'Id', 'Time', 'Alert Name', 'Alert Category', 'Alert Code', 'Alert Description'];
        for (let cohe_header of cohe_names) {
            eventTable.addHeader({ value: cohe_header });
        }
        let row_body;
        if (eventProperties) {
            for (const items of eventProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    let counter = 0;
                    row_body = [];
                    for (let cohe_row of cohe_names) {
                        row_body = [...row_body, ...[{ order: counter, value: row[cohe_row] }]];
                        counter++;
                    }
                    eventTable.addRow(row_body);
                }
            }
        }
        else {
            let counter = 0;
            row_body = [];
            for (let cohe_row of cohe_names) {
                row_body = [...row_body, ...[{ order: counter, value: '' }]];
                counter++;
            }
            eventTable.addRow(row_body);
        }
        saver = [...saver, ...[eventsText], ...[eventTable.generateBox()]];
        tabs.push({
            title: 'Health Status',
            content: [
                ...[healthStatusBox],
                ...saver
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.CohesityHealthstatusPage = CohesityHealthstatusPage;
class RubrikHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const nodesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Nodes"
        };
        const disksText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Disks"
        };
        const eventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events (last 7 days)"
        };
        let nodesTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' });
        let disksTable = new Table_1.Table()
            .addHeader({ value: 'Node' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Status' })
            .addHeader({ value: 'Degraded' });
        let eventsTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Object type' })
            .addHeader({ value: 'Object name' })
            .addHeader({ value: 'Message' })
            .addHeader({ value: 'Time' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.nodes) {
                    for (const row of data.nodes) {
                        nodesTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.status },
                        ]);
                    }
                }
                else {
                    nodesTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.disks) {
                    for (const row of data.disks) {
                        disksTable.addRow([
                            { order: 0, value: row.node },
                            { order: 1, value: row.type },
                            { order: 2, value: row.id },
                            { order: 3, value: row.status },
                            { order: 4, value: row.degraded },
                        ]);
                    }
                }
                else {
                    disksTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                    ]);
                }
                if (data.events) {
                    for (const row of data.events) {
                        eventsTable.addRow([
                            { order: 0, value: row.id },
                            { order: 1, value: row.severity },
                            { order: 2, value: row.type },
                            { order: 3, value: row.name },
                            { order: 4, value: row.objecttype },
                            { order: 5, value: row.objectname },
                            { order: 6, value: row.message },
                            { order: 7, value: new Date(row.time) },
                        ]);
                    }
                }
                else {
                    eventsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                        { order: 6, value: '' },
                        { order: 7, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                nodesText,
                nodesTable.generateBox(),
                disksText,
                disksTable.generateBox(),
                eventsText,
                eventsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.RubrikHealthstatusPage = RubrikHealthstatusPage;
class StoreonceHealthstatusPage extends Menu_1.StorHealthstatusPage {
    constructor() {
        super(...arguments);
        this.bgStatusmap = {
            'OK': 'ok',
            'CRITICAL': 'error',
            'WARNING': 'warning',
            'UNKNOWN': 'unknown'
        };
    }
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const statusinfoText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Status Info"
        };
        const servicesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Services"
        };
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        let statusinfoTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status', styleClass: pageResponse_constants_1.TABLE_STYLE_CLASS.healthStatus });
        let alertTable = new Table_1.Table()
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'Time', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.timestamp })
            .addHeader({ value: 'Event ID' })
            .addHeader({ value: 'Event Type' })
            .addHeader({ value: 'Event Code' })
            .addHeader({ value: 'Message' });
        let serviceTable = new Table_1.Table()
            .addHeader({ value: 'Service' })
            .addHeader({ value: 'Status', styleClass: pageResponse_constants_1.TABLE_STYLE_CLASS.healthStatus });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.dash) {
                    for (const row of data.dash) {
                        const bgStatusValue = this.bgStatusmap[row.status] || 'undefined';
                        statusinfoTable.addRow([
                            { order: 0, value: row.service },
                            { order: 1, value: row.status, bgStatus: bgStatusValue },
                        ]);
                    }
                }
                else {
                    statusinfoTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.services) {
                    for (const row of data.services) {
                        const bgStatusValue = this.bgStatusmap[row.status] || 'undefined';
                        serviceTable.addRow([
                            { order: 0, value: row.service },
                            { order: 1, value: row.status, bgStatus: bgStatusValue },
                        ]);
                    }
                }
                else {
                    serviceTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.alerts) {
                    for (const row of data.alerts) {
                        alertTable.addRow([
                            { order: 0, value: row.level },
                            { order: 1, value: row.time },
                            { order: 2, value: row.id },
                            { order: 3, value: row.type },
                            { order: 4, value: row.code },
                            { order: 5, value: row.message },
                        ]);
                    }
                }
                else {
                    alertTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                    ]);
                }
            }
        }
        alertTable.sortByIndex(1);
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                statusinfoText,
                statusinfoTable.generateBox(),
                servicesText,
                serviceTable.generateBox(),
                alertsText,
                alertTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoreonceHealthstatusPage = StoreonceHealthstatusPage;
class VmaxHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "HW config events"
        };
        const alertsNoteText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h4,
            text: "NOTE: RED status for this device is set only if this table contains some HardWare config event with severity level \"Fatal\"."
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Time' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Category' })
            .addHeader({ value: 'Description' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.time },
                        { order: 1, value: row.severity },
                        { order: 2, value: row.type },
                        { order: 3, value: row.category },
                        { order: 4, value: row.description },
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                alertsNoteText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.VmaxHealthstatusPage = VmaxHealthstatusPage;
class XtremioHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_events' } });
        const hsdata = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const storageStatusText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Storage system status"
        };
        let statusTable = new Table_1.Table()
            .addHeader({ value: 'sys-health-state' })
            .addHeader({ value: 'sys-state' });
        if (hsdata) {
            for (const items of hsdata) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    statusTable.addRow([
                        { order: 0, value: row.sys_health_state },
                        { order: 1, value: row.sys_state },
                    ]);
                }
            }
        }
        const storageEventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        const alertsNoteText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h4,
            text: "NOTE: last 90 days, critical severity only"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'Time' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Event code' })
            .addHeader({ value: 'Entity' })
            .addHeader({ value: 'Entity details' })
            .addHeader({ value: 'Description' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.timestamp },
                        { order: 1, value: row.severity },
                        { order: 2, value: row.event_code },
                        { order: 3, value: row.entity },
                        { order: 4, value: row.entity_details },
                        { order: 5, value: row.description },
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                storageStatusText,
                statusTable.generateBox(),
                storageEventsText,
                hsTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.XtremioHealthstatusPage = XtremioHealthstatusPage;
class EseriesHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const storageStatusText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Storage system status"
        };
        const failuresText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Failures"
        };
        let statusTable = new Table_1.Table()
            .addHeader({ value: 'Status' })
            .addHeader({ value: 'Last status update' });
        let failuresTable = new Table_1.Table()
            .addHeader({ value: 'Key' })
            .addHeader({ value: 'Value' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.status && data.last_update_time) {
                    statusTable.addRow([
                        { order: 0, value: data.status },
                        { order: 1, value: data.last_update_time },
                    ]);
                }
                else {
                    statusTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.failures) {
                    for (const row of data.failures) {
                        failuresTable.addRow([
                            { order: 0, value: row.key },
                            { order: 1, value: row.value },
                        ]);
                    }
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                storageStatusText,
                statusTable.generateBox(),
                failuresText,
                failuresTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.EseriesHealthstatusPage = EseriesHealthstatusPage;
class SwizHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const itemSubsystems = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_subsystem' } });
        const storageStatusText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Storage system status"
        };
        const eventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let statusTable = new Table_1.Table()
            .addHeader({ value: 'Last status update' })
            .addHeader({ value: 'Status' })
            .addHeader({ value: 'Reason' });
        let eventsTable = new Table_1.Table()
            .addHeader({ value: 'Date/Time' })
            .addHeader({ value: 'Event ID' })
            .addHeader({ value: 'Object type' })
            .addHeader({ value: 'Object name' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'Status' })
            .addHeader({ value: 'Fixed' })
            .addHeader({ value: 'Sequence number' })
            .addHeader({ value: 'Object ID' })
            .addHeader({ value: 'Copy ID' })
            .addHeader({ value: 'Error code' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.reason && data.status && data.time) {
                    statusTable.addRow([
                        { order: 1, value: data.time },
                        { order: 0, value: data.status },
                        { order: 0, value: data.reason },
                    ]);
                }
                else {
                    statusTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.events) {
                    for (const row of data.events) {
                        eventsTable.addRow([
                            { order: 0, value: row.time },
                            { order: 1, value: row.event_id },
                            { order: 2, value: row.object_type },
                            { order: 3, value: row.object_name },
                            { order: 4, value: row.description },
                            { order: 5, value: row.status },
                            { order: 6, value: row.fixed },
                            { order: 7, value: row.sequence_number },
                            { order: 8, value: row.object_id },
                            { order: 9, value: row.copy_id },
                            { order: 10, value: row.error_code }
                        ]);
                    }
                }
            }
        }
        const componentText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Components"
        };
        let hsComponentTableContent = 0;
        let hsComponentTable = new Table_1.Table()
            .addHeader({ value: 'Section' })
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' })
            .addHeader({ value: 'Description' });
        if (itemSubsystems) {
            for (const items of itemSubsystems) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsComponentTableContent = 1;
                    hsComponentTable.addRow([
                        { order: 0, value: row.section },
                        { order: 1, value: row.id },
                        { order: 2, value: row.name },
                        { order: 3, value: row.status },
                        { order: 4, value: row.description },
                    ]);
                }
            }
        }
        else {
            hsComponentTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' }
            ]);
        }
        if (hsComponentTableContent) {
            tabs.push({
                title: 'Health Status',
                content: [
                    healthStatusBox,
                    storageStatusText,
                    statusTable.generateBox(),
                    eventsText,
                    eventsTable.generateBox(),
                    componentText,
                    hsComponentTable.generateBox()
                ],
            });
        }
        else {
            tabs.push({
                title: 'Health Status',
                content: [
                    healthStatusBox,
                    storageStatusText,
                    statusTable.generateBox(),
                    eventsText,
                    eventsTable.generateBox()
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.SwizHealthstatusPage = SwizHealthstatusPage;
class SynologyHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const systemText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "System status"
        };
        const componentsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Components"
        };
        let systemStatusTable = new Table_1.Table()
            .addHeader({ value: 'System Status' })
            .addHeader({ value: 'Power Status' })
            .addHeader({ value: 'CPU FAN Status' })
            .addHeader({ value: 'System FAN Status' });
        let componentsTable = new Table_1.Table()
            .addHeader({ value: 'Section' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.system) {
                    for (const row of data.system) {
                        systemStatusTable.addRow([
                            { order: 0, value: row.systemstatus },
                            { order: 1, value: row.powerstatus },
                            { order: 2, value: row.cpufanstatus },
                            { order: 3, value: row.systemfanstatus },
                        ]);
                    }
                }
                else {
                    systemStatusTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                    ]);
                }
                if (data.components) {
                    for (const row of data.components) {
                        componentsTable.addRow([
                            { order: 0, value: row.section },
                            { order: 1, value: row.name },
                            { order: 2, value: row.status },
                        ]);
                    }
                }
                else {
                    componentsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                systemText,
                systemStatusTable.generateBox(),
                componentsText,
                componentsTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.SynologyHealthstatusPage = SynologyHealthstatusPage;
class _3parHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const properties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: (0, typeorm_1.In)(['epar_remotecopy', 'epar_pool', 'epar_volumes', 'epar_ports', 'epar_disks', 'epar_cage', 'epar_psu']) } });
        console.log('properties', properties);
        const remotecopyProperties = properties.find(property => property.property_name === 'epar_remotecopy');
        const poolProperties = properties.find(property => property.property_name === 'epar_pool');
        const volumesProperties = properties.find(property => property.property_name === 'epar_volumes');
        console.log('Volume', volumesProperties);
        const portsProperties = properties.find(property => property.property_name === 'epar_ports');
        const diskProperties = properties.find(property => property.property_name === 'epar_disks');
        const cageProperties = properties.find(property => property.property_name === 'epar_cage');
        const psuProperties = properties.find(property => property.property_name === 'epar_psu');
        const remotecopyText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Remote Copy"
        };
        const poolText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Pool"
        };
        const volumesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Volume"
        };
        const portsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Ports"
        };
        const disksText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Disks"
        };
        const cageText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Cage Level State"
        };
        const psuText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "PS Level State"
        };
        let remotecopyTable = new Table_1.Table()
            .addHeader({ value: 'Mode' })
            .addHeader({ value: 'Status' });
        if (remotecopyProperties) {
            for (const row of JSON.parse(remotecopyProperties.property_value)) {
                remotecopyTable.addRow([
                    { order: 0, value: row.mode },
                    { order: 1, value: row.status },
                ]);
            }
        }
        else {
            remotecopyTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
            ]);
        }
        let poolTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'State' });
        if (poolProperties) {
            for (const row of JSON.parse(poolProperties.property_value)) {
                poolTable.addRow([
                    { order: 0, value: row.id },
                    { order: 1, value: row.name },
                    { order: 2, value: row.state },
                ]);
            }
        }
        else {
            poolTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
            ]);
        }
        let volumeTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Dstate' });
        if (volumesProperties) {
            for (const row of JSON.parse(volumesProperties.property_value)) {
                volumeTable.addRow([
                    { order: 0, value: row.id },
                    { order: 1, value: row.name },
                    { order: 2, value: row.state },
                    { order: 3, value: row.dstate },
                ]);
            }
        }
        else {
            volumeTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
            ]);
        }
        let portTable = new Table_1.Table()
            .addHeader({ value: 'N:S:P' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Failover state' });
        if (portsProperties) {
            for (const row of JSON.parse(portsProperties.property_value)) {
                portTable.addRow([
                    { order: 0, value: row.nsp },
                    { order: 1, value: row.type },
                    { order: 2, value: row.state },
                    { order: 3, value: row.failover },
                ]);
            }
        }
        else {
            portTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
            ]);
        }
        let diskTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Position' })
            .addHeader({ value: 'State' });
        if (diskProperties) {
            for (const row of JSON.parse(diskProperties.property_value)) {
                diskTable.addRow([
                    { order: 0, value: row.id },
                    { order: 1, value: row.position },
                    { order: 2, value: row.state },
                ]);
            }
        }
        else {
            diskTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
            ]);
        }
        let cageTable = new Table_1.Table()
            .addHeader({ value: 'Cage' })
            .addHeader({ value: 'Cage Level' })
            .addHeader({ value: 'State' });
        if (cageProperties) {
            for (const row of JSON.parse(cageProperties.property_value)) {
                cageTable.addRow([
                    { order: 0, value: row.cage },
                    { order: 1, value: row.level },
                    { order: 2, value: row.state },
                ]);
            }
        }
        else {
            cageTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
            ]);
        }
        let psuTable = new Table_1.Table()
            .addHeader({ value: 'Cage' })
            .addHeader({ value: 'PS' })
            .addHeader({ value: 'PS state' })
            .addHeader({ value: 'Level' });
        if (psuProperties) {
            for (const row of JSON.parse(psuProperties.property_value)) {
                psuTable.addRow([
                    { order: 0, value: row.cage },
                    { order: 1, value: row.ps },
                    { order: 2, value: row.state },
                    { order: 3, value: row.level },
                ]);
            }
        }
        else {
            psuTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                remotecopyText,
                remotecopyTable.generateBox(),
                poolText,
                poolTable.generateBox(),
                portsText,
                portTable.generateBox(),
                volumesText,
                volumeTable.generateBox(),
                disksText,
                diskTable.generateBox(),
                cageText,
                cageTable.generateBox(),
                psuText,
                psuTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports._3parHealthstatusPage = _3parHealthstatusPage;
class NimbleHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const eventProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const arrayText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Array"
        };
        const ctrlrText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Controllers"
        };
        const drivesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Drives"
        };
        const eventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events (last 90 days)"
        };
        let arrayTable = new Table_1.Table()
            .addHeader({ value: 'Array name' })
            .addHeader({ value: 'Status' });
        let ctrlrTable = new Table_1.Table()
            .addHeader({ value: 'Controller' })
            .addHeader({ value: 'Serial' })
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Power supply' })
            .addHeader({ value: 'Cooling fans' })
            .addHeader({ value: 'System partition status' })
            .addHeader({ value: 'Temperature sensors' });
        let drivesTable = new Table_1.Table()
            .addHeader({ value: 'Disk' })
            .addHeader({ value: 'Controller' })
            .addHeader({ value: 'Serial' })
            .addHeader({ value: 'HW status' })
            .addHeader({ value: 'RAID status' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.hs_array) {
                    for (const row of data.hs_array) {
                        arrayTable.addRow([
                            { order: 0, value: row.array_name },
                            { order: 1, value: row.array_status },
                        ]);
                    }
                }
                else {
                    arrayTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.hs_ctrlrs) {
                    for (const row of data.hs_ctrlrs) {
                        ctrlrTable.addRow([
                            { order: 0, value: row.id },
                            { order: 1, value: row.serial },
                            { order: 2, value: row.state },
                            { order: 3, value: row.power_supply },
                            { order: 4, value: row.cooling_fans },
                            { order: 5, value: row.system_partition },
                            { order: 6, value: row.temperature_sensors },
                        ]);
                    }
                }
                else {
                    ctrlrTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                        { order: 6, value: '' },
                    ]);
                }
                if (data.hs_drives) {
                    for (const row of data.hs_drives) {
                        drivesTable.addRow([
                            { order: 0, value: row.id, url: URL_1.URL.generate('nimble', 'drive', row.hash_id) },
                            { order: 1, value: row.ctrlr },
                            { order: 2, value: row.serial },
                            { order: 3, value: row.hw_state },
                            { order: 4, value: row.raid_state },
                        ]);
                    }
                }
                else {
                    drivesTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                    ]);
                }
            }
        }
        let eventTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Category' })
            .addHeader({ value: 'Array' })
            .addHeader({ value: 'Detail' })
            .addHeader({ value: 'Date' });
        if (eventProperties) {
            for (const items of eventProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    eventTable.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: row.severity },
                        { order: 2, value: row.type },
                        { order: 3, value: row.category },
                        { order: 4, value: row.array },
                        { order: 5, value: row.detail },
                        { order: 6, value: row.date },
                    ]);
                }
            }
        }
        else {
            eventTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' },
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                arrayText,
                arrayTable.generateBox(),
                ctrlrText,
                ctrlrTable.generateBox(),
                drivesText,
                drivesTable.generateBox(),
                eventsText,
                eventTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.NimbleHealthstatusPage = NimbleHealthstatusPage;
class PowerstoreHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const hwText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Hardware"
        };
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        let hwTable = new Table_1.Table()
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Slot' })
            .addHeader({ value: 'Serial' })
            .addHeader({ value: 'ID' });
        let alertsTable = new Table_1.Table()
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'State' })
            .addHeader({ value: 'Acknowledged timestamp' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'Resource name' })
            .addHeader({ value: 'Resource type' })
            .addHeader({ value: 'Event code' })
            .addHeader({ value: 'ID' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.hw) {
                    for (const row of data.hw) {
                        hwTable.addRow([
                            { order: 0, value: row.state },
                            { order: 1, value: row.type },
                            { order: 2, value: row.name },
                            { order: 3, value: row.slot },
                            { order: 4, value: row.serial },
                            { order: 5, value: row.id },
                        ]);
                    }
                }
                else {
                    hwTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                    ]);
                }
                if (data.alerts) {
                    for (const row of data.alerts) {
                        alertsTable.addRow([
                            { order: 0, value: row.severity },
                            { order: 1, value: row.state },
                            { order: 2, value: row.acknowledged_timestamp },
                            { order: 3, value: row.description_l10n },
                            { order: 4, value: row.resource_name },
                            { order: 5, value: row.resource_type },
                            { order: 6, value: row.event_code },
                            { order: 7, value: row.id },
                        ]);
                    }
                }
                else {
                    alertsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                        { order: 6, value: '' },
                        { order: 7, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                hwText,
                hwTable.generateBox(),
                alertsText,
                alertsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.PowerstoreHealthstatusPage = PowerstoreHealthstatusPage;
class StoragegridHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const alarmsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alarms"
        };
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        const gridText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Grid"
        };
        const nodesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Nodes"
        };
        const sitesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Sites"
        };
        const alertingText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerting"
        };
        let alarmTable = new Table_1.Table()
            .addHeader({ value: 'Major' })
            .addHeader({ value: 'Crtical' })
            .addHeader({ value: 'Minor' })
            .addHeader({ value: 'Notice' });
        let alertTable = new Table_1.Table()
            .addHeader({ value: 'Major' })
            .addHeader({ value: 'Crtical' })
            .addHeader({ value: 'Minor' });
        let gridTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' });
        let siteTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' });
        let nodecountTable = new Table_1.Table()
            .addHeader({ value: 'Connected' })
            .addHeader({ value: 'Administratively down' })
            .addHeader({ value: 'Unknown' });
        let nodeTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Site' })
            .addHeader({ value: 'Status' });
        let alertingTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Site' })
            .addHeader({ value: 'Instance' })
            .addHeader({ value: 'Time' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Name' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.alarms) {
                    for (const row of data.alarms) {
                        alarmTable.addRow([
                            { order: 0, value: row.major },
                            { order: 1, value: row.critical },
                            { order: 2, value: row.minor },
                            { order: 3, value: row.notice },
                        ]);
                    }
                }
                else {
                    alarmTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                    ]);
                }
                if (data.alerts) {
                    for (const row of data.alerts) {
                        alertTable.addRow([
                            { order: 0, value: row.major },
                            { order: 1, value: row.critical },
                            { order: 2, value: row.minor },
                        ]);
                    }
                }
                else {
                    alertTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
                if (data.grid) {
                    for (const row of data.grid) {
                        gridTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.status },
                        ]);
                    }
                }
                else {
                    gridTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.sites) {
                    for (const row of data.sites) {
                        siteTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.status },
                        ]);
                    }
                }
                else {
                    siteTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.node_count) {
                    for (const row of data.node_count) {
                        nodecountTable.addRow([
                            { order: 0, value: row.connected },
                            { order: 1, value: row.administratively_down },
                            { order: 2, value: row.unknown },
                        ]);
                    }
                }
                else {
                    nodecountTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
                if (data.node) {
                    for (const row of data.node) {
                        nodeTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.site_name },
                            { order: 2, value: row.status },
                        ]);
                    }
                }
                else {
                    nodeTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
                if (data.alerting) {
                    for (const row of data.alerts) {
                        alertingTable.addRow([
                            { order: 0, value: row.id },
                            { order: 1, value: row.site },
                            { order: 2, value: row.instance },
                            { order: 3, value: row.time },
                            { order: 4, value: row.severity },
                            { order: 5, value: row.name },
                        ]);
                    }
                }
                else {
                    alertingTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alarmsText,
                alarmTable.generateBox(),
                alertsText,
                alertTable.generateBox(),
                gridText,
                gridTable.generateBox(),
                sitesText,
                siteTable.generateBox(),
                nodesText,
                nodecountTable.generateBox(),
                nodeTable.generateBox(),
                alertingText,
                alertingTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.StoragegridHealthstatusPage = StoragegridHealthstatusPage;
class InfiniboxHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const servicesText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Services"
        };
        const eventsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let deviceTable = new Table_1.Table()
            .addHeader({ value: 'Operational state' })
            .addHeader({ value: 'Uptime' });
        let servicesTable = new Table_1.Table()
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' });
        let eventsTable = new Table_1.Table()
            .addHeader({ value: 'Time' })
            .addHeader({ value: 'Seq num' })
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'Reporter' })
            .addHeader({ value: 'Username' })
            .addHeader({ value: 'Code' })
            .addHeader({ value: 'Description' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.device && data.device) {
                    deviceTable.addRow([
                        { order: 0, value: data.device.op_state },
                        { order: 1, value: data.device.uptime },
                    ]);
                }
                else {
                    deviceTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.services) {
                    for (const row of data.services) {
                        servicesTable.addRow([
                            { order: 0, value: row.name },
                            { order: 1, value: row.status },
                        ]);
                    }
                }
                else {
                    servicesTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                    ]);
                }
                if (data.events) {
                    for (const row of data.events) {
                        eventsTable.addRow([
                            { order: 0, value: new Date(row.time) },
                            { order: 1, value: row.seq },
                            { order: 2, value: row.level },
                            { order: 3, value: row.reporter },
                            { order: 4, value: row.user },
                            { order: 5, value: row.code },
                            { order: 6, value: row.description },
                        ]);
                    }
                }
                else {
                    eventsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                        { order: 6, value: '' },
                    ]);
                }
            }
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                deviceTable.generateBox(),
                servicesText,
                servicesTable.generateBox(),
                eventsText,
                eventsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.InfiniboxHealthstatusPage = InfiniboxHealthstatusPage;
class DatacoreHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'health_status_data' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Alerts"
        };
        const componentsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Components"
        };
        const monitorsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Monitors"
        };
        let alertsTable = new Table_1.Table()
            .addHeader({ value: 'Time', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.timestamp })
            .addHeader({ value: 'Seq num' })
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'Machine name' })
            .addHeader({ value: 'Source type' })
            .addHeader({ value: 'Source' })
            .addHeader({ value: 'Message' });
        let componentsTable = new Table_1.Table()
            .addHeader({ value: 'Section' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Status' });
        let monitorsTable = new Table_1.Table()
            .addHeader({ value: 'Date', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.timestamp })
            .addHeader({ value: 'Seq num' })
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'Caption' })
            .addHeader({ value: 'Message' })
            .addHeader({ value: 'Description' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                if (data.alerts) {
                    for (const row of data.alerts) {
                        alertsTable.addRow([
                            { order: 0, value: row.time },
                            { order: 1, value: row.id },
                            { order: 2, value: row.level },
                            { order: 3, value: row.machine_name },
                            { order: 4, value: row.type },
                            { order: 5, value: row.source },
                            { order: 6, value: row.message },
                        ]);
                    }
                }
                if (data.components) {
                    for (const row of data.components) {
                        componentsTable.addRow([
                            { order: 0, value: row.section },
                            { order: 1, value: row.name },
                            { order: 2, value: row.status },
                        ]);
                    }
                }
                else {
                    componentsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                    ]);
                }
                if (data.monitors) {
                    for (const row of data.monitors) {
                        monitorsTable.addRow([
                            { order: 0, value: row.time },
                            { order: 1, value: row.id },
                            { order: 2, value: row.level },
                            { order: 3, value: row.caption },
                            { order: 4, value: row.message },
                            { order: 5, value: row.description },
                        ]);
                    }
                }
                else {
                    monitorsTable.addRow([
                        { order: 0, value: '' },
                        { order: 1, value: '' },
                        { order: 2, value: '' },
                        { order: 3, value: '' },
                        { order: 4, value: '' },
                        { order: 5, value: '' },
                    ]);
                }
            }
        }
        monitorsTable.sortByIndex(0);
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                alertsTable.generateBox(),
                componentsText,
                componentsTable.generateBox(),
                monitorsText,
                monitorsTable.generateBox(),
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.DatacoreHealthstatusPage = DatacoreHealthstatusPage;
class VspgCpucpuPage extends Menu_1.StorItemPage {
    constructor(itemId) {
        super('vspg', 'cpu', itemId);
    }
    async getPage() {
        let tabs = [];
        let item = await this.objectItemsRepository.findOneBy({
            item_id: this.itemId,
        });
        const cpus = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey.VSPG,
                subsystem: 'cpu',
                parents: {
                    parent: item.item_id
                },
            },
            relations: {
                parents: true
            }
        });
        for (const tabIndex in Storage_1.Storage.technology['vspg']['subsystems']['cpu']['totals']['cpu']['tabs']) {
            const subsys = Storage_1.Storage.technology['vspg']['subsystems']['cpu'];
            const tab = subsys['totals']['cpu']['tabs'][tabIndex];
            if (!tab) {
                console.warn("[VspgCpucpuPage] No tab definition found");
                continue;
            }
            tabs.push({
                title: tab.label,
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: tab.metrics,
                        uuids: cpus.map(item => item.item_id),
                        aggregated: true,
                        label: subsys['label'] ? subsys['label'] : this.subsystem,
                        parent: subsys['parent'] ? {
                            label: subsys['parent'],
                            subsystem: subsys['parent']
                        } : undefined
                    },
                ],
            });
        }
        const cpuTypes = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey.VSPG,
                subsystem: 'cpu_type',
                children: {
                    _child: {
                        subsystem: 'cache'
                    }
                },
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                children: {
                    _child: true
                },
                parents: true
            }
        });
        for (const cpuType of cpuTypes) {
            tabs.push({
                title: cpuType.label,
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [{
                                ...Storage_1.Storage.metrics['cpu_system'],
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                            }],
                        uuids: cpuType.children.map(child => child._child.item_id),
                        aggregated: true,
                        label: cpuType.label,
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page("Total", tabs);
        return this.page;
    }
}
exports.VspgCpucpuPage = VspgCpucpuPage;
class VspgCachetotalPage extends Menu_1.StorItemPage {
    constructor(itemId) {
        super('vspg', 'cache', itemId);
    }
    async getPage() {
        let tabs = [];
        let device = await this.objectItemsRepository.findOneBy({
            item_id: this.itemId,
        });
        const caches = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey.VSPG,
                subsystem: 'cache',
                parents: {
                    parent: device.item_id
                }
            },
            relations: {
                parents: true
            }
        });
        for (const tabIndex in Storage_1.Storage.technology['vspg']['subsystems']['cache']['totals']['total']['tabs']) {
            const subsys = Storage_1.Storage.technology['vspg']['subsystems']['cache'];
            const tab = subsys['totals']['total']['tabs'][tabIndex];
            if (!tab) {
                console.warn("[VspgCachetotalPage] No tab definition found");
                continue;
            }
            tabs.push({
                title: tab.label,
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: tab.metrics,
                        uuids: caches.map(item => item.item_id),
                        aggregated: true,
                        label: subsys['label'] ? subsys['label'] : this.subsystem,
                        parent: subsys['parent'] ? {
                            label: subsys['parent'],
                            subsystem: subsys['parent']
                        } : undefined
                    },
                ],
            });
        }
        const cpuTypes = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey.VSPG,
                subsystem: 'cpu_type',
                children: {
                    _child: {
                        subsystem: 'cache'
                    }
                },
                parents: {
                    parent: this.itemId
                }
            },
            relations: {
                children: {
                    _child: true
                },
                parents: true
            }
        });
        for (const cpuType of cpuTypes) {
            tabs.push({
                title: "Write Pending " + cpuType.label,
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [{
                                ...Storage_1.Storage.metrics['write_pending_percent'],
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                            }],
                        uuids: cpuType.children.map(child => child._child.item_id),
                        aggregated: true,
                        label: "Write Pending " + cpuType.label,
                    },
                ],
            });
            tabs.push({
                title: "Cache usage " + cpuType.label,
                content: [
                    {
                        type: pageResponse_constants_1.BOX_TYPE.FourGraphBox,
                        metrics: [{
                                ...Storage_1.Storage.metrics['cache_usage_percent'],
                                type: pageResponse_constants_1.CHART_TYPE.line,
                                stacked: false,
                                order: 0,
                            }],
                        uuids: cpuType.children.map(child => child._child.item_id),
                        aggregated: true,
                        label: "Cache useage " + cpuType.label,
                    },
                ],
            });
        }
        this.page = new pageResponse_dto_1.Page("Total", tabs);
        return this.page;
    }
}
exports.VspgCachetotalPage = VspgCachetotalPage;
class _3parCapacityPage extends Stor_1.StorCapacityPage {
    constructor() {
        super(...arguments);
        this.title = 'Capacity';
    }
    async getPage() {
        let page = await (new Stor_1.StorCapacityPage(this.itemId, this.request)).getPage();
        const tiers = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey._3PAR,
                subsystem: 'tier',
                parents: {
                    parent: this.itemId
                },
            },
            relations: {
                parents: true
            }
        });
        const pools = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey._3PAR,
                subsystem: 'pool',
                parents: {
                    parent: this.itemId
                },
            },
            relations: {
                parents: true
            }
        });
        const volumes = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey._3PAR,
                subsystem: 'volume',
                parents: {
                    parent: this.itemId
                },
            },
            relations: {
                parents: true
            }
        });
        const disks = await this.objectItemsRepository.find({
            where: {
                hw_type: hwTypeKey_constants_1.HwTypeKey._3PAR,
                subsystem: 'drive',
                parents: {
                    parent: this.itemId
                },
            },
            relations: {
                parents: true
            }
        });
        page.tabs.push({
            title: "Tier",
            content: [
                await PerformanceTable_1.PerformanceTable.createPerformanceTableFromTemplate("Tier", [
                    {
                        label: "Allocated",
                        subheader: [{
                                label: "Total",
                                metric: "capacity_used"
                            }, {
                                label: "Volumes",
                                metric: "volumes_capacity_used"
                            }, {
                                label: "System",
                                metric: "system_capacity_used",
                            }]
                    },
                ], tiers)
            ]
        });
        page.tabs.push({
            title: "Pool",
            content: [
                await PerformanceTable_1.PerformanceTable.createPerformanceTableFromTemplate("CPGS", [
                    {
                        label: "Allocated",
                        subheader: [{
                                label: "Total",
                                metric: "capacity_allocated"
                            }, {
                                label: "User",
                                metric: "user_capacity_allocated"
                            }, {
                                label: "Snapshot",
                                metric: "snapshot_capacity_allocated"
                            }, {
                                label: "Admin",
                                metric: "admin_capacity_allocated"
                            }]
                    },
                    {
                        label: "Used",
                        subheader: [{
                                label: "Total",
                                metric: "sum_capacity_used"
                            }, {
                                label: "User",
                                metric: "user_capacity_used"
                            }, {
                                label: "Snapshot",
                                metric: "snapshot_capacity_used"
                            }, {
                                label: "Admin",
                                metric: "admin_capacity_used"
                            }]
                    },
                    {
                        label: "Free",
                        subheader: [{
                                label: "Total",
                                metric: "capacity_free"
                            }, {
                                label: "User",
                                metric: "user_capacity_free"
                            }, {
                                label: "Snapshot",
                                metric: "snapshot_capacity_free"
                            }, {
                                label: "Admin",
                                metric: "admin_capacity_free"
                            }]
                    },
                ], pools)
            ]
        });
        page.tabs.push({
            title: "Volume",
            content: [
                await PerformanceTable_1.PerformanceTable.createPerformanceTableFromTemplate("Volume", [
                    {
                        label: "Used",
                        subheader: [{
                                label: "User",
                                metric: "capacity_used"
                            }, {
                                label: "Snapshot",
                                metric: "snapshot_capacity_used"
                            }, {
                                label: "Total",
                                metric: "sum_capacity_used"
                            },
                        ]
                    },
                ], volumes)
            ]
        });
        page.tabs.push({
            title: "Disk",
            content: [
                await PerformanceTable_1.PerformanceTable.createPerformanceTableFromTemplate("Disk", [
                    {
                        label: "Data",
                        subheader: [{
                                label: "Total",
                                metric: "user_capacity_total"
                            }, {
                                label: "Used",
                                metric: "user_capacity_used"
                            }, {
                                label: "Used %",
                                metric: "user_capacity_used_percent",
                            }, {
                                label: "Available",
                                metric: "user_capacity_free"
                            }]
                    },
                    {
                        label: "Spare",
                        subheader: [{
                                label: "Total",
                                metric: "spare_capacity_total"
                            }, {
                                label: "Used",
                                metric: "spare_capacity_used"
                            }, {
                                label: "Used %",
                                metric: "spare_capacity_used_percent",
                            }, {
                                label: "Available",
                                metric: "spare_capacity_free"
                            }]
                    },
                ], disks)
            ]
        });
        return page;
    }
}
exports._3parCapacityPage = _3parCapacityPage;
class VspgCapacityPage extends Stor_1.StorCapacityPage {
    constructor() {
        super(...arguments);
        this.title = 'Capacity';
    }
    async getPage() {
        let tabs = [];
        let title = "Total";
        let page = await (new Stor_1.StorCapacityPage(this.itemId, this.request)).getPage();
        const pools_raw = await this.objectItemsRepository.query(`SELECT oi.label, ip.* from object_items oi inner join item_relations ir on oi.item_id = ir.child inner join item_properties ip on ip.item_id = oi.item_id where oi.subsystem = 'pool' and ir.parent = '${this.itemId}'`);
        let pools = {};
        if (pools_raw) {
            for (const element of pools_raw) {
                if (pools[element.item_id]) {
                    pools[element.item_id][element.property_name] = element.property_value;
                }
                else {
                    pools[element.item_id] = {
                        [element.property_name]: element.property_value
                    };
                }
            }
        }
        let driveTable = new Table_1.Table()
            .addHeader({ value: 'Location ID' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'RPM' })
            .addHeader({ value: 'Code' })
            .addHeader({ value: 'Parity Group' })
            .addHeader({ value: 'Capacity', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Usage' });
        const drives = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'disks' } });
        if (drives) {
            for (const items of drives) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    driveTable.addRow([
                        { order: 0, value: row.location_id },
                        { order: 1, value: row.type },
                        { order: 2, value: row.rpm },
                        { order: 3, value: row.code },
                        { order: 4, value: row.parity_group },
                        { order: 5, value: row.capacity_total },
                        { order: 6, value: row.usage }
                    ]);
                }
            }
        }
        page.tabs.push({
            title: 'Drive',
            content: [
                driveTable.generateBox()
            ]
        });
        let drive_type_Table = new Table_1.Table()
            .addHeader({ value: 'Drive Type' })
            .addHeader({ value: 'RPM' })
            .addHeader({ value: 'Drive Size', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Total', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Data', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Spare', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Free', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 });
        const drive_type = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'drive_type' } });
        if (drive_type) {
            for (const items of drive_type) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    drive_type_Table.addRow([
                        { order: 0, value: row.drive_type },
                        { order: 1, value: row.rpm },
                        { order: 2, value: row.drive_size_capacity_total },
                        { order: 3, value: row.capacity_total },
                        { order: 4, value: row.data },
                        { order: 5, value: row.spare },
                        { order: 6, value: row.free }
                    ]);
                }
            }
        }
        page.tabs.push({
            title: 'Drive Type',
            content: [
                drive_type_Table.generateBox()
            ]
        });
        let raid_group_Table = new Table_1.Table()
            .addHeader({ value: 'Parity Group' })
            .addHeader({ value: 'Drive Type' })
            .addHeader({ value: 'HW compression' })
            .addHeader({ value: 'RAID level' })
            .addHeader({ value: 'RAID type' })
            .addHeader({ value: 'Formatted Size', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0 })
            .addHeader({ value: 'Formatted Free', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0 })
            .addHeader({ value: 'Formatted Used', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0 })
            .addHeader({ value: 'Formatted Physical Size', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0 })
            .addHeader({ value: 'Formatted Physical Free', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0 })
            .addHeader({ value: 'Formatted Physical Used', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.tebi, decimal: 0 });
        const raid_group = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'raid_group' } });
        if (raid_group) {
            for (const items of raid_group) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    raid_group_Table.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: row.drive_type },
                        { order: 2, value: row.hw_compression },
                        { order: 3, value: row.raid_level },
                        { order: 4, value: row.raid_type },
                        { order: 5, value: row.capacity_total },
                        { order: 6, value: row.capacity_free },
                        { order: 7, value: row.capacity_used },
                        { order: 8, value: row.physical_capacity_total },
                        { order: 9, value: row.physical_capacity_free },
                        { order: 10, value: row.physical_capacity_used },
                    ]);
                }
            }
        }
        page.tabs.push({
            title: 'Parity Group',
            content: [
                raid_group_Table.generateBox()
            ]
        });
        let pool_volume_Table = new Table_1.Table()
            .addHeader({ value: 'LDEV' })
            .addHeader({ value: 'Label' })
            .addHeader({ value: 'Atributtes' })
            .addHeader({ value: 'Size', number: true, unit: subsystemMetricsResponse_constants_1.UNIT.bytes, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Pool' })
            .addHeader({ value: 'Drive Type ID' })
            .addHeader({ value: 'RAID Level' })
            .addHeader({ value: 'RAID Type' })
            .addHeader({ value: 'Parity Groups' });
        const pool_volume = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'pool_volume' } });
        if (pool_volume) {
            for (const items of pool_volume) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    pool_volume_Table.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: row.label },
                        { order: 2, value: row.attributes },
                        { order: 3, value: row.capacity_total },
                        { order: 4, value: row.pool },
                        { order: 5, value: row.drive_type },
                        { order: 6, value: row.raid_level },
                        { order: 7, value: row.raid_type },
                        { order: 8, value: row.raid_groups },
                    ]);
                }
            }
        }
        page.tabs.push({
            title: 'Pool Volume',
            content: [
                pool_volume_Table.generateBox()
            ]
        });
        const pool_ids_object = {};
        for (const pool of pools_raw) {
            pool_ids_object[pool.item_id] = pool.item_id;
        }
        page.tabs.push({
            title: 'Pool',
            content: [
                await new CapacityTableBuilder_1.CapacityTableBuilder("pool", this.request)
                    .setItemLabel("Pool Name")
                    .addItems(pools_raw.map(p => p.item_id))
                    .addCustomHeader({ label: "Pool ID", valuesByItemId: pool_ids_object })
                    .addMetric("capacity_total", "Size")
                    .addMetric("capacity_free", "Free")
                    .addMetric("capacity_used", "Used")
                    .addMetric("format_data_capacity_used", "Data")
                    .addMetric("format_snap_capacity_used", "Snap")
                    .addMetric("capacity_used_percent", "Used")
                    .addMetric("physical_capacity_total", "Phy Size")
                    .addMetric("physical_capacity_free", "Phy Free")
                    .addMetric("physical_capacity_used", "Phy Used")
                    .addMetric("physical_capacity_used_percent", "Phy Used")
                    .generateBox()
            ]
        });
        let pool_effectivity_Table = new Table_1.Table()
            .addHeader({ value: 'Pool Name' })
            .addHeader({ value: 'Total', number: true })
            .addHeader({ value: 'Snapshot', number: true })
            .addHeader({ value: 'Compression', number: true })
            .addHeader({ value: 'Accelerated Compression Total', number: true })
            .addHeader({ value: 'Accelerated Compression', number: true })
            .addHeader({ value: 'Accelerated Compression Reclaim', number: true })
            .addHeader({ value: 'Dedupe & Compression Total', number: true })
            .addHeader({ value: 'Dedupe & Compression Dedupe', number: true })
            .addHeader({ value: 'Dedupe & Compression Compress', number: true })
            .addHeader({ value: 'Dedupe & Compression Reclaim', number: true });
        if (pools) {
            for (const items of Object.keys(pools)) {
                if (pools[items].id == -1) {
                    continue;
                }
                pool_effectivity_Table.addRow([
                    { order: 0, value: pools[items].label },
                    { order: 2, value: pools[items].total_ratio },
                    { order: 3, value: pools[items].snapshot_ratio },
                    { order: 4, value: pools[items].compression_ratio },
                    { order: 5, value: pools[items].accelerated_compression_total_ratio },
                    { order: 6, value: pools[items].accelerated_compression_ratio },
                    { order: 7, value: pools[items].accelerated_compression_reclaim_ratio },
                    { order: 8, value: pools[items].dkc_total_ratio },
                    { order: 9, value: pools[items].dkc_dedupe_saving_ratio },
                    { order: 10, value: pools[items].dkc_compression_saving_ratio },
                    { order: 11, value: pools[items].dkc_zpr_saving_ratio },
                ]);
            }
        }
        page.tabs.push({
            title: 'Efficiency',
            content: [
                pool_effectivity_Table.generateBox()
            ]
        });
        let hdp_volume_Table = new CapacityTable_1.CapacityTable()
            .addHeader({ value: 'LDEV' })
            .addHeader({ value: 'Label' })
            .addHeader({ value: 'Pool' })
            .addHeader({ value: 'Snap Pool' })
            .addHeader({ value: 'Size', number: true, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Free', number: true, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Data Used', number: true, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Data Used', number: true, thermometer: true })
            .addHeader({ value: 'Snap Used', number: true, prefix: pageResponse_constants_1.UNIT_PREFIX.gibi, decimal: 0 })
            .addHeader({ value: 'Atributtes' })
            .addHeader({ value: 'Copy of' });
        const hdp_volume = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'hdp_volume' } });
        if (hdp_volume) {
            for (const items of hdp_volume) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hdp_volume_Table.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: row.label },
                        { order: 2, value: row.pool },
                        { order: 3, value: row.snap_pool },
                        { order: 4, value: row.capacity_total },
                        { order: 5, value: row.capacity_free },
                        { order: 6, value: row.capacity_used },
                        { order: 7, value: row.capacity_used_percent },
                        { order: 8, value: row.snapshot_capacity_used },
                        { order: 9, value: row.attributes },
                        { order: 10, value: row.copy_of },
                    ]);
                }
            }
        }
        page.tabs.push({
            title: 'DP Volume',
            content: [
                hdp_volume_Table.generateBox()
            ]
        });
        return page;
    }
}
exports.VspgCapacityPage = VspgCapacityPage;
class OceanstorHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'ID Event' })
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'Description' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.event },
                        { order: 1, value: new Date(row.time * 1000) },
                        { order: 2, value: row.name },
                        { order: 3, value: row.type },
                        { order: 4, value: row.level },
                        { order: 5, value: row.description }
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' }
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OceanstorHealthstatusPage = OceanstorHealthstatusPage;
class OceanstornasHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'ID Event' })
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Type' })
            .addHeader({ value: 'Level' })
            .addHeader({ value: 'Description' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.event },
                        { order: 1, value: new Date(row.time * 1000) },
                        { order: 2, value: row.name },
                        { order: 3, value: row.type },
                        { order: 4, value: row.level },
                        { order: 5, value: row.description }
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' }
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OceanstornasHealthstatusPage = OceanstornasHealthstatusPage;
class OceanstorpacificHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'ID Alarm' })
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Object type' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'Suggestion' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.event },
                        { order: 1, value: new Date(row.time * 1000) },
                        { order: 2, value: row.name },
                        { order: 3, value: row.type },
                        { order: 4, value: row.severity },
                        { order: 5, value: row.description },
                        { order: 6, value: row.suggestion }
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' }
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OceanstorpacificHealthstatusPage = OceanstorpacificHealthstatusPage;
class OceanstorpacificnasHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'ID Alarm' })
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'Name' })
            .addHeader({ value: 'Object type' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'Suggestion' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.event },
                        { order: 1, value: new Date(row.time * 1000) },
                        { order: 2, value: row.name },
                        { order: 3, value: row.type },
                        { order: 4, value: row.severity },
                        { order: 5, value: row.description },
                        { order: 6, value: row.suggestion }
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' },
                { order: 6, value: '' }
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                healthStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.OceanstorpacificnasHealthstatusPage = OceanstorpacificnasHealthstatusPage;
class CompellentCapacityPage extends Stor_1.StorCapacityPage {
    constructor() {
        super(...arguments);
        this.title = 'Capacity';
    }
    async getPage() {
        let tabs = [];
        const user = await User_1.User.getUserByRequest(this.request);
        const timezone = user ? user.timezone : 'Etc/UTC';
        const pools = await this.objectItemsRepository.find({
            relations: {
                parents: true
            },
            where: {
                subsystem: 'pool',
                parents: {
                    parent: this.itemId
                }
            }
        });
        const poolsIds = pools.map((pool) => pool.item_id);
        tabs.push({
            title: 'Pool Capacity',
            content: await new CapacityTableBuilder_1.CapacityTableBuilder("pool", this.request)
                .setItemLabel("Pool")
                .addItems(poolsIds)
                .addDefaultMetrics()
                .addMetric("unused_capacity_total", "Unused")
                .addMetric("spare_capacity_total", "Spare")
                .addPrediction()
                .addUsed()
                .addTotal()
                .generateContentWithPredictions(),
        });
        let page = new pageResponse_dto_1.Page(this.title, tabs);
        return page;
    }
}
exports.CompellentCapacityPage = CompellentCapacityPage;
class UnityHealthstatusPage extends Menu_1.StorHealthstatusPage {
    async getPage() {
        let title = 'Health Status';
        let tabs = [];
        const deviceText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Device"
        };
        let healthStatusBox = await (new HealthStatus_1.HealthStatus()).getStatusByIds([this.itemId], 'Device');
        const driveText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Drive"
        };
        let driveStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['drive']);
        const ethportText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "ETH port"
        };
        let ethportStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['ethport']);
        const fcportText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "FC port"
        };
        let fcportStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['fcport']);
        const isciportText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "ISCI port"
        };
        let isciportStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['isciport']);
        const filesystemText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Filesystem"
        };
        let filesystemStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['fs']);
        const hostText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Host"
        };
        let hostStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['host']);
        const nasText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "NAS"
        };
        let nasStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['nas']);
        const nodeText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Node"
        };
        let nodeStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['node']);
        const poolText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Pool"
        };
        let poolStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['pool']);
        const volumeText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Volume"
        };
        let volumeStatusBox = await (new HealthStatus_1.HealthStatus()).getDeviceSubsystems(this.itemId, ['volume']);
        const itemProperties = await this.itemPropertiesRepository.find({ where: { item_id: this.itemId, property_name: 'events' } });
        const alertsText = {
            type: pageResponse_constants_1.BOX_TYPE.TextBox,
            styleClass: pageResponse_constants_1.TEXT_STYLE_CLASS.h2,
            text: "Events"
        };
        let hsTable = new Table_1.Table()
            .addHeader({ value: 'ID' })
            .addHeader({ value: 'Date' })
            .addHeader({ value: 'Message' })
            .addHeader({ value: 'Severity' })
            .addHeader({ value: 'Description' })
            .addHeader({ value: 'Acknowledged' });
        if (itemProperties) {
            for (const items of itemProperties) {
                const data = (JSON.parse(items.property_value));
                for (const row of data) {
                    hsTable.addRow([
                        { order: 0, value: row.id },
                        { order: 1, value: new Date(row.time * 1000) },
                        { order: 2, value: row.message },
                        { order: 3, value: row.severity },
                        { order: 4, value: row.description },
                        { order: 5, value: row.acknowledged }
                    ]);
                }
            }
        }
        else {
            hsTable.addRow([
                { order: 0, value: '' },
                { order: 1, value: '' },
                { order: 2, value: '' },
                { order: 3, value: '' },
                { order: 4, value: '' },
                { order: 5, value: '' }
            ]);
        }
        tabs.push({
            title: 'Health Status',
            content: [
                deviceText,
                healthStatusBox,
                nodeText,
                nodeStatusBox,
                poolText,
                poolStatusBox,
                volumeText,
                volumeStatusBox,
                driveText,
                driveStatusBox,
                fcportText,
                fcportStatusBox,
                ethportText,
                ethportStatusBox,
                isciportText,
                isciportStatusBox,
                hostText,
                hostStatusBox,
                nasText,
                nasStatusBox,
                filesystemText,
                filesystemStatusBox,
                alertsText,
                hsTable.generateBox()
            ],
        });
        this.page = new pageResponse_dto_1.Page(title, tabs);
        return this.page;
    }
}
exports.UnityHealthstatusPage = UnityHealthstatusPage;
//# sourceMappingURL=StorageCustomPages.js.map