import { MenuItem } from '@xormon/common/menuResponse.dto';
import { ChartType, Page } from '@xormon/common/pageResponse.dto';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
export declare class TimescaledbFolder {
    hwType: string;
    children?: Array<MenuItem>;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
}
export declare class TimescaledbRootFolder extends TimescaledbFolder {
    getChildren(): Promise<any[]>;
}
export declare class TimescaledbPage {
    hwType: string;
    page: Page;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPath(): Promise<any[]>;
}
export declare abstract class TimescaledbSingleItemPage extends TimescaledbPage {
    subsystem: string;
    itemId: string;
    constructor(itemId: string);
    getPath(): Promise<any[]>;
}
export declare class TimescaledbHwtypePage extends TimescaledbSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class TimescaledbSelfmonitoringPage extends TimescaledbSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
    getPath(): Promise<any[]>;
}
export declare class TimescaledbMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: import("@xormon/common/pageResponse.dto").MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
