import { TopInterval } from '@xormon/common/exporter.dto';
import { Tab } from '@xormon/common/pageResponse.dto';
import { TopOrderByField } from '@xormon/common/reportItem.dto';
import { HwTypeKey } from '@xormon/common/constants/hwTypeKey.constants';
import { MetricItem } from '@xormon/service/metrics/Metric';
import { Request } from 'express';
interface TopExport {
    item_id: string;
    label: string;
    max: number;
    avg: number;
}
interface TopIntervals {
    [key: string]: TopMetrics;
}
interface TopMetrics {
    [key: string]: MetricItem;
}
interface TopIntervalDefinition {
    key: string;
    label: string;
    interval: number;
    bucket: Bucket;
}
export type Bucket = '5m' | '1h' | '6h' | '1d';
export declare class Top {
    private hwType;
    private subsystem;
    private subsystemKey;
    private parentSubsystem;
    private parentSubsystemKey;
    private itemIds;
    private items;
    private metrics;
    private interval;
    private request;
    private lastUpdateAt;
    private mapped;
    private mappedParents;
    private objectItemsRepository;
    private topRepository;
    static intervals: TopIntervalDefinition[];
    constructor();
    loadSubsystems(): Promise<void>;
    setSubsystem(hwType: string, subsystemKey: string): void;
    setParentSubsystem(parentSubsystem: string): void;
    setMetrics(metrics: string[]): void;
    setInterval(interval: TopInterval): void;
    setItemIds(itemIds: string[]): void;
    setAcl(request: Request): void;
    setMapped(): void;
    private getItems;
    private loadItems;
    private isOld;
    getValues(): Promise<TopIntervals>;
    genTabs(): Promise<Tab[]>;
    private genTable;
    static exportTopData(hwType: HwTypeKey, subsystem: string, metric: string, interval: TopInterval): Promise<TopExport[]>;
    static exportTopDataByItemIds(itemIds: string[], metric: string, interval: TopInterval, orderBy?: TopOrderByField): Promise<TopExport[]>;
    static exportTopDataByRegex(regex: string[], hwType: string, subsystem: string, metric: string, interval: TopInterval, orderBy?: TopOrderByField): Promise<TopExport[]>;
}
export {};
