import { MenuItem } from '@xormon/common/menuResponse.dto';
import { ChartType, MetricAggregate, Page } from '@xormon/common/pageResponse.dto';
import { ItemProperty } from '@xormon/entity/itemProperty.entity';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Request } from 'express';
export declare class VmwareFolder {
    hwType: string;
    children?: Array<MenuItem>;
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    getPathFolder(parentIds: string[]): Promise<Array<MenuItem>>;
    getChildren(): Promise<Array<MenuItem>>;
}
export declare class VmwarePage {
    itemId: string;
    request: Request;
    hwType: string;
    page: Page;
    withItemId: boolean;
    otherParents: boolean;
    constructor(itemId: string, request: Request);
    objectItemsRepository: import("typeorm").Repository<ObjectItem>;
    itemRelationsRepository: import("typeorm").Repository<ItemRelation>;
    itemPropertiesRepository: import("typeorm").Repository<ItemProperty>;
    getPath(): Promise<MenuItem[]>;
}
export declare class VmwareSubsystemFolder extends VmwareFolder {
    subsystem: string;
    itemId: string;
    constructor(itemId?: string);
}
export declare abstract class VmwareSingleItemPage extends VmwarePage {
    subsystem: string;
}
export declare class VmwareRootFolder extends VmwareFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class VmwareVcenterFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class VmwareClusterFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class VmwareEsxiFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class VmwareEsxiitemFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class VmwareVmFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class VmwareVmfolderFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
    getChildrenAcl(): Promise<any[]>;
}
export declare class VmwareDatacenterFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class VmwareDsfolderFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class VmwareResourcepoolFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class VmwareRpfolderFolder extends VmwareSubsystemFolder {
    getChildren(): Promise<any[]>;
}
export declare class VmwareVmPage extends VmwareSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class VmwareDatastorePage extends VmwareSingleItemPage {
    subsystem: string;
    getPage(): Promise<Page>;
}
export declare class VmwareEsxiPage extends VmwareSingleItemPage {
    subsystem: string;
    withItemId: boolean;
}
export declare class VmwareEsxicpuPage extends VmwareEsxiPage {
    getPage(): Promise<Page>;
}
export declare class VmwareEsximemoryPage extends VmwareEsxiPage {
    getPage(): Promise<Page>;
}
export declare class VmwareEsxidiskPage extends VmwareEsxiPage {
    getPage(): Promise<Page>;
}
export declare class VmwareEsxilanPage extends VmwareEsxiPage {
    getPage(): Promise<Page>;
}
export declare class VmwareEsxiviewPage extends VmwareEsxiPage {
    getPage(): Promise<Page>;
}
export declare class VmwareResourcepoolPage extends VmwareSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class VmwareVcentertotalsPage extends VmwareSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class VmwareClustertotalsPage extends VmwareSingleItemPage {
    subsystem: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class VmwareMetrics {
    static Metric: {
        new (subsystem: string, metric: string): {
            getGraph(type: ChartType, stacked?: boolean, order?: number, color?: string): any;
            getAggrGraph(type: ChartType, stacked?: boolean, order?: number, aggregate?: MetricAggregate): any;
            type: ChartType;
            stacked: boolean;
            metric: string;
            order: number;
            aggregate?: MetricAggregate;
            unit: import("../../../common/subsystemMetricsResponse.dto").Unit;
            unitLabel?: string;
            shortcut: string;
            label?: string;
            color?: string;
            defaultPrefix?: import("@xormon/common/pageResponse.dto").UnitPrefix;
            defaultPrecision?: number;
            minY?: number;
            legendTop?: boolean;
            legendOnly?: boolean;
        };
    };
}
export declare class VmwareVmtopPage extends VmwarePage {
    title: string;
    withItemId: boolean;
    getPage(): Promise<Page>;
}
export declare class VmwareVcentertopPage extends VmwarePage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class VmwareDatastoretopPage extends VmwarePage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class VmwareOverviewPage extends VmwarePage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class VmwareHeatmapPage extends VmwarePage {
    title: string;
    getPage(): Promise<Page>;
}
export declare class VmwareConfigurationPage extends VmwarePage {
    title: string;
    getPage(): Promise<Page>;
}
