"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessagesGateway = void 0;
const event_emitter_1 = require("@nestjs/event-emitter");
const websockets_1 = require("@nestjs/websockets");
const websocketMessage_dto_1 = require("../../common/websocketMessage.dto");
const ws_1 = require("ws");
let MessagesGateway = class MessagesGateway {
    constructor() {
        this.wsClients = [];
    }
    afterInit() {
    }
    handleWebsocketMessageEvent(payload) {
        this.broadcast(payload.event, payload.message);
    }
    handleConnection(client) {
        this.wsClients.push(client);
    }
    handleDisconnect(client) {
        for (let i = 0; i < this.wsClients.length; i++) {
            if (this.wsClients[i] === client) {
                this.wsClients.splice(i, 1);
                break;
            }
        }
    }
    broadcast(event, message) {
        const broadCastMessage = JSON.stringify(message);
        for (let c of this.wsClients) {
            c.send(broadCastMessage);
        }
    }
    handleEvent(data) {
        const event = 'events';
        return { event, data };
    }
};
exports.MessagesGateway = MessagesGateway;
__decorate([
    (0, websockets_1.WebSocketServer)(),
    __metadata("design:type", typeof (_a = typeof ws_1.Server !== "undefined" && ws_1.Server) === "function" ? _a : Object)
], MessagesGateway.prototype, "server", void 0);
__decorate([
    (0, event_emitter_1.OnEvent)('message.created'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [websocketMessage_dto_1.WebsocketMessage]),
    __metadata("design:returntype", void 0)
], MessagesGateway.prototype, "handleWebsocketMessageEvent", null);
__decorate([
    (0, websockets_1.SubscribeMessage)('events'),
    __param(0, (0, websockets_1.MessageBody)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], MessagesGateway.prototype, "handleEvent", null);
exports.MessagesGateway = MessagesGateway = __decorate([
    (0, websockets_1.WebSocketGateway)({ path: '/websocket' })
], MessagesGateway);
//# sourceMappingURL=messages.gateway.js.map