import { HttpStatus } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { BackendServiceResponseDTO, BackendServicesResponseDTO } from '@xormon/common/backendResponse.dto';
import { BasicResponseDTO } from '@xormon/common/basicResponse.dto';
import { MicroserviceJobsResponseDTO } from '@xormon/common/microserviceJob.dto';
import { MicroserviceRequestDTO } from '@xormon/common/microserviceRequest.dto';
import { MicroserviceJobIntervalDTO } from '@xormon/common/microserviceJobInterval.dto';
import { MicroserviceChangeStateResponseDTO, MicroserviceResponseDTO } from '@xormon/common/microserviceResponse.dto';
import { Response } from 'express';
import { MicroserviceJobIntervalService } from './microserviceJobInterval.service';
import { MicroservicesService } from './microservices.service';
import { MicroserviceDataDTO } from '@xormon/common/microserviceData.dto';
import { MicroserviceDataService } from './microserviceData.service';
import { Request } from 'express';
export declare class MicroservicesController {
    private readonly microservicesService;
    private configService;
    private microserviceJobsIntervalService;
    private readonly microserviceData;
    constructor(microservicesService: MicroservicesService, configService: ConfigService, microserviceJobsIntervalService: MicroserviceJobIntervalService, microserviceData: MicroserviceDataService);
    listMicroservices(): Promise<BackendServicesResponseDTO>;
    registerMicroservice(microservice: MicroserviceRequestDTO): Promise<BasicResponseDTO>;
    deleteMicroservice(res: Response, microservice: string): Promise<BasicResponseDTO>;
    describeMicroservice(microservice: string): Promise<BackendServiceResponseDTO>;
    getMicroserviceData(microservice: string, hostcfg_id: string): Promise<BasicResponseDTO>;
    storeMicroserviceData(microservice: string, data: MicroserviceDataDTO): Promise<BasicResponseDTO>;
    microserviceJobs(microservice: string): Promise<{
        statusCode: HttpStatus;
        data: import("../../entity/microserviceJobs.entity").MicroserviceJob[];
    }>;
    microserviceJobsHistory(microservice: string): Promise<MicroserviceJobsResponseDTO>;
    resetMicroserviceJobInterval(microservice: string, job: string): Promise<{
        statusCode: HttpStatus;
        message: string;
    }>;
    updateMicroserviceJobInterval(microserviceJobIntervalDTO: MicroserviceJobIntervalDTO, microservice: string, job: string): Promise<{
        statusCode: HttpStatus;
        message: string;
    }>;
    startMicroservice(request: Request, microservice: string): Promise<MicroserviceChangeStateResponseDTO>;
    stopMicroservice(request: Request, microservice: string): Promise<MicroserviceChangeStateResponseDTO>;
    restartMicroservice(res: Response, microservice: string): Promise<BasicResponseDTO>;
    testkMicroservice(microservice: string, data: any, hostcfg_id?: number): Promise<MicroserviceResponseDTO>;
    taskMicroservice(microservice: string, task: string, data: JSON, hostcfg_id?: number): Promise<MicroserviceResponseDTO>;
}
