import { User as UserEntity } from "@xormon/entity/user.entity";
import { UserApiKey } from "@xormon/entity/userApiKey.entity";
import { Request } from 'express';
export declare class ApiKey {
    static authAndGenerate(username: string, password: string): Promise<{
        user_id: number;
        api_key: string;
        expiration: string;
    } & UserApiKey>;
    static generateApiKey(user_id: number, expiration: number, label: string, temporary?: boolean): Promise<{
        user_id: number;
        label: string;
        api_key: string;
        expiration: string;
        isTemporary: boolean;
    } & UserApiKey>;
    static getUserByRequest(request: Request, withGroups?: boolean): Promise<UserEntity>;
    static getUserByApiKey(apiKey: string, withGroups?: boolean): Promise<UserEntity>;
    static check(apiKey: string): Promise<boolean>;
    static getRanHex(size?: number): string;
}
