import { ClassesResponseDTO, HwTypesResponseDTO, ItemsResponseDTO, ItemsSearchResponseDTO, MetricsResponseDTO, PropsResponseDTO, SubsystemsResponseDTO } from '@xormon/common/architecture.dto';
import { ArchitectureService } from '@xormon/service/architecture/architecture.service';
import { Request } from 'express';
export declare class ArchitecturePublicController {
    private readonly architectureService;
    constructor(architectureService: ArchitectureService);
    getDevices(request: Request): Promise<ItemsResponseDTO>;
    getClasses(): Promise<ClassesResponseDTO>;
    getClassHwTypes(_class: string, list_models?: boolean): Promise<HwTypesResponseDTO>;
    getHwTypeSubsystems(_class: string, hwType: string): Promise<SubsystemsResponseDTO>;
    getHwTypeSubsystemMetrics(_class: string, hwType: string, subsystem: string): Promise<MetricsResponseDTO>;
    getHwTypeSubsystemProperties(_class: string, hwType: string, subsystem: string): PropsResponseDTO;
    itemsByHwTypeAndSubsystem(_class: string, hw_type: string, subsystem: string): Promise<ItemsResponseDTO>;
    search(request: Request, subsystem?: string, hw_type?: string, _class?: string, parents?: string[], search?: string, page?: number, limit?: number): Promise<ItemsSearchResponseDTO>;
}
