"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthStatusPublicController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const healthStatus_entity_1 = require("../../../entity/healthStatus.entity");
const healthStatus_interceptor_1 = require("../../../interceptor/healthStatus.interceptor");
const healthStatus_service_1 = require("../../health_status/healthStatus.service");
let HealthStatusPublicController = class HealthStatusPublicController {
    constructor(healthStatusService) {
        this.healthStatusService = healthStatusService;
    }
    async getHealthStatus() {
        let hostcfgs = await this.healthStatusService.getHostsCfg(undefined);
        let hsSever = [];
        let healthStatusHostCfg = (await this.healthStatusService.getDeviceHS(hostcfgs, undefined)).filter(hscfg => hscfg.status);
        let nStatus = { ...healthStatus_entity_1.Status };
        nStatus["IGNORED"] = [];
        for (const health of healthStatusHostCfg) {
            let upperStatus = health.status.toString().toUpperCase();
            if (health.ignored) {
                upperStatus = "IGNORED";
            }
            if (upperStatus in nStatus) {
                if (!Array.isArray(nStatus[upperStatus])) {
                    nStatus[upperStatus] = [];
                }
                nStatus[upperStatus].push(health);
            }
        }
        for (const stat in nStatus) {
            let cleanArray = [];
            if (!Array.isArray(nStatus[stat])) {
                nStatus[stat] = cleanArray;
            }
            cleanArray = nStatus[stat].sort((a, b) => (a.updatedAt > b.updatedAt ? -1 : 1));
            hsSever.push({ status: stat, count: cleanArray.length, devices: cleanArray });
        }
        return {
            statusCode: common_1.HttpStatus.OK,
            data: hsSever,
        };
    }
    async getHealthStatusSpecificSeverity(severity) {
        severity = severity.toUpperCase();
        let ignored = undefined;
        if (severity === "IGNORED") {
            ignored = true;
        }
        let hostcfgs = await this.healthStatusService.getHostsCfg(ignored);
        let hsSever = [];
        let healthStatusHostCfg = (await this.healthStatusService.getDeviceHS(hostcfgs, ignored === undefined ? healthStatus_entity_1.Status[severity] : undefined)).filter(hscfg => hscfg.status);
        let nStatus = [];
        for (const health of healthStatusHostCfg) {
            let upperStatus = health.status.toString().toUpperCase();
            if (health.ignored) {
                upperStatus = "IGNORED";
            }
            if (upperStatus === severity) {
                nStatus.push(health);
            }
        }
        nStatus = nStatus.sort((a, b) => (a.updatedAt > b.updatedAt ? -1 : 1));
        hsSever.push({ status: severity, count: nStatus.length, devices: nStatus });
        return {
            statusCode: common_1.HttpStatus.OK,
            data: hsSever,
        };
    }
};
exports.HealthStatusPublicController = HealthStatusPublicController;
__decorate([
    (0, common_1.Get)('/'),
    (0, common_1.UseInterceptors)(healthStatus_interceptor_1.HealthStatusInterceptor),
    openapi.ApiResponse({ status: 200, type: require("../../../common/healthStatus.dto").HealthStatusSeverityDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], HealthStatusPublicController.prototype, "getHealthStatus", null);
__decorate([
    (0, common_1.Get)('/:severity'),
    (0, common_1.UseInterceptors)(healthStatus_interceptor_1.HealthStatusInterceptor),
    openapi.ApiResponse({ status: 200, type: require("../../../common/healthStatus.dto").HealthStatusSeverityDTO }),
    __param(0, (0, common_1.Param)('severity')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], HealthStatusPublicController.prototype, "getHealthStatusSpecificSeverity", null);
exports.HealthStatusPublicController = HealthStatusPublicController = __decorate([
    (0, swagger_1.ApiTags)('PublicHealthStatus'),
    (0, common_1.Controller)('api/public/v1/health_status'),
    __metadata("design:paramtypes", [healthStatus_service_1.HealthStatusService])
], HealthStatusPublicController);
//# sourceMappingURL=healthStatus.public.controller.js.map