"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const publicApi_dto_1 = require("../../common/publicApi.dto");
const tokenRequest_dto_1 = require("../../common/tokenRequest.dto");
const joiValidation_pipe_1 = require("../../pipe/joiValidation.pipe");
const Joi = require("joi");
const ApiKey_1 = require("./ApiKey");
let PublicController = class PublicController {
    constructor() { }
    getEndpoints() {
        return {
            statusCode: common_1.HttpStatus.OK,
            data: []
        };
    }
    async generateApiKey(authRequest) {
        const apiKey = await ApiKey_1.ApiKey.authAndGenerate(authRequest.username, authRequest.password);
        if (apiKey) {
            return {
                statusCode: common_1.HttpStatus.OK,
                data: {
                    apiKey: apiKey.api_key,
                    expiration: apiKey.expiration
                }
            };
        }
    }
};
exports.PublicController = PublicController;
__decorate([
    openapi.ApiOperation({ description: "get all endpoints" }),
    (0, common_1.Get)('v1/'),
    openapi.ApiResponse({ status: 200, type: require("../../common/publicApi.dto").PublicEndpointsResponseDTO }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", publicApi_dto_1.PublicEndpointsResponseDTO)
], PublicController.prototype, "getEndpoints", null);
__decorate([
    openapi.ApiOperation({ description: "generate api key" }),
    (0, common_1.Post)('v1/auth'),
    (0, common_1.UsePipes)(new joiValidation_pipe_1.JoiValidationPipe(Joi.object({
        username: Joi.string().required(),
        password: Joi.string().required(),
    }))),
    openapi.ApiResponse({ status: 201, type: require("../../common/publicApi.dto").ApiKeyResponseDTO }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [tokenRequest_dto_1.TokenRequestDTO]),
    __metadata("design:returntype", Promise)
], PublicController.prototype, "generateApiKey", null);
exports.PublicController = PublicController = __decorate([
    (0, swagger_1.ApiTags)('Public'),
    (0, common_1.Controller)('api/public'),
    __metadata("design:paramtypes", [])
], PublicController);
//# sourceMappingURL=public.controller.js.map