import { Item } from "@xormon/common/architecture.dto";
import { TimeseriesItem } from "@xormon/common/timeseriesResponse.dto";
import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { IMetric } from "@xormon/service/metrics/Classes";
import { TimeDataPoint } from "./Vega";
export declare class GraphData {
    metricName: string;
    itemIds: string[];
    start: number;
    end: number;
    stacked: boolean;
    includeLegend: boolean;
    alertLimit?: number;
    width: number;
    height: number;
    format: 'svg' | 'png';
    timezone: string;
    graphTitle: string;
    private objectItems;
    private objectItemsById;
    private rawData;
    private interval;
    private metricSpecification?;
    private labelsById;
    private labels;
    private startsAndEnds;
    private rootParents;
    private metricItems;
    private timeserieItems;
    private timeDataPoints;
    private max;
    private min;
    alertingOptions: {
        legendTitle: string;
        limitText: string;
    };
    constructor(metricName: string, itemIds: string[], start: number, end: number, timezone: string);
    haveData(): boolean;
    haveObjectItemsLoaded(): boolean;
    haveNonEmptyObjectItems(): boolean;
    getObjectItems(): ObjectItem[];
    getFirstObjectItem(): ObjectItem;
    getMetricSpecification(): Partial<IMetric> | null;
    getLabels(): string[];
    getSortedLabels(singleItem?: {
        uuid: string;
        label: string;
    }): {
        uuid: string;
        label: string;
    }[];
    getTimeDataPoints(singleItem?: {
        uuid: string;
        label: string;
    }): TimeDataPoint[];
    getTimeserieItems(): TimeseriesItem[];
    getSpecificTimeserieItem(itemToFind: string): TimeseriesItem;
    getMax(): number;
    setObjectItems(objectItems: ObjectItem[]): void;
    setRootParents(itemsWithParents: Item[]): void;
    getRootParentLabel(itemId: string): string;
    fillAndProcessData(rawData: object, interval: number): Promise<void>;
    private setMetricSpecification;
    private calculateStartAndEndForItems;
    private makeTimeserieItems;
    private makeTimeDataPoints;
    private calculateMaxAndMin;
    private findSumMaxAndMin;
    private findItemsMaxAndMin;
}
