"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    longStringHandler: {
        pageWidth: 100,
    },
    graph: {
        format: 'svg',
        width: 520,
        height: 148,
        pngWidth: 920,
        pngHeight: 296,
    },
    graphSummary: {
        maxItems: 10,
        columns: 2,
        labelMaxLength: 25,
    },
    pdfMake: {
        docDefinition: {
            styles: {
                h1: {
                    fontSize: 24,
                    bold: true,
                    margin: [0, 10, 0, 5],
                },
                h2: {
                    fontSize: 20,
                    bold: true,
                    margin: [0, 10, 0, 5],
                },
                h3: {
                    fontSize: 16,
                    bold: true,
                    italics: true,
                    margin: [0, 5, 0, 2],
                },
                h4: {
                    fontSize: 12,
                    bold: true,
                    italics: true,
                    margin: [0, 2, 0, 1],
                },
                title: {
                    fontSize: 24,
                    bold: true,
                    marginBottom: 5,
                    fillColor: '#233f4d',
                    color: '#fff',
                    margin: [0, 0, 0, 0],
                },
                caption: {
                    bold: true,
                    fontSize: 12,
                    margin: [0, 20, 0, 5],
                },
                generatedAt: {},
                textItem: {
                    fontSize: 8,
                },
                tableHeader: {
                    color: '#000',
                    fillColor: '#F0F5F8',
                    hLineColor: () => '#A5A5A5',
                    vLineColor: () => '#A5A5A5',
                    bold: true,
                },
                tableItemLabel: {
                    bold: true,
                },
                tableItemValue: {},
                tableItemNoValue: {},
                graphSummaryItemLabel: {
                    bold: false,
                },
                graphMoreItemsNote: {
                    bold: false,
                    italics: true,
                },
                error: {
                    bold: true,
                    fontSize: 11,
                    color: 'black',
                    margin: [0, 10, 0, 5],
                },
            },
            defaultStyle: {
                fontSize: 8,
            },
            pageMargins: [40, 20, 40, 40],
        },
        tableLayouts: {
            standardTableLayout: {
                hLineWidth: () => 0.3,
                vLineWidth: () => 0.3,
                hLineColor: () => '#A5A5A5',
                vLineColor: () => '#A5A5A5',
            },
        },
        addPageNumberFooter: true,
        useFontDefinition: null,
        fontDefinitions: {
            standardFonts: {
                Courier: {
                    normal: 'Courier',
                    bold: 'Courier-Bold',
                    italics: 'Courier-Oblique',
                    bolditalics: 'Courier-BoldOblique',
                },
                Helvetica: {
                    normal: 'Helvetica',
                    bold: 'Helvetica-Bold',
                    italics: 'Helvetica-Oblique',
                    bolditalics: 'Helvetica-BoldOblique',
                },
                Times: {
                    normal: 'Times-Roman',
                    bold: 'Times-Bold',
                    italics: 'Times-Italic',
                    bolditalics: 'Times-BoldItalic',
                },
                Symbol: {
                    normal: 'Symbol',
                },
                ZapfDingbats: {
                    normal: 'ZapfDingbats',
                },
            },
        },
    },
};
//# sourceMappingURL=reporter.configuration.js.map