import { OnModuleInit, StreamableFile } from "@nestjs/common";
import { BasicResponseDTO } from "@xormon/common/basicResponse.dto";
import { GetReportResponseDTO, GetReportsResponseDTO, NewReport, PlainReport, SaveReportResponseDTO, UpdateReport } from "@xormon/common/report.dto";
import { GetReportFileResponseDTO } from "@xormon/common/reportFile.dto";
import { GetReportTemplatesResponseDTO, generateReportFromTemplateRequestDTO, generateReportFromTemplateResponseDTO } from "@xormon/common/reportTemplate.dto";
import { Request, Response } from 'express';
import { ReportTemplateService } from "./ReportTemplate.service";
import { ReporterService } from "./reporter.service";
export declare class ReporterController implements OnModuleInit {
    private readonly reporterService;
    private readonly reportTemplateService;
    constructor(reporterService: ReporterService, reportTemplateService: ReportTemplateService);
    onModuleInit(): Promise<any>;
    generateReportFromSchema(request: Request, res: Response, plainReport: PlainReport): Promise<StreamableFile>;
    reports(request: Request): Promise<GetReportsResponseDTO>;
    report(request: Request, report_id: string): Promise<GetReportResponseDTO>;
    generateReport(request: Request, res: Response, report_id: string): Promise<StreamableFile>;
    updateReport(request: Request, updateReport: UpdateReport, report_id?: string): Promise<SaveReportResponseDTO>;
    saveReport(request: Request, newReport: NewReport): Promise<SaveReportResponseDTO>;
    cloneReport(request: Request, report_id: string): Promise<SaveReportResponseDTO>;
    deleteReport(request: Request, report_id: string): Promise<BasicResponseDTO>;
    getReportFile(request: Request, report_file_id?: string): Promise<GetReportFileResponseDTO>;
    downloadReportFilePDF(request: Request, res: Response, report_file_id: string): Promise<StreamableFile>;
    deleteReportFile(request: Request, report_file_id?: string): Promise<BasicResponseDTO>;
    getReportTemplates(): Promise<GetReportTemplatesResponseDTO>;
    generateReportFromTemplate(request: Request, templateData: generateReportFromTemplateRequestDTO): Promise<generateReportFromTemplateResponseDTO>;
}
