import { Tag } from '@xormon/entity/tag.entity';
import { TagValue } from '@xormon/entity/tagValue.entity';
import { TagValueItem } from '@xormon/entity/tagValueItem.entity';
import { Repository } from 'typeorm';
export declare class TagService {
    private tagRepository;
    private tagValueRepository;
    private tagValueItemRepository;
    constructor(tagRepository: Repository<Tag>, tagValueRepository: Repository<TagValue>, tagValueItemRepository: Repository<TagValueItem>);
    listAllTags(): Promise<Tag[]>;
    listAllTagValues(): Promise<TagValue[]>;
    listAllTagValueItems(): Promise<TagValueItem[]>;
    listTagValuesByTagId(tag_id: string): Promise<TagValue[]>;
    listTagValueItemsByItem(item_id: string): Promise<TagValueItem[]>;
    findTagValuesByLabel(tag_label: string): Promise<TagValue[]>;
    findTagValueByLabel(tag_label: string, value: string): Promise<TagValue>;
    findTagValueById(tag_id: string, value: string): Promise<TagValue>;
    getItemsForTag(tag_label: string): Promise<import("../../common/architecture.dto").Item[]>;
    getItemsForTagValueId(tag_value_id: string): Promise<import("../../common/architecture.dto").Item[]>;
    getFilteredItemsForTagValueId(tag_value_id: string, hw_type: string, subsystem: string, class_name: string): Promise<any[]>;
    getItemsForTagId(tag_id: string): Promise<import("../../common/architecture.dto").Item[]>;
    listTagValueItemsByValueId(tag_value_id: string): Promise<TagValueItem[]>;
    deleteTagValueItems(item_ids: string[], tag_value_id: string): Promise<void>;
    saveTag(label: string, user_id: number, include_self?: boolean): Promise<Tag>;
    updateTag(oldLabelToUse: string, newLabelToUse: string, includeSelfToUse: boolean, user_id: number): Promise<import("typeorm").UpdateResult>;
    saveTagValue(value: string, tag_id: string, user_id: number): Promise<TagValue>;
    saveTagValueByName(value: string, tag_label: string, user_id: number): Promise<TagValue>;
    updateTagValueByName(old_value: string, new_value: string, label: string, user_id: number): Promise<import("typeorm").UpdateResult>;
    saveTagValueItems(item_ids: string[], tag_value_id: string): Promise<void>;
    updateTagValueItems(item_ids: string[], tag_value_id: string): Promise<void>;
    updateTagValueById(old_value: string, new_value: string, tag_id: string, user_id: number): Promise<import("typeorm").UpdateResult>;
    saveTagValueItem(item_id: string, tag_value_id: string): Promise<TagValueItem>;
    findTagByName(label: string): Promise<Tag>;
    findTagById(tag_id: string): Promise<Tag>;
    deleteTagByName(label: string): Promise<Tag>;
    deleteTagById(tag_id: string): Promise<Tag>;
    deleteTagValueByName(value: string, label: string): Promise<TagValue>;
    deleteTagValueById(value: string, tag_id: string): Promise<TagValue>;
    deleteTagValueItem(item_id: string, tag_value_id: string): Promise<TagValueItem>;
    deleteTagValuesById(tag_id: string): Promise<TagValue[]>;
    deleteTagValuesByLabel(tag_label: string): Promise<TagValue[]>;
    deleteTagValuesByItem(item_id: string): Promise<TagValueItem[]>;
}
