import { RegisterUserDTO, UpdateLoggedUserDTO, UpdateUserDTO } from '@xormon/common/usersResponse.dto';
import { User as UserEntity } from '@xormon/entity/user.entity';
import { Request } from 'express';
export declare class User {
    static bcrypt: any;
    static authByEmail(email: string, password: string): Promise<UserEntity>;
    static getUserById(userId: number, withGroups?: boolean): Promise<UserEntity>;
    static getUserByToken(token: string): Promise<UserEntity>;
    static getUserByRequest(req: Request, withGroups?: boolean): Promise<UserEntity>;
    static authByUsername(username: string, password: string): Promise<UserEntity>;
    static setLastLogged(user_id: any): Promise<void>;
    static register(user: RegisterUserDTO): Promise<UserEntity>;
    static update(user_id: number, update: Partial<UpdateUserDTO | UpdateLoggedUserDTO>, logged?: boolean): Promise<UserEntity>;
}
