import { OnApplicationShutdown } from '@nestjs/common';
import { AlertingHwEmail } from '@xormon/entity/alertingHwEmail.entity';
import { HealthStatus } from '@xormon/entity/healthStatus.entity';
import { HealthStatusHistory } from '@xormon/entity/healthStatusHistory.entity';
import { HostcfgStatus } from '@xormon/entity/hostcfgStatus.entity';
import { MailService } from '@xormon/mail/mail.service';
import { AlertHandler } from '@xormon/tasks-server/alert.handler';
import { Repository } from 'typeorm';
import { AlertingHistory } from '@xormon/entity/alertingHistory.entity';
export declare class AlertTask implements OnApplicationShutdown {
    private alertingHwEmailsRepository;
    private hostcfgstatusRepository;
    private healthStatusHistoryRepository;
    private healthStatusRepository;
    private alertingHistoryRepository;
    private mailService;
    private alertHandler;
    private logger;
    private winstonLogger;
    constructor(alertingHwEmailsRepository: Repository<AlertingHwEmail>, hostcfgstatusRepository: Repository<HostcfgStatus>, healthStatusHistoryRepository: Repository<HealthStatusHistory>, healthStatusRepository: Repository<HealthStatus>, alertingHistoryRepository: Repository<AlertingHistory>, mailService: MailService, alertHandler: AlertHandler);
    onApplicationShutdown(signal?: string): void;
    checkAlerts(): Promise<void[][]>;
    checkHwAlerts(): Promise<void>;
    closeDifferingHealthStatusHistory(): Promise<void>;
}
