import { ObjectItem } from "@xormon/entity/objectItem.entity";
import { TargetDestination } from "@xormon/entity/targetDestination.entity";
import { Top } from "@xormon/entity/top.entity";
import { HeatmapItem } from "@xormon/service/metrics/Classes";
import { Repository } from "typeorm";
import { TargetDestinationHostcfg } from "@xormon/entity/targetDestinationHostcfg.entity";
export type DestinationMap = {
    [key: string]: {
        destination: TargetDestination;
        items: HeatTop[];
    };
};
export type HeatTop = Partial<HeatmapItem | Top>;
export declare class DestinationSender {
    private destinationRepository;
    private destinationHostcfg;
    private type;
    private globalDestinations;
    private destinationMap;
    private globalItems;
    private hasLicense;
    private options;
    constructor(destinationRepository: Repository<TargetDestination>, destinationHostcfg: Repository<TargetDestinationHostcfg>, type: "heatmap" | "top");
    init(): Promise<void>;
    addItems(item: ObjectItem, hItem: HeatTop): void;
    private doRequest;
    sendBatch(): Promise<void>;
}
