import { OnApplicationShutdown } from '@nestjs/common';
import { HealthStatus } from '@xormon/entity/healthStatus.entity';
import { SettingsItem } from '@xormon/common/settings.dto';
import { Repository } from 'typeorm';
import { HealthStatusHistory } from '@xormon/entity/healthStatusHistory.entity';
import { HostcfgStatus } from '@xormon/entity/hostcfgStatus.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { AlertingHwEmail } from '@xormon/entity/alertingHwEmail.entity';
import { MailService } from '@xormon/mail/mail.service';
import { HwEventDeviceGroup } from '@xormon/entity/deviceGroupHwAlerting.entity';
import { SnmpHandler } from './snmp.handler';
import { ServiceNowHandler } from './serviceNow.handler';
export type HsCacheItems = (HostcfgStatus[] | ObjectItem[] | AlertingHwEmail[] | HealthStatusHistory[] | SettingsItem)[];
export declare function createItemLink(_class: string, hw_type: string, alias: string, item_id: string, settings: SettingsItem): string;
export declare class HealthStatusTask implements OnApplicationShutdown {
    private healthStatusRepository;
    private healthStatusHistoryRepository;
    private objectItemRepository;
    private deviceGroupRepository;
    private readonly snmpHandler;
    private readonly serviceNowHandler;
    private readonly mailService;
    private winstonLogger;
    constructor(healthStatusRepository: Repository<HealthStatus>, healthStatusHistoryRepository: Repository<HealthStatusHistory>, objectItemRepository: Repository<ObjectItem>, deviceGroupRepository: Repository<HwEventDeviceGroup>, snmpHandler: SnmpHandler, serviceNowHandler: ServiceNowHandler, mailService: MailService);
    onApplicationShutdown(signal?: string): void;
    sendReload(): void;
    healthStatusInsert(payload: HealthStatus[]): Promise<void>;
    getMail(item: ObjectItem, entity: HealthStatus, settings: SettingsItem): string[];
    reloadHsTaskCache(): Promise<void>;
    loadCacheItems(): Promise<HsCacheItems>;
    sendSnmp(settings: SettingsItem, header: string, message: string, item: ObjectItem, healthStatus: HealthStatus): Promise<void>;
    sendServicenow(settings: SettingsItem, header: string, message: string, item: ObjectItem, healthStatus: HealthStatus): Promise<void>;
    addMailsToItems(group: HwEventDeviceGroup, mapKey: string, map: {
        [key: string]: string[];
    }, mailMap: {
        [key: string]: Set<string>;
    }, snmpMap: {
        [key: string]: boolean;
    }, snMap: {
        [key: string]: boolean;
    }, snmp: boolean, servicenow: boolean): void;
}
