import { OnApplicationShutdown, OnModuleInit } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { ItemRelation } from '@xormon/entity/itemRelation.entity';
import { ObjectItem } from '@xormon/entity/objectItem.entity';
import { Repository } from 'typeorm';
export declare class MonitoringTask implements OnModuleInit, OnApplicationShutdown {
    private configService;
    private objectItemsRepository;
    private itemRelationsRepository;
    private namespace;
    private enabled;
    private winstonLogger;
    constructor(configService: ConfigService, objectItemsRepository: Repository<ObjectItem>, itemRelationsRepository: Repository<ItemRelation>);
    onApplicationShutdown(signal?: string): void;
    onModuleInit(): Promise<void>;
    monitoring(): Promise<void>;
    handlePerf(): Promise<void>;
    handleConf(): Promise<void>;
    getQueries(type: 'perf' | 'conf', database?: string | Uint8Array): {
        dbs: string;
        cluster: string;
        locks: string;
        sessions: string;
        wait_event: string;
    } | {
        main: string;
        relations: string;
    };
}
