import { OnApplicationShutdown } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { EventEmitter2 } from '@nestjs/event-emitter';
import { HostCfgDTO } from '@xormon/common/hostCfgResponse.dto';
import { HostCfg } from '@xormon/entity/hostcfg.entity';
import { Microservice as MicroserviceEntity } from '@xormon/entity/microservice.entity';
import { MicroserviceJob } from '@xormon/entity/microserviceJobs.entity';
import { MicroserviceJobStatus } from '@xormon/entity/microserviceJobsStatus.entity';
import { MicroserviceVariables } from '@xormon/entity/microserviceVariables.entity';
import { TargetDestination } from '@xormon/entity/targetDestination.entity';
import { TargetDestinationHostcfg } from '@xormon/entity/targetDestinationHostcfg.entity';
import { Repository } from 'typeorm';
type HostcfgWithDestinations = HostCfgDTO & {
    destinations?: {
        _target_destination: TargetDestination;
    }[];
};
interface HostCfgByHwType {
    [hwType: string]: HostcfgWithDestinations[];
}
export declare class MicroservicesTask implements OnApplicationShutdown {
    private configService;
    private microservicesRepository;
    private microservicesJobsRepository;
    private microservicesJobsStatusRepository;
    private hostcfgRepository;
    private targetDestinationRepository;
    private targetDestinationHostcfgRepository;
    private microserviceVariablesRepository;
    private eventEmitter;
    private offset;
    private winstonLogger;
    constructor(configService: ConfigService, microservicesRepository: Repository<MicroserviceEntity>, microservicesJobsRepository: Repository<MicroserviceJob>, microservicesJobsStatusRepository: Repository<MicroserviceJobStatus>, hostcfgRepository: Repository<HostCfg>, targetDestinationRepository: Repository<TargetDestination>, targetDestinationHostcfgRepository: Repository<TargetDestinationHostcfg>, microserviceVariablesRepository: Repository<MicroserviceVariables>, eventEmitter: EventEmitter2);
    onApplicationShutdown(signal?: string): void;
    handleInterval(): Promise<void>;
    getMicroservices(): Promise<MicroserviceEntity[]>;
    getMicroservicesJobs(microservice: any): Promise<MicroserviceJob[]>;
    getMicroservicesActiveJobs(microservice: any, job: any, identification: any): Promise<MicroserviceJobStatus[]>;
    getHostcfgByHwType(): Promise<HostCfgByHwType>;
    hostCfg(hw_type: string): Promise<HostCfg[]>;
}
export {};
