"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TasksModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const typeorm_1 = require("@nestjs/typeorm");
const alerting_entity_1 = require("../entity/alerting.entity");
const alertingGroup_entity_1 = require("../entity/alertingGroup.entity");
const alertingHwEmail_entity_1 = require("../entity/alertingHwEmail.entity");
const alertingLaunch_entity_1 = require("../entity/alertingLaunch.entity");
const backend_entity_1 = require("../entity/backend.entity");
const class_entity_1 = require("../entity/class.entity");
const customGroup_entity_1 = require("../entity/customGroup.entity");
const customGroupFolder_entity_1 = require("../entity/customGroupFolder.entity");
const export_entity_1 = require("../entity/export.entity");
const healthStatus_entity_1 = require("../entity/healthStatus.entity");
const healthStatusHistory_entity_1 = require("../entity/healthStatusHistory.entity");
const heatmap_entity_1 = require("../entity/heatmap.entity");
const heatmapTier_entity_1 = require("../entity/heatmapTier.entity");
const heatmapTierItem_entity_1 = require("../entity/heatmapTierItem.entity");
const hostcfg_entity_1 = require("../entity/hostcfg.entity");
const hwType_entity_1 = require("../entity/hwType.entity");
const itemProperty_entity_1 = require("../entity/itemProperty.entity");
const itemRelation_entity_1 = require("../entity/itemRelation.entity");
const microservice_entity_1 = require("../entity/microservice.entity");
const microserviceJobs_entity_1 = require("../entity/microserviceJobs.entity");
const microserviceJobsStatus_entity_1 = require("../entity/microserviceJobsStatus.entity");
const objectItem_entity_1 = require("../entity/objectItem.entity");
const report_entity_1 = require("../entity/report.entity");
const reportFile_entity_1 = require("../entity/reportFile.entity");
const subsystem_entity_1 = require("../entity/subsystem.entity");
const targetDestination_entity_1 = require("../entity/targetDestination.entity");
const targetDestinationHostcfg_entity_1 = require("../entity/targetDestinationHostcfg.entity");
const top_entity_1 = require("../entity/top.entity");
const mail_module_1 = require("../mail/mail.module");
const architecture_module_1 = require("../service/architecture/architecture.module");
const custom_group_module_1 = require("../service/custom_group/custom_group.module");
const backend_service_1 = require("./backend.service");
const microservices_service_1 = require("./microservices.service");
const microserviceVariables_entity_1 = require("../entity/microserviceVariables.entity");
const PM2_1 = require("../service/configuration/PM2");
const deviceGroupHwAlerting_entity_1 = require("../entity/deviceGroupHwAlerting.entity");
let providers = PM2_1.PM2.isRunning() && PM2_1.PM2.isMasterBackend ? [microservices_service_1.MicroservicesTask, backend_service_1.BackendTask] : [];
let TasksModule = class TasksModule {
};
exports.TasksModule = TasksModule;
exports.TasksModule = TasksModule = __decorate([
    (0, common_1.Module)({
        imports: [
            config_1.ConfigModule.forRoot({ isGlobal: true }),
            typeorm_1.TypeOrmModule.forFeature([
                hostcfg_entity_1.HostCfg,
                class_entity_1.Class,
                subsystem_entity_1.Subsystem,
                hwType_entity_1.HwType,
                microservice_entity_1.Microservice,
                backend_entity_1.Backend,
                objectItem_entity_1.ObjectItem,
                itemRelation_entity_1.ItemRelation,
                itemProperty_entity_1.ItemProperty,
                microserviceJobsStatus_entity_1.MicroserviceJobStatus,
                microserviceJobs_entity_1.MicroserviceJob,
                healthStatus_entity_1.HealthStatus,
                alerting_entity_1.Alerting,
                alertingLaunch_entity_1.AlertingLaunch,
                alertingGroup_entity_1.AlertingGroup,
                heatmap_entity_1.Heatmap,
                heatmapTier_entity_1.HeatmapTier,
                heatmapTierItem_entity_1.HeatmapTierItem,
                top_entity_1.Top,
                export_entity_1.Export,
                report_entity_1.Report,
                customGroup_entity_1.CustomGroup,
                customGroupFolder_entity_1.CustomGroupFolder,
                reportFile_entity_1.ReportFile,
                healthStatusHistory_entity_1.HealthStatusHistory,
                alertingHwEmail_entity_1.AlertingHwEmail,
                targetDestination_entity_1.TargetDestination,
                targetDestinationHostcfg_entity_1.TargetDestinationHostcfg,
                microserviceVariables_entity_1.MicroserviceVariables,
                deviceGroupHwAlerting_entity_1.HwEventDeviceGroup
            ]),
            mail_module_1.MailModule,
            architecture_module_1.ArchitectureModule,
            custom_group_module_1.CustomGroupModule
        ],
        providers: providers,
    })
], TasksModule);
//# sourceMappingURL=tasks.module.js.map