package CMC_COMMON;

use strict;
use warnings;

use Data::Dumper;


sub load_config {
  my $config = shift;

  my $host          = $config->{'host'};
  my $username      = $config->{'clientID'};
  my $password      = $config->{'secret'};

  my $proxy         = $config->{'proxyUrl'} || "";
  my $proxy_proto   = $config->{'protocol'} || "";

  my $proxy_url = "";

  if ( $proxy && $proxy_proto ) {
    $proxy_url = "${proxy_proto}://${proxy}";
  }

  return ($host, $username, $password, $proxy_url);
}

sub unique_id {
  # create id for cmc,
  # reason: all UUIDs on System/Partition level are the same as in HMC
  #         metrics are different
  my $console_uuid    = shift;
  my $section         = shift || "";
  my $section_item_id = shift || "";

  my $unique_id = "${console_uuid}";

  if ( $section && $section_item_id ){

    $unique_id .= ".${section}";
    $unique_id .= ".${section_item_id}";

  }

  return $unique_id;
}

sub use_api_data {
  my $loc_console_name = shift;

  my $production_state = 1;

  my ${loc_development_data_dir} = get_development_data_dir();
  my $testing_file = "$loc_development_data_dir/${loc_console_name}/CMC-${loc_console_name}-inventory_tags.json";

  if ( -f "$testing_file") {
    print "WARNING: DEVELOPMENT DATA MODE!! \n This should never happen in user environment! \n";
    $production_state = 0;
  }
  else {
    $production_state = 1;
  }

  print "PRODUCTION STATE [$loc_console_name]: $production_state \n";

  return $production_state;
}

sub get_development_data_dir {
  my ${development_data_dir} = "/home/lpar2rrd/lpar2rrd/data/PEP2";

  return $development_data_dir;
}

1;
