package SQLServer;

use strict;
use warnings;

use JSON;
use Data::Dumper;
use Digest::MD5 qw(md5 md5_hex md5_base64);
use lib "$FindBin::Bin/";

sub get_filepath_rrd_bpage {
  my $page = shift;
  my $server = shift;
  my $host = shift;
  my $type = get_type_from_page($page);
  get_filepath_rrd({type => $type, uuid => $server, id =>$host});
}

sub get_driver {
  my $odbc_inst   = "/etc/odbcinst.ini";
  my $mvc_dir     = $FindBin::Bin;
  my $driver_file = "$mvc_dir/sqlserver_driver.txt";
  my $_driver = "";
  if (-e $driver_file){
    open( FHR, "<" ,"$driver_file" );
    foreach my $line (<FHR>) {
      if ($line =~ /ODBC Driver .* for SQL Server|FreeTDS/){
        $_driver = "$line";
        close FHR;
        return $_driver;
      } 
    }
    close FHR;
    unlink($driver_file);
    return "err-incodriver";
  }elsif(-e $odbc_inst){
    open( FHR, "<", "$odbc_inst" );
    foreach my $line (<FHR>) {
      if ($line =~ /ODBC Driver .* for SQL Server|FreeTDS/){
        $line =~ s/\[/\{/g;
        $line =~ s/\]/\}/g;
        $_driver = "$line";

        unlink($driver_file);
        open my $fh, '>', $driver_file;
        print $fh $_driver;
        close $fh;
        close FHR;

        return $_driver;
      }
    }
    close FHR;
    return "err-driverne";
  }else{
    return "err-instne";   
  }
}

sub isdigit {
  my $digit = shift;

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;
  #$digit_work =~ s/\-//;

  if ( length($digit_work) == 0 ) {
    # is a number
    return 1;
  }

  return 0;
} ## end sub isdigit

sub basename {
  my $full      = shift;
  my $separator = shift;
  my $out = "";
  #my $length = length($full);
  if(defined $separator and defined $full and  index($full, $separator) != -1){
    $out = substr($full, length($full) - index(reverse($full), $separator), length($full));
    return $out;
  }
  return $full;
}

sub md5_string {
  my $data = shift;
  my $out = md5_hex($data);

  return $out;
}


1;